<?php
/*
module:	page_admin
Copyright Jean-Paul GIAUSSERAND 2009-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.4  06/07/11  Ajout Champs utilisateur paramtrable
	v1.3  28/07/11  Utilisation de certains paramtres de tinymce
	v1.2  26/02/11  Edition source skin + retour page appelante
	v1.1  06/08/10  Transformation page standard <-> panneau
	v1.0	27/12/09	Cration du module
*/
class Tpage_admin extends Tmodule {
	function dojob($opt="") {
		parent::dojob();
		require_once(self::$cms->zpath.'/outils.php');
		if (1==1){//($_SESSION['zite_admin']) {//transitoire
		//$pages = (array)unserialize(@file_get_contents($this->cpath.'/structure.dta'));//$this->BuildStruct();
		$max = count(self::$cms->struct);
		$webmaster = in_array('webmaster',$_SESSION['zite_usergroup']);
		$admin = in_array('admin',$_SESSION['zite_usergroup']);//			$admin = $_SESSION['zite_admin']==2;
		switch($opt) {
		  case 'page_editor' :
				$pageid =  (int)self::$cms->args[1];
				$pagedesc = & self::$cms->struct[$pageid];
				if (self::$cms->isPageAuth($pageid,cPageWrite)) {
					$r_in = array('<?', '<?php', '?'.'>', '<?=');
					$r_out = array('<!--?', '<!--?php', '?-->', '<!--?=');
					$file = self::$cms->cpath.'/'.$pagedesc[cPageIdent].'.txt';
					if (file_exists($file)) {
					  $out='';
						self::$cms->truepage = $pageid;
					  $_SESSION['truepage']=self::$cms->truepage;
						if (isset($_POST['abort'])) {
							header('Location: '.self::$cms->base.'admin#'.$pageid);
						} elseif (isset($_POST['mysubmit'])||!empty($_POST)) {  // pour enregistrer de tinymce
							$pagedesc[cPageTitre] = trim(htmlentities(stripslashes($_POST['title'])));
							if (empty($pagedesc[cPageTitre])) $pagedesc[cPageTitre] = self::$cms->get_message('page_default_title');
							$source = str_replace($r_out, $r_in, stripslashes($_POST['source']),$nbphp);
							if ($nbphp && ($pagedesc[cPageType]%2!=0)) {
								$pagedesc[cPageType] = ($pagedesc[cPageType]&~pgbitType)|(int)2;
							}
							$rslt = self::$cms->WriteStruct() && self::$cms->writefile($file, $source);
							$out .= $rslt ? self::$cms->get_message('done_ok') : self::$cms->get_message('done_failed');
							$out .= '<p class="zalert">'.$out.' - <a href="'.self::$cms->base.$pageid.'">'.self::$cms->get_message('view_page').'</a>'.'</p>';
						}
						$out .= '<form action="'.self::$cms->base.'page_editor|'.$pageid.'"  method="post">';
						$out .= $this->get_message('pg_titre') . ' <input name="title" type="text" value="'.$pagedesc[1].'" />';
						if ($pagedesc[cPageType]%2==0) $out.=' PHP ';
						$out.= ' <a href="'.self::$cms->base.'selectdoc" target="_blank"><img src="deco/godocs.png" title="'.$this->get_message('icone_selectdoc').'" align="absmiddle"  /></a>';
						$out .= ' <input name="save" type="hidden" value="1" /><input type="submit" name="mysubmit" value="'.self::$cms->get_message('submit').'" /> <input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /> './*'<a href="'.self::$cms->base.'admin#'.$pageid.'"> '.self::$cms->get_message('edit_admin').'</a>'.*/' <br />';
							// Chargement de l'diteur
						$edfile = self::$cms->zpath. '/'.self::$cms->get_data('editor').'.php';
						$content = file_get_contents($file);
						$content = htmlentities(str_replace($r_in, $r_out, $content));
						if (file_exists($edfile)) {
							// Editeur externe
							@ob_start();
							include($edfile);
							$out .= @ob_get_clean();
						} else {
							// Editeur brut
							$out .= '<textarea class="border" style="width:100%;height:500px;" name="source" id="source">'.$content.'</textarea>';
						}
						$out .= '</form>';
						return $out;
					} else {
						return self::$cms->get_message('errorNOFILE');
					}
				} else {
					return self::$cms->get_message('not_allowed');
				}
				break;
		  case 'source_editor' :
				if ($admin) {
					$pageid =  self::$cms->args[1];
					$istruepage=false;
						if (substr($pageid, 0, 5)=='files' && array_key_exists($pageid, self::$cms->config)) {
							$filename = self::$cms->get_data($pageid);
							$file = self::$cms->ipath.'/'.$filename;
						} elseif ($pageid=='skin') {
						  $filename = self::$cms->args[3];;
							$file = self::$cms->ipath.'/skin/'.self::$cms->args[2].'/'.$filename;
						} elseif (($pageid=='config.ini') || ($pageid=='messages.ini')) {
							$filename = $pageid;
							$file = self::$cms->cpath.'/'.$filename;
						} elseif ((int)$pageid && (int)$pageid<=count(self::$cms->struct)) {
							$filename = self::$cms->struct[(int)$pageid][1];
							$file = self::$cms->cpath.'/'.self::$cms->struct[(int)$pageid][0].'.txt';
							self::$cms->truepage = (int)$pageid;
							$istruepage=true;
						}
					  $_SESSION['truepage']=$istruepage?self::$cms->truepage:false;
						$out ='';
						if (file_exists($file)) {
							if (array_key_exists('source', $_POST)) {
								if (self::$cms->truepage==$pageid) {
									$oldname = self::$cms->struct[(int)$pageid][0];
									$newname = preg_replace('/[^A-z0-9_-]/','',$_POST['permaname']);
									if ($newname!=$oldname) {
										$newfile = self::$cms->cpath.'/'.$newname.'.txt';;
										if(file_exists($newfile)) {
											$out .= '<p class="zalert">'.self::$cms->get_message('permaname_duplicate').' ('.$newname.')'.'</p>';
										} else {
											$oldfile = self::$cms->cpath.'/'.$oldname.'.txt';
											$file = $newfile;
											unlink($oldfile);
											self::$cms->struct[(int)$pageid][0] = $newname;
										self::$cms->writeStruct();
										}
									}
								}
								$tmp= self::$cms->writefile($file, no_mq_gpc($_POST['source'])) ? self::$cms->get_message('done_ok') : self::$cms->get_message('done_failed');
								$out .= '<p class="zalert">'.$tmp.' : '.$filename.'</p>';
							}
							$out .= '<form action="'.self::$cms->base.'source_editor|'.$pageid.($pageid=='skin'?'|'.self::$cms->args[2].'|'.$filename:'').'"  method="post"><div class="ztable" style="width:auto">';
							if (self::$cms->truepage==$pageid) {
								$out .= $this->get_message('pg_titre').' '.$filename;
								$out .= ' <input type="submit" name="Submit" value="'.self::$cms->get_message('submit').'" /><a href="'.self::$cms->base.'admin#'.$pageid.'"> '.self::$cms->get_message('edit_admin').'</a></div>';
								$out .= $this->get_message('pg_permalien').' <input type="text" name="permaname" value="'.self::$cms->struct[(int)$pageid][0].'" /><br />';
							} else {
								$out .= self::$cms->get_message('edit_file').': <b>'.$filename.'</b>';
								$out .= ' <input type="submit" name="Submit" value="'.self::$cms->get_message('submit').'" /></div>';
							}
							$out .= '<textarea style="width:100%;height:500px;" name="source" id="source">'.htmlentities(file_get_contents($file)).'</textarea>';
							$out .= '</form>';
						  self::$cms->doevent(eSource,eAfter,$out,$filename);
							return $out;
						} else {
							return self::$cms->get_message('errorNOFILE');
						}
					} else {
						return self::$cms->get_message('not_allowed');
					}
				break;
		  case 'delete' :
				$p = (int)self::$cms->args[1];
				if ($p>0 && $p<=$max && $max>1) {
				$tools =  $admin || ($webmaster&&(self::$cms->isPageAuth($p,cPageWrite)));
					if ($tools) {
						if (self::$cms->args[2]=='ok') {
							unlink(self::$cms->cpath.'/'.self::$cms->struct[$p][0].'.txt');
							for($i=$p; $i<$max; $i++) self::$cms->struct[$i] = self::$cms->struct[$i+1];
							unset(self::$cms->struct[$max]);
							self::$cms->writeStruct(true);
							header('Location: '.self::$cms->base.'admin#'.self::$cms->args[1]);
						} else {
							return self::$cms->get_message('delpage_confirm').'<p class="zalert"><a href="'.self::$cms->base.'delete|'.$p.'|ok">'.self::$cms->get_message('delpage').'<strong>'.self::$cms->struct[$p][1].'</strong></a></p>';
						}
					} else {
						return self::$cms->get_message('not_allowed');
					}
				} else {
					return self::$cms->get_message('not_possible');
				}
		    break;
			case 'option':
				$tools =  $admin || $webmaster;
				if ($tools) {
					$c = self::$cms->args[1];
					$p = (int)self::$cms->args[2];
					if ($p>0 && $p<=$max) {
					  $page = & self::$cms->struct[$p];
					  if (self::$cms->isPageAuth($p,cPageWrite)) {
  					  $_SESSION['truepage']=$p;
					  	if ($c=="s") {   // prendre les valeurs dans la page courante
					      $pg_titre = $page[cPageTitre];
								$pg_desc = empty($page[cPageDesc])?'':$page[cPageDesc];
								$pg_keyw = empty($page[cPageKeyword])?'':$page[cPageKeyword];
								$pg_type = $page[cPageType];
								$pg_opt = empty($page[cPageOpt])?'':$page[cPageOpt];
								$pg_navtitle = empty($page[cPageNavTitle])?'':$page[cPageNavTitle];
								$pg_field1 = empty($page[cPageField1])?'':$page[cPageField1];
								$pg_field2 = empty($page[cPageField2])?'':$page[cPageField2];
							} else if ($c=="m") {  // prendre les valeurs du formulaire
							  $pg_titre = trim(htmlentities(stripslashes($_POST['pg_titre'])));
							  $pg_desc = trim(htmlentities(stripslashes($_POST['pg_desc'])));
							  $pg_keyw = trim(htmlentities(stripslashes($_POST['pg_keyw'])));
								$pg_type=(((int)$_POST['pg_type'])&~(pgbitMenu|pgbitPosSide)) | (int)$_POST['pg_visumenu'] | (int)$_POST['pg_position'];//v091
//							$pg_type=(((int)$_POST['pg_type'])&~(pgbitMenu)) | ((int)$_POST['pg_visumenu']); //v090
							  $pg_opt = (int)$_POST['pg_opt'];
							  if ($admin) {
									switch ($page[cPageType]&pgbitType) {
								    case 0: case 1 : 	//HTML
								    case 2 :  //PHP
											$pg_type = (((int)$pg_type)&(~3)) | ((int)$_POST['pg_htmlphp']);//v090 ($page[cPageType]&~pgbitType)|(int)$pg_type;
						      		break;
										default : //Autre
										  break;
									}
								}
							  $pg_navtitle = trim(htmlentities(stripslashes($_POST['pg_navtitle'])));
							  $pg_field1 = trim(htmlentities(stripslashes($_POST['pg_field1'])));
							  $pg_field2 = trim(htmlentities(stripslashes($_POST['pg_field2'])));
							} else return self::$cms->get_message('not_possible');
							$out = '<form method="post" action="'.self::$cms->base.'option|m|'.self::$cms->args[2].'" enctype="multipart/form-data"><table class="ztable">';
							$out .= '<tr><td colspan="2"><h2><center>'.$this->get_message('title_option').'</center></h2><td></tr>';
							$out .= '</table>';
  						if (isset($_POST['abort'])) {
									header('Location: '.self::$cms->base.'admin#'.self::$cms->args[2]);
								} elseif (!empty($err)) {
									$out .= $err;
								} elseif (isset($_POST['submit'])) {  // on va vraiment modifier les options de la page
										$page[cPageTitre] = $pg_titre?$pg_titre:self::$cms->get_message('page_default_title')." [$p]";
										$page[cPageType] = (int)$pg_type;//v090 ($page[cPageType]&~pgbitType)|(int)$pg_type;
										if ($pg_desc) {
											$page[cPageDesc] = $pg_desc;
										} else unset($page[cPageDesc]);
										if ($pg_keyw) {
											$page[cPageKeyword] = $pg_keyw;
										} else unset($page[cPageKeyword]);
										if (($page[cPageType]&pgbitPosSide)==pgbitPosSide) { // C'est un panneau latral
											$page[cPageOpt] = $pg_opt;
										}
										if ($pg_navtitle) {
											$page[cPageNavTitle] = $pg_navtitle;
										} else unset($page[cPageNavTitle]);
										if ($pg_field1) {
											$page[cPageField1] = $pg_field1;
										} else unset($page[cPageField1]);
										if ($pg_field2) {
											$page[cPageField2] = $pg_field2;
										} else unset($page[cPageField2]);
										self::$cms->writeStruct(true); // false devrait suffire =>  vrifier
										header('Location: '.self::$cms->base.'admin#'.self::$cms->args[2]);
										exit;
								}
							self::$cms->content['js'].='<script language="Javascript" type="text/javascript"> function monaction(form) { ;'
																			.'if (form.pg_position1.checked){document.getElementById("pnl").style.display="";document.getElementById("rb4").checked=true;} else {document.getElementById("pnl").style.display="none"} '
																			.' }</script>';
							  // pav: HTML & META desc
							$out .= '<table class="ztable" id="pv">';
							$out .= '<tr><td>'.$this->get_message('pg_titre').'</td><td><input name="pg_titre" type="text" value="'.$pg_titre.'" size="30"/>';
							$out .= '<tr><td></td><td>'.$this->get_message('pg_titredesc').'</td></tr>';
							$out .= '<tr><td style="width:200px"></td></tr>';
							$out .= '<tr><td>Type de page: </td><td>';
							$out .=  '<input name="pg_htmlphp" type="radio" value="1" '.($pg_type%2==1 ? 'checked ' : '').($_SESSION['zite_admin']!=2?'disabled':'').' />HTML';
							$out .=  '<input name="pg_htmlphp" type="radio" value="2" '.($pg_type%2==0 ? 'checked ' : '').($_SESSION['zite_admin']!=2?'disabled':'').' />PHP</td></tr>';
							$out .= '<tr><td></td><td>'.$this->get_message('pg_htmlphpdesc').'</td></tr>';
								// pav: Voulez-vous voir la page dans le menu
							//$out .= '<table id="visumenu" class="ztable" '.(($pg_type&pgbitMenu)|($pg_type&pgbitType)==5?'style="display:none;"':'').'>';
							$out .= '<tr><td>'.$this->get_message('pg_visumenu').'</td>';
							$out .= '<td><input type="radio" name="pg_visumenu" value="0" '.($pg_type&pgbitMenu?'':'checked').'>Oui ';
							$out .= '<input type="radio" name="pg_visumenu" value="'.pgbitMenu.'" '.($pg_type&pgbitMenu?'checked':'').'>Non</td></tr>';
							$out .= '<tr><td></td><td>'.$this->get_message('pg_visumenudesc').'</td></tr>';
								//
							$out .= '<tr><td>'.$this->get_message('pg_navtitle').'</td><td> <input name="pg_navtitle" id="pg_navtitle" type="text" value="'.($pg_navtitle?$pg_navtitle:'').'" size=50> '.$this->get_message('optional').'</td></tr>';
							$out .= '<tr><td></td><td>'.$this->get_message('pg_navtitledesc').'</td></tr>';
							$out .= '<tr><td>'.$this->get_message('pg_desc').'</td><td> <input name="pg_desc" id="pg_desc" type="text" value="'.($pg_desc?$pg_desc:'').'" size="50"> '.$this->get_message('optional').'</td></tr>';
							$out .= '<tr><td></td><td>'.$this->get_message('pg_descdesc').'</td></tr>';
							$out .= '<tr><td>'.$this->get_message('pg_keyw').'</td><td><input name="pg_keyw" id="pg_keyw" type="text" value="'.($pg_keyw?$pg_keyw:'').'" size="50"> '.$this->get_message('optional').'</td></tr>';
							$out .= '<tr><td></td><td>'.$this->get_message('pg_keywdesc').'</td></tr>';
								// pav: position de la page
//							$out .= '<table id="position" class="ztable" '.(($pg_type&pgbitMenu)|($pg_type&pgbitType)==5?'style="display:none;"':'').'>';
							$out .= '<tr><td style="vertical-align:top">'.$this->get_message('pg_position').'</td>';
							$out .= '<td><input type="radio" name="pg_position" value="0" '.($pg_type&pgbitPosSide?'':'checked').' onclick="monaction(this.form);">'.$this->get_message('pg_positionstd');
							$out .= ' <input type="radio" id ="pg_position1" name="pg_position" value="'.pgbitPosSide.'" '.($pg_type&pgbitPosSide?'checked':'').' onclick="monaction(this.form);">'.$this->get_message('pg_positionside').'</td></tr>';
							$out .= '<tr><td colspan="2">'.$this->get_message('pg_positiondesc').'</td></tr>';
							$out .= '</table>';
							$disabled = !($admin || ($_SESSION['zite_admin']==1))?'disabled':''; //?vrifier
								// pav: panneau latral
//							if (($page[cPageType]&pgbitPosSide)==pgbitPosSide) { // C'est un panneau latral
								$out.='<table class="ztable" id="pnl" '.(($pg_type&pgbitPosSide)==pgbitPosSide?'':'style="display:none;"').'>';
								$out .= '<tr><td colspan=2>'.$this->get_message('pg_pnl').'<td><tr><tr><td>';
								$out .= '<input name="pg_opt" type="radio" value="1" '.(($pg_opt&1)==1 ? 'checked ' : '').$disabled.' /> <b>1</b>-'.$this->get_message('pg_pnl1').'<br/>';
								$out .= '<input name="pg_opt" type="radio" value="2" '.(($pg_opt&2)==2 ? 'checked ' : '').$disabled.' /> <b>2</b>-'.$this->get_message('pg_pnl2').'<br/>';
								$out .= '<input name="pg_opt" id="rb4" type="radio" value="4" '.(($pg_opt&4)==4 ? 'checked ' : '').$disabled.' /> <b>3</b>-'.$this->get_message('pg_pnl3').'<br/>';
								$out .= '<input name="pg_opt" type="radio" value="8" '.(($pg_opt&8)==8 ? 'checked ' : '').$disabled.' /> <b>4</b>-'.$this->get_message('pg_pnl4').'<br/>';
								$out .= '<input name="pg_opt" type="radio" value="16" '.(($pg_opt&16)==16 ? 'checked ' : '').$disabled.' /> <b>5</b>-'.$this->get_message('pg_pnl5').'<br/>';
								$out .= '<input name="pg_opt" type="radio" value="32" '.(($pg_opt&32)==32 ? 'checked ' : '').$disabled.' /> <b>6</b>-'.$this->get_message('pg_pnl6').'<br/>';
								$out .= '<input name="pg_opt" type="radio" value="64" '.(($pg_opt&64)==64 ? 'checked ' : '').$disabled.' /> <b>7</b>-'.$this->get_message('pg_pnl7').'<br/>';
								$out .= '<input name="pg_opt" type="radio" value="128" '.(($pg_opt&128)==128 ? 'checked ' : '').$disabled.' /> <b>8</b>-'.$this->get_message('pg_pnl8').'<br/><br/><br/>';
								$out .= '</td><td><img src=deco/pnl01.png></img></td></tr>';
//							}
								// Les champs paramtrables
							$fld1name=$this->getOption('field1');$fld2name=$this->getOption('field2');
							if (!(empty($fld1name)&&empty($fld2name))) {
								$out.='<table class="ztable">';
								if (!empty($fld1name)) $out.='<tr><td>'.$fld1name.'</td><td><input name="pg_field1" id="pg_field1" type="text" value="'.$pg_field1.'" /></td></tr>';
								if (!empty($fld2name)) $out.='<tr><td>'.$fld2name.'</td><td><input name="pg_field2" id="pg_field2" type="text" value="'.$pg_field2.'" /></td></tr>';
								}
								//
							$out .= '</table><table class="ztable"><tr><td><input type="submit" name="submit" value="'.self::$cms->get_message('submit').'" ><input name="pg_type" type="hidden" value="'.$pg_type.'" ><input name="save" type="hidden" value="1" /></td><td><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr>';
							$out .= '</table></form>';
							return $out;
						} else return self::$cms->get_message('not_allowed');
					} else return self::$cms->get_message('not_possible');
				} else return self::$cms->get_message('not_allowed');
			  break;
			default : // page_admin
				$tools =  $admin || $webmaster;
				// Oprations
				if ($tools) {   //
					$c = isset(self::$cms->args[1])?self::$cms->args[1]:'';
					$p = isset(self::$cms->args[2])?self::$cms->args[2]:0;
					if ($p>0 && $p<=$max) {
						$change = true;
						$dta = & self::$cms->struct[$p];
						$power = $admin || self::$cms->isPageAuth($p,cPageWrite);
						if ($c=='l' && $dta[cPageRang]>1) {// left
							if ($dta[cPageRang]>1) $dta[cPageRang]--;
							if (($dta[cPageRang]==1)&&(isset($dta[cPageWrite]))) {//pour voir crer page racine
								$dta[cPageWrite]=self::$cms->struct[$dta[cPagePere]][cPageWrite]; //0.9.0.a3-1/9/2009
							}
						} elseif ($c=='r') {// right
							$dta[cPageRang]++;
						} elseif ($c=='u') {// up
							if (($p>1)&&(self::$cms->isPageAuth($p-1,cPageWrite))) self::$cms->swap($p);
						} elseif ($c=='d') {// down
							if (($p<$max)&&(self::$cms->isPageAuth($p+1,cPageWrite))) self::$cms->swap($p+1);
						} elseif ($c=='s' && $power) {// Status
							$dta[cPageOn] = $dta[cPageOn]==1 ? 0 : 1;
						} else {
							$change = false;
						}
						if ($change) self::$cms->writeStruct(true);
						header('Location: '.self::$cms->base.'admin#'.self::$cms->args[2]); // positionner correctement la page
					}
				}
				// Affichage structure
				$i = 0; $nav='';
//				$nav .= '<tr><td><img src="deco/help"></td><td><img src="deco/help"></td><td><img src="deco/help"></td><td><img src="deco/help"><img src="deco/help"><img src="deco/help"> PgW - PgR</td><td><img src="deco/help"></td></tr>';
				foreach (self::$cms->struct as $k => $v) {
					$i++;
					if (self::$cms->isPageAuth($k,cPageRead)) {
					  $pw = self::$cms->isPageAuth($k,cPageWrite); // prendre les droits en criture sur la page
					  $tool1 = $tool2 = $tool3 = '';
				 		if ($tools) {
							$tb = ' <a href="'.self::$cms->base.'admin|';
							if ($pw) {
								$tool1 .= $v[cPageRang]>1 ? $tb.'l|'.$k.'"><img src="deco/l1.png" /></a>' : ' <img src="deco/l0.png" />';
								$tool1 .= ' <a href="'.self::$cms->base.'page_new|'.'n|'.$k.'" title="'.$this->get_message('icone_plus').'"><img src="deco/a.png" /></a>';
								$tool1 .= $tb.'r|'.$k.'"><img src="deco/r1.png" /></a>';
							}
							$tool2 .= ($k>1)&&($pw) ? $tb.'u|'.$k.'"><img src="deco/u1.png" /></a>' : '<img src="deco/u0.png" />';
							$tool2 .= ($k<$max)&&($pw) ? $tb.'d|'.$k.'"><img src="deco/d1.png" /></a>' : ' <img src="deco/d0.png" />';

						if ($admin || $pw) {
							$tool2 .= $v[cPageOn] ? $tb.'s|'.$k.'" title="'.$this->get_message('icone_onoff').'"><img src="deco/s1.png" /></a>' : $tb.'s|'.$k.'"><img src="deco/s0.png" /></a>';
	        	} else {
							$tool2 .= $v[cPageOn] ? ' <img src="deco/s1.png" />' : ' <img src="deco/s0.png" />';
						}
						if ($admin) {
      	      $tool2 .= ' <a href="'.self::$cms->base.'selectgroup|'.$k.'|i|'.cPageWrite.'"> <img src="deco/kw'.($v[cPageWrite] ?'1' : '0').'.png" title="'.arrayToString(array_unique(array_merge($v[cPageWrite],array('admin')))).'"/></a>';
          	  $tool2 .= ' <a href="'.self::$cms->base.'selectgroup|'.$k.'|i|'.cPageRead.'"><img src="deco/kr'.($v[cPageRead]?'1': '0').'.png" title="'.($v[cPageRead]?arrayToString($v[cPageRead]):$this->get_message('grpreadall')).'"/></a>';
						} else {
							$tool2 .= ' <img src="deco/kw'.($v[cPageWrite] ? '1' : '0').'.png" title="'.arrayToString(array_unique(array_merge($v[cPageWrite],array('admin')))).'"/>';
							$tool2 .= ' <img src="deco/kr'.($v[cPageRead] ? '1':'0').'.png" title="'.($v[cPageRead]?arrayToString($v[cPageRead]):$this->get_message('grpreadall')).'"/>';
						}
						if ($admin || $pw) {
							$tool3 .= $max>1 ? ' <a href="'.self::$cms->base.'delete|'.$k.'"><img src="deco/e1.png" /></a>' : ' <img src="deco/e0.png" />';
	        	} else {
							$tool3 .= ' <img src="deco/e0.png" />';
						}
					 }
					 $nav .= '<tr class="'.($i%2 ? 'oddcolor' : 'evencolor').'"><td>'."<a name='$i' href='#$i'>".(isset($_SESSION['truepage'])&&($k==$_SESSION['truepage'])?'<span style="background-color:yellow">':'').$i.(isset($_SESSION['truepage'])&&($k==$_SESSION['truepage'])?'</span>':'').'</a>'.'</td><td>'.$tool1.'</td><td>'.str_repeat('&nbsp; ',4*--$v[cPageRang]);
					 $nav .= (self::$cms->isPageAuth($k,cPageWrite) ? ('<a href="'.self::$cms->base.($v[cPageType]=='5'?'page_new|m|':'option|s|').$k.'" title="'.$this->get_message('icone_option').'"><img src="deco/config.png" /></a> ') : '');
					 $nav .= (!(self::$cms->isPageAuth($k,cPageWrite) ) ? $v[1] : ($_SESSION['zite_admin']==2 ? '<a href="'.self::$cms->base.($v[cPageType]=='5'?'page_new|m|':'source_editor|').$k.'" title="'.$this->get_message('icone_src').'"><img src="deco/c.png" /></a> ' : '').'<a href="'.self::$cms->base.((($v[cPageType]&pgbitType)>='1')&&(($v[cPageType]&pgbitType)<='2')?'page_editor|':(($v[cPageType]&pgbitType)=='5'?'page_new|m|':'page_extended|')).$k.'">'.$v[cPageTitre].'</a>');
					 $nav .= ' <a href="'.($v[3]!=5?'?perma=':'').$v[0].'" style="font-size:75%;color:#AAA">'.$v[0].'</a>';
					 $nav .= (($v[cPageType]&pgbitPosSide)==pgbitPosSide)?/*'(P'.(1+log($v[cPageOpt],2)).')'.*/' <img src="deco/pl'.(1+log($v[cPageOpt],2)).'.png" />':'';
					 $nav .='</td><td>'.$tool2.'</td><td>'.$tool3.'</td></tr>';
					}
				}
				return '<p><table align="center" border="0" cellspacing="0" cellpadding="2" class="ztable"><tr class="headcolor"><td colspan="5" align="center">'.self::$cms->get_message('edit_structure').'</td></tr>'.$nav.'</table></p>';
			} //switch
			} else {
				return self::$cms->get_message('not_allowed');
			}
	}
	function Init() {
	  $this->module_brother = 'tinymce';
	  parent::Init();
	}
}
?>