<?php
/*
module:	Sauvegarde du site - V1.5
Copyright Jean-Paul GIAUSSERAND 2008-2009
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.5  20/10/2009  Ajout sauvegarde complte du site (ide davyk & Fredo42)
	v1.4 	23/08/2009
				Cration du fichier ini correspondant
	      Passage en code objet
	v1.3	Le nom du fichier de sauvegarde comprend la date et l'heure du jour
	v1.2	Modification pour prise en compte nouvelle structure de data (sous-rpertoire)
	v1.1	Le nom du fichier de sauvegarde comporte la date du jour
	v1.0	Cration du module de sauvegarde du site
*/
class Tsavesite extends Tmodule {
	function dojob($opt="") {
		parent::dojob();
		function doSave($opt,$src,$cms) {
			require($cms->zpath.'/pclzip.lib.php');
			function myPreAddCallBack($p_event, &$p_header) {   // Ne sauvegarder que les fichiers, pas les sous-rpertoires
				if (($p_header['folder']==true)||(strpos($p_header['stored_filename'],'/')!==strrpos($p_header['stored_filename'],'/'))) {
	      		return 0;
  	 		} else { // ----- all other files are simply added
						return 1;
				}
   		}
      set_time_limit(0);
	   	$dest = $cms->config['site_id'].'_'.$opt.'_'.date('Y-m-d_H\hi');
			$tempname=tempnam('','sv');
			if ($tempname===false) {$tempname='sv.zip';unlink($tempname);}//si safe_mode on
    	$archive = new PclZip($tempname);
			if ($opt=='data') {
				$v_list=$archive->create($src,PCLZIP_CB_PRE_ADD , 'myPreAddCallBack');
			} else {
				if ($opt=='site') {
					$src=implode(',',array_diff(scandir('.'),array('.','..',basename($tempname),'sessions')));
				}
				$v_list=$archive->create($src);
			}
	    if ($v_list != 0) {
				@ob_end_clean();
				header('Content-Type: application/x-zip');
				header('Content-Disposition: inline; filename="'.$dest.'.zip"');
				@ini_set('zlib.output_compression', '0');
  	    readfile($tempname);
				ob_flush();//ob_end_flush();
				unset($archive);
				}
			unlink($tempname);
			return !empty($v_list);
		}
		// Si sauvegarde de site demand
		if ($_POST['save']=='svsite') { // sauvegarde site
			switch($_POST['savedata']) {
			  case 'data' :
					(doSave('data','zdata',self::$cms)!=0)?self::$cms->msgShow('done_ok'):self::$cms->msgShow('done_failed');
			    break;
				case 'docs':
					(doSave('docs','zdata/zdocs',self::$cms)!=0)?self::$cms->msgShow('done_ok'):self::$cms->msgShow('done_failed');
			    break;
				case 'all' :
					(doSave('all','zdata',self::$cms) !=0)? self::$cms->msgShow('done_ok'):self::$cms->msgShow('done_failed');
				  break;
				case 'site' :
					(doSave('site','site',self::$cms) !=0)? self::$cms->msgShow('done_ok'):self::$cms->msgShow('done_failed');
				  break;
				default :
				  self::$cms->msgShow($this->get_message('nochoice'),false);
    }
		}
		$savedata = empty($_POST['savedata'])?'zdata':$_POST['savedata'];
		$out = '<form method="post" action="'.self::$cms->base.'savesite" enctype="multipart/form-data"><table class="ztable">';
		$out .= '<tr><td colspan="2"><center><strong>'.$this->get_message('title').'</strong></center></td></tr>';
		$out .= '<tr><td><input name="savedata" type="radio" value="data" '.($savedata=='data'?'checked':'').' >'.' '.$this->get_message('zdata').'</td></tr>';
		$out .= '<tr><td><input name="savedata" type="radio" value="docs"' .($savedata=='docs'?'checked':'').' >'.' '.$this->get_message('zfiles').'</td></tr>';
		$out .= '<tr><td><input name="savedata" type="radio" value="all" '.($savedata=='all'?'checked':'').' >'.' '.$this->get_message('alldata').'</td></tr>';
		$out .= '<tr><td><input name="savedata" type="radio" value="site" '.($savedata=='total'?'checked':'').' >'.' '.$this->get_message('allsite').'</td></tr>';
		$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.self::$cms->get_message('submit').'" /><input name="save" type="hidden" value="svsite" /></td></tr></table></form>';
		return $out;
	}
}
?>
