<?php
/*
module:	Mise  jour de ZitePLUS de la version 0.9.1 vers la version 0.9.2
Copyright Jean-Paul GIAUSSERAND 2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.7  24/02/12  0.9.2.rc4 application des modifs du module update  la rc3 et rc2
	v1.6  18/02/12  0.9.2.rc3
  v1.5  25/12/11  0.9.2.rc2
	v1.4  09/11/11  0.9.2.rc1
	v1.3  03/10/11  0.9.2.a4 : Optimisation vitesse traitement des documents + divers (navtitle + field1 et field2)
	v1.2  01/09/11  0.9.2.a3 : premire mise  jour fonctionnelle
	v1.1  27/07/11  Passage  la version 0.9.2.a2
	v1.0	26/04/11	Cration du module
*/
class Tupdate extends Tmodule {
	function On() {
		parent::On();
		$cms = &self::$cms;
		  // Mettre les nouveaux paramtres du config.ini
		if (!isset($cms->config['site_lang'])) {	$cms->config['site_lang']=0; }
		if (!isset($cms->config['jquery_link'])) {	$cms->config['jquery_link']='https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js'; }
		if (!isset($cms->config['jquery_load'])) {	$cms->config['jquery_load']=2; }
		if (!isset($cms->config['page_div'])) {	$cms->config['page_div']=1; }
		if (empty($cms->config['files_styleuser'])) {
				$cms->config['files_styleuser']='user.css';
        if (!file_exists($cms->ipath.'/user.css')) file_put_contents($cms->ipath.'/user.css', '');
		}
		if (!isset($cms->config['login_captcha'])) { $cms->config['login_captcha']=0; }
		$cms->config['version']='ZitePLUS 0.9.2';    // Car la bonne version de ZITEEVER n'existe pas encore
		$cms->writeconfig($cms->cpath.'/config.ini', $cms->config);
    $cms->msgShow('Nouveaux paramtres de configuration: ok',false);
			//
		if (file_exists($cms->zpath."/module/tinymce.php")) {
			if (!isset($cms->module['tinymce.php'])) {
				$file = $cms->cpath.'/module.dta';
				$module = &$cms->module;
				$module['tinymce.php'] = array('tinymce', 0,array('logon'));
 				$cms->writedata($file, $module);
				$mo = Tmodule::create_module('tinymce'); $mo->Off(); unset($mo);
			} else { // correction version prcdente login  la place de logon
				$module = &$cms->module;
				$module['tinymce.php'][cModulUse] = array('logon');
 				$cms->writedata($file, $module);
			}
		}
		if (file_exists($cms->zpath."/module/captcha.php")) {
			if (!isset($cms->module['captcha.php'])) {
				$file = $cms->cpath.'/module.dta';
				$module = &$cms->module;
				$module['captcha.php'] = array('captcha', 0,array('admin'));
 				$cms->writedata($file, $module);
				define('eCaptcha',7); // car la bonne version de TModule n'existe pas encore
				$mo = Tmodule::create_module('captcha'); $mo->On(); unset($mo);
		    $cms->msgShow('Register module CAPTCHA-On: ok',false);
			}
		}
		if (file_exists($cms->zpath."/module/contact.php")&&file_exists($cms->zpath."/module/contact.ini")) {
			if (!isset($cms->module['contact.php'])) {
				$file = $cms->cpath.'/module.dta';
				$module = &$cms->module;
				$module['contact.php'] = array('contact', 0,array()); // accessible  tout le monde
 				$cms->writedata($file, $module);
		    $cms->msgShow('Register module CONTACT-off: ok',false);
				$mo = Tmodule::create_module('contact'); $mo->Off(); unset($mo);
			}
		}
		  // Rafraichir la liste des valeurs de configuration pour prendre en compte les nouveaux paramtres
		foreach ($cms->module as $clef => $valeur ) {
			$mo= Tmodule::create_module($valeur[cModulIdent]);
			if (is_object($mo)) {//uniquement pour les vrais modules
				 $mo->Config('init'); unset($mo);
			}
		}
    $cms->msgShow('Nouveaux paramtres des modules: ok',false);
			// modification template.php
		$template = file_get_contents(self::$cms->ipath.'/'.self::$cms->config['files_template']);
			// Traitement du template.php pour changement menu_title
		$template=preg_replace('@<title>.+</title>@is', '<title><?php echo $this->content["page_navtitle"]?'.'></title>', $template);
			// remplacer les $zite par $this
		$template=preg_replace('@\$zite->@is', '\$this->', $template);
		file_put_contents(self::$cms->ipath.'/'.self::$cms->config['files_template'],$template);
    $cms->msgShow('modification du template: ok',false);
		  // Prparer renvoi vers nouveau ZitePLUS
		$indexphp = file_get_contents(self::$cms->ipath.'/index.php');
		$indexphp = str_ireplace('zite/zite.php','zplus/ziteplus.php', $indexphp);
		$indexphp = str_ireplace('zite/module/ga.txt','zplus/module/ga.txt', $indexphp);//juste ou cas ou ==========> c'est dans le template
		file_put_contents(self::$cms->ipath.'/index.php',$indexphp);
		unset($indexphp);
    $cms->msgShow($this->get_message('Version_test_active'),false);
	}
	function Off() {//Appel lorsque le module est activ
//    self::$cms->msgShow($this->get_message('Version_test_off'),false);
		parent::Off();
	}
}
?>