<?php
/**
module:	Gestion des utilisateurs
Copyright Jean-Paul GIAUSSERAND 2008-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.8  07/12/2011  Suppression nombreux warnings, gestion de certains champs par l'utilisateur
	v1.7  18/12/2010  Gestion magic_quotes
	v1.6  06/05/2010  Corrections mineures
	v1.5  16/11/2009  Diminution nombre de warning en php 5.3
	v1.4  19/10/2009  changement du sparateur de groupe (blanc au lieu de :)
	v1.3  28/09/2009  Prise en compte des paramtres optionnels
	v1.2	31/08/2009	Ajout divers champs  la gestion utilisateur
	v1.1	30/08/2009	Passage en code objet
	v1.0	01/10/2008	Cration du module de gestion des utilisateurs
*/
//args: 0=user, 1=ident, 2=new|edit|delete|
require_once(Tmodule::$cms->zpath.'/outils.php');
class Tuser extends Tmodule {
	function dojob($opt="") {
		function new_password($length) {
			$allowedchars = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_";
			$password = '';
			$max=strlen($allowedchars)-1;
			for ($i=1;$i<=$length;$i++) {
				$password .= substr($allowedchars, mt_rand(0, $max), 1);
			}
			return $password;
		}
		parent::dojob();
		$admin = in_array('admin',$_SESSION['zite_usergroup']);
		if (!$admin) {
			if (isset($_POST['name'])&&($_POST['name']!=$_SESSION['zite_user'])) unset($_POST['name']); // Protection fraude simple user
			self::$cms->args[2]='edit';
			if (empty(self::$cms->args[1])||isset($_POST['abort'])) {
				unset($_POST['abort']);
			 	unset($_POST['name']);
			}
			self::$cms->args[1]=$_SESSION['zite_user'];
		}
		$file = self::$cms->cpath.'/user.dta';
		if (empty(self::$cms->user)) self::$cms->user = (array)unserialize(@file_get_contents($file));
		$f = & self::$cms->user;
			//
		$err='';
		if (isset($_POST['abort'])) {
	  	self::$cms->args[2]='';
		} else {
			if (isset($_POST['name'])) {//valeur renvoy par le formulaire
				$name = no_mq_gpc(strtolower(preg_replace('/\W+/','',$_POST['name'])));
				if ($admin) {
					$inactif = (int)isset($_POST['inactif'])?$_POST['inactif']:0;
					$group = (array)$_POST['group'];
					$cgu = (int)isset($_POST['cgu'])?$_POST['cgu']:0;
				} else {
					$inactif = $f[$name][3];
				  $group = $f[$name][2];
					$cgu = $f[$name][7];
				}
				$desc = no_mq_gpc($_POST['desc']);
				$courriel = $_POST['courriel'];
				$nom = preg_replace   ('/[^\w_\-\'\040]*/','',$_POST['nom']);
				$prenom = preg_replace('/[^\w_\-\'\040]*/','',$_POST['prenom']);
			} elseif (!empty(self::$cms->args[1])) {//valeur initiale du formulaire
			  $name = no_mq_gpc(strtolower(self::$cms->args[1]));
				$desc = $f[$name][1];
				$group = (array)$f[$name][2];
				$inactif = $f[$name][3];
				$courriel = $f[$name][4];
				$nom = $f[$name][5];
				$prenom = $f[$name][6];
				$cgu = $f[$name][7];
			} else {// formulaire vierge
			  $name = $desc = $inactif = $courriel = $nom = $prenom = $cgu = ''; $group = array(); $password = new_password($this->getOption('passwordminlen'));
			}
		if (!in_array('logon',$group)) $group[]='logon';  // Tous les utilisateurs font partis de ce groupe
		//
		if (isset($_POST['resetpwd'])){
			$password = new_password($this->getOption('passwordminlen'));
		} elseif (isset($_POST['save'])&&($admin||($_SESSION['zite_user']==$name))) {
		  $id = $name;
			$password = trim($_POST['password']);
			if (isset($_POST['delete'])&&($_POST['delete']==1)) {  // effacement de l'utilisateur
				if (isset($f[$name]))	unset($f[$name]);
			} else {
				if (empty($name)) {
				  $err = 'errnameempty';
				} elseif ((strlen($password)>0)&&(strlen($password)<$this->getOption('passwordminlen'))) {
					$err = 'errpwdtooshort';
				} elseif (strlen($password)>$this->getOption('passwordmaxlen')) {
				  $err = 'errpwdtoolong';
				} else {	// Ajout d'un nouvel utilisateur
					$f[$id][1] = $desc;
					$f[$id][2] = $group;
				  $f[$id][3] = $inactif;
				  $f[$id][4] = $courriel;
				  $f[$id][5] = $nom;
				  $f[$id][6] = $prenom;
				  $f[$id][7] = $cgu;
					if (array_key_exists($id,$f)) {
						if  (strlen($password)!=0) $f[$id][0] = md5($password);
					} else {
						$f[$id][0] = (strlen($password)!=0)? md5($password):md5($id);
					}
				}
			}
			if (!empty($err)) {
				self::$cms->msgShow($this->get_message($err));
			} else {
				self::$cms->writedata($file, $f);
				self::$cms->user  = (array)unserialize(@file_get_contents($file));
			  if ($admin) self::$cms->args[2]='';
			}
		}
	}
	// formulaire
	$out = '<form method="post" action="'.self::$cms->base.'user|'.(isset($name)?$name:'').(isset(self::$cms->args[2])?'|'.self::$cms->args[2]:'').'" enctype="multipart/form-data"><table class="ztable">';
	if ($admin&&!self::$cms->truepage&&$this->isConfig('user')){
    $out2= '<a href="'.self::$cms->base.'selectmodule|config|'.$this->ident.'" title="'.$this->get_message('moduleconf').'"><img src="deco/config.png" /></a>';
	} else $out2='';
	$out .= '<tr><td colspan="2" style="text-align:center"><span style="float:right">'.$out2.'</span><center><h2>'.$this->get_message('title').'</h2></center></td></tr>';
	if ($admin) $out .= '<tr><td align="left">'.count($f).' '.strtolower($this->get_message('admin')).'</td><td align="right"><a href="'.self::$cms->base.'user||new"><img src="deco/a.png" />'.$this->get_message('btnadd').'</a></td></tr>';
	$out .= '</table><table class="ztable">';
	if (!empty(self::$cms->args[2])) {
		$del = self::$cms->args[2]=='delete';  // Mode suppression actif
		$out .= '<tr><td colspan="2"><h3>'.$this->get_message( $del ? 'confirmdel' : (self::$cms->args[2]=='new' ? 'new' : 'edit')).'</h3></td></tr>';
		$out .= '<tr><td>'.$this->get_message('username').'</td><td><input name="name" type="text" id="name" value="'.$name.'" '.($del||!$admin ? 'readonly' : '').($err=='errnameempty'?' class="zerr"':'').' /></td></tr>';
		$out .= '<tr><td>'.$this->get_message('password').'</td><td><input name="password" type="text" id="password" value="'.(isset($password)?$password:'').'" '.($del ? 'readonly' : '').' /> <input type="submit" name="resetpwd" value="'.$this->get_message('resetpwd').'"/></td></tr>';
		$out .= '<tr><td>'.$this->get_message('desc').'</td><td><input name="desc" type="text" id="desc" value="'.$desc.'" '.($del ? 'readonly' : '').' size="60%" /></td></tr>';
		if ($admin) $out .= '<tr><td>'.$this->get_message('useroff').'</td><td><input name="inactif" type="checkbox" value="1" '.($inactif?'checked':'').($del||!$admin ? 'readonly' : '').' ></td></tr>';
		if ($this->getOption('showmail'))	$out .= '<tr><td>'.$this->get_message('mail').'</td><td><input name="courriel" type="text" id="courriel" value="'.$courriel.'" '.($del ? 'readonly' : '').' size="60%" /></td></tr>';
		if ($this->getOption('showname'))	$out .= '<tr><td>'.$this->get_message('firstname').' - '.$this->get_message('lastname').'</td><td><input name="prenom" type="text" id="prenom" value="'.$prenom.'" '.($del ? 'readonly' : '').' size="25%" /> <input name="nom" type="text" id="nom" value="'.$nom.'" '.($del ? 'readonly' : '').' size="30%" /></td></tr>';
				// Afficher les groupes de l'utilisateur
		if ($admin) {
			$out .= '<tr><td>'.$this->get_message('groupe').'</td><td><select name="group[]" multiple size=3 '.($del ? 'disabled' : '').' style="width:50%">';
			foreach (self::$cms->group as $clef => $valeur	)
				$out .= '<option '.(in_array($clef,$group)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
			$out .= '</select></td></tr>';
		}
		if ($admin&&$this->getOption('showcgu'))	$out .= '<tr><td>'.$this->get_message('cgu').'</td><td><input name="cgu" type="checkbox" value="1" '.($cgu?'checked':'').($del||!$admin ? ' readonly' : '').' ></td></tr>';
		if ($del) $out .= '<tr><td></td><td><input name="delete" type="checkbox" value="1" '.($del ? 'checked' : '').' /> '.self::$cms->get_message('files_delwarning').'</td></tr>';
		$out .= '<tr><td colspan="2"><input type="submit" name="save" value="'.self::$cms->get_message($del?'confirm':'send').'" /> <input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr></table></form>';
	}
			// liste de tous les utilisateurs
	if ($admin) {
		uksort($f, create_function('$a, $b', 'return strcmp($a[0], $b[0]);'));
		$out .= '<table class="ztable">';
		$out .= '<tr class="headcolor"><td>'.$this->get_message('colname').'</td><td>'.$this->get_message('coldesc').'</td><td>'.$this->get_message('colgroup').'</td><td></td></tr>';
		$i=0;foreach ($f as $clef => $valeur	) {
			$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'"><td><a href="'.self::$cms->base.'user|'.$clef.'|edit">'.strtoupper($clef).'</a></td><td>'.$valeur[1].'</td><td>'.implode(' ',$valeur[2]).'</td>';
			$out .= '<td align="center"><a href="'.self::$cms->base.'user|'.$clef.'|delete"><img src="deco/e1.png" /></a></td></tr>';
		}
		$out .= '</table>';
	}
	return $out;
}
}

?>
