<?php
/*
module:	Auto enregistrement des utilisateurs
Copyright Jean-Paul GIAUSSERAND 2009-2010
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.5	15/09/10  Ajout zone http et password pour le message admin
	v1.4  27/10/09  Ajout options de configuration + anvoi message admin + renvoi sur page
	v1.3  24/10/09  suppression zone password
	                envoi du mot de passe aprs activation du compte
	v1.2  13/10/09  ajout de l'utilisateur au groupe "logon"
	v1.1  10/10/09  ajout des options
	v1.0	27/08/09	Cration du module
*/
class Tuser_auto extends Tmodule {
	function new_password($length) {
		$allowedchars = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_";
		$password = '';
		$max=strlen($allowedchars)-1;
		for ($i=1;$i<=$length;$i++) {
			$password .= substr($allowedchars, mt_rand(0, $max), 1);
		}
		return $password;
	}
//
	function dojob($opt="") {
		parent::dojob();
			//normaliser les paramtres d'appel du module
	  if (self::$cms->args[0]=='module') array_shift(self::$cms->args);
	  $file = self::$cms->cpath.'/user.dta';
		$err=false; $errsend=false;
		if (self::$cms->args[1]=='v') { // tentative de validation du compte
    	$usernew =  ereg_replace('[^[:digit:][:alpha:]]','',strtolower(trim(self::$cms->args[2])));
    	$usercode =  ereg_replace('[^[:digit:][:alpha:]_]','',trim(self::$cms->args[3]));
    	if (self::$cms->user[$usernew][3]) { // utilisateur actuellement dsactiv
    	  $filename = self::$cms->cpath.'/ztemp/'.$usernew.'-'.$usercode;
				if (file_exists($filename)) {//activer l'utilisateur
					$password = $this->new_password($this->getOption('passwordlen'));
					self::$cms->user  = (array)unserialize(@file_get_contents($file));
					self::$cms->user[$usernew][3]=0;
					self::$cms->user[$usernew][0]=md5($password);
	   			self::$cms->writedata($file, self::$cms->user);
	        unlink($filename);
	          // Envoi d'un mail  l'utilisateur avec nom d'uilisateur et password
					$user = self::$cms->user[$usernew];
					$desc = $user[1];
					$nom = $user[5];
					$prenom = $user[6];
					$mailTo  = $user[4];
		     	$mailSubject = $this->getOption('mailsubjectok');
					$mailMessage = $this->getOption('mailmessageok');
					$mailMessage = str_ireplace('[http]',self::$cms->rewritebase.self::$cms->base.'login',$mailMessage);
					$mailMessage = str_ireplace('[login]',$usernew,$mailMessage);
					$mailMessage = str_ireplace('[password]',$password,$mailMessage);
		     	$errsend |= !mail($mailTo, $mailSubject, $mailMessage);
					if (!$errsend && $this->getOption('adminnotify')) {//Envoyer un message  l'administrateur: nouvel utilisateur
						$mailSubject = str_ireplace('[site]',self::$cms->config['site_id'],$this->getOption('mailsubjectadmin'));
						$mailMessage = str_ireplace('[login]',$usernew,$this->getOption('mailmessageadmin'));
						$mailMessage = str_ireplace('[mail]',$user[4],$mailMessage);
						$mailMessage = str_ireplace('[ip]',$_SERVER['REMOTE_ADDR'],$mailMessage);
						$mailMessage = str_ireplace('[http]',self::$cms->rewritebase.self::$cms->base.'login',$mailMessage);
            $mailMessage = str_ireplace('[password]',$password,$mailMessage);
						@mail($this->getOption('mailadmin'),$mailSubject,$mailMessage);
					}
					if (!$errsend) {
	     	  	if (strlen(trim($this->getOption('pagedestactivation')))) {
							header('Location: '.self::$cms->rewritebase.$this->getOption('pagedestactivation'));
						} else return '<div class="zalert">'.$this->get_message('msgactif').'</div>';
					}
	   		} else return $this->get_message('err_activation');
			} else return $this->get_message('err_activation');
		} elseif (isset($_POST['save'])&&($_POST['save']=='ok')) {  // tentative de cration du compte
			$name = ereg_replace('[^[:digit:][:alpha:]]','',strtolower(trim($_POST['name'])));
			$password = $this->new_password($this->getOption('passwordlen'));
			$desc = $_POST['desc'];
			$prenom = $_POST['prenom'];
			$nom = $_POST['nom'];
			$mail = ereg_replace('[^[:digit:][:alpha:].@-_]','',trim($_POST['mail']));
			$errmail = !preg_match("#^[a-z0-9._-]+@[a-z0-9._-]{2,}\.[a-z]{2,4}$#", $mail);  // mauvaise adresse mail
			$mail2 = ereg_replace('[^[:digit:][:alpha:].@-_]','',trim($_POST['mail2']));
			$errmail2 = $mail != $mail2;
			$errname = empty($name)||isset(self::$cms->user[$name]);  // pas d'utilisateur ou l'utilisateur existe dj}
			$err = $err | $errname | $errmail | $errmail2;
			if (!$err) {
			  	// Crer l'utilisateur en mode inactif
				self::$cms->user  = (array)unserialize(@file_get_contents($file));
				$f = &self::$cms->user;
				$f[$name][0] = md5($password);
				$f[$name][1] = $desc;
				$f[$name][2] = array('logon');	//group;
				$f[$name][3] = $this->getOption('useroff');	//inactif;
				$f[$name][4] = $mail;
				$f[$name][5] = $nom;
				$f[$name][6] = $prenom;
	 			self::$cms->writedata($file, self::$cms->user);
	 			  //
				$usercode = $this->new_password(64);
	    	file_put_contents(self::$cms->cpath.'/ztemp/'.$name.'-'.$usercode,'',LOCK_EX);
	 			  // Notifier l'utilisateur d'un ml
				$mailTo  = $mail;
	     	$mailSubject = $this->getOption('mailsubject');
				$mailMessage = $this->getOption('mailmessage')."\"".self::$cms->rewritebase.self::$cms->base.'user_auto|v|'.$name.'|'.$usercode.'"';
	     	if (mail($mailTo, $mailSubject, $mailMessage)) {
				 	self::$cms->msgShow('done_ok');
    	  	if (strlen(trim($this->getOption('pagedestinscription')))) {
						header('Location: '.self::$cms->rewritebase.$this->getOption('pagedestinscription'));
					} else return '<div class="zalert">'.$this->get_message('msgcreate').'</div>';
				} else $errsend=true;
			}
		} else {
	  	$name=$desc=$prenom=$nom=$mail=$message='';
		}
		$err = $err | $errsend;
		if ($err)	{
		 	if ($errname) self::$cms->msgShow($this->get_message('err_baduser'),false);
		 	if ($errmail) self::$cms->msgShow($this->get_message('err_badmail'),false);
		 	if ($errmail2) self::$cms->msgShow($this->get_message('err_badmail2'),false);
		 	if ($errsend) self::$cms->msgShow($this->get_message('err_sendmail'),false);
		}
		$password = $this->new_password(8); //  mettre en paramtre
		$out = '<form method="post" action="'.self::$cms->base.'user_auto" enctype="multipart/form-data"><table class="ztable">';
		$out .= '<tr><td colspan="2"><center><h1>'.$this->get_message('title').'</h1></center></td></tr>';
		$out .= '<tr><td>'.$this->get_message('username').'</td><td><input name="name" type="text" id="name" value="'.$name.'" '.($del ? 'readonly' : '').($errname?' class="zerr" ':'').' /> '.$this->get_message('username_desc').'</td></tr>';
		$out .= '<tr><td>'.$this->get_message('mail').' </td><td><input name="mail" type="text" value="'.$mail.'" '.($errmail?' class="zerr" ':'').'>'.' '.'</td></tr>';
		$out .= '<tr><td>'.$this->get_message('mail2').' </td><td><input name="mail2" type="text" value="'.$mail2.'" '.($errmail2?' class="zerr" ':'').'>'.' '.'</td></tr>';
		if ($this->getOption('showname')) {
			$out .= '<tr><td>'.$this->get_message('firstname').' - '.$this->get_message('lastname').' </td><td><input name="prenom" type="text" value="'.$prenom.'" > <input name="nom" type="text" value="'.$nom.'" > '.$this->get_message('zonefree').'</td></tr>';
		}
		if ($this->getOption('showdesc')) {
			$out .= '<tr><td>'.$this->get_message('desc').'</td><td><input name="desc" type="text" id="desc" value="'.$desc.'" '.($del ? 'readonly' : '').' size="60%" /> '.$this->get_message('zonefree').'</td></tr>';
		}
		$out .= '</table><table class="ztable">';
		$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.self::$cms->get_message('submit').'" /><input name="save" type="hidden" value="ok" /><input name="password" type="hidden" id="password" value="'.$password.'" /></td></tr></table></form>';
		return $out;
	}
	function Init() {
	  $this->module_brother = 'user';
	  parent::Init();
	}
}
?>