<?php
/*
Classe: Gestion de base des modules
Copyright Jean-Paul GIAUSSERAND 2009-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.6  31/05/11  Cration tools et event eCaptcha
	v1.5  23/10/10  Droits de changer
	v1.4  05/10/10  Droits de configuration
	v1.3  02/06/10  Gestion des vnement
	v1.2	24/10/09	Gestion modules frres (phase 1)
	v1.1	28/08/09	Gestion configuration
	v1.0	22/08/09	Cration de la classe
*/
define('cModulIdent',0);
define('cModulOn',1);
define('cModulUse',2);//ancien cModulGroup
define('cModulChg',3);
define('cModulCfg',4);
define('cModulVer',5);
//
define('eAll',0);
define('eHead',1);
define('eSource',2);
define('eOutput',3);
define('eLogout',4);
define('eLogin',5);
define('eMenu',6);
define('eCaptcha',7);
//
//define('eAll',0);
define('eBefore',1);
define('eAfter',2);
class Tmodule {
	public static $cms;
//	protected static $cms;
	public static function set_cms(zpbase $zp) {
	  self::$cms = $zp;
	}
	public static function tools($toolname){
		if (!empty($toolname) && (file_exists(self::$cms->zpath.'/tools/'.$toolname.'.php'))) {
				require_once(self::$cms->zpath.'/tools/'.$toolname.'.php');
		}
	}
/* rsultat: objet, true si ancienne forme de module ou message d'erreur*/
	public static function create_module($modulename) {
	  $ident = $modulename.'.php';
		if (!empty(self::$cms) && !empty($modulename) && array_key_exists($ident,self::$cms->module) && (file_exists(self::$cms->zpath.'/module/'.$ident))) {
//			if (empty(self::$cms->module[$ident][cModulUse])||($_SESSION['zite_admin']==2)||(array_intersect(self::$cms->module[$ident][cModulUse],$_SESSION['zite_usergroup'])!= array())) {
				require_once(self::$cms->zpath.'/module/'.$ident);
				if (class_exists('T'.$modulename)) {
					$modu = 'T'.$modulename;
					try {
						$mo = new $modu($modulename);
						return $mo;
					} catch (Exception $e) {
		    		return (string)$e->getMessage();
					}
				} else {
					return true;
				}
//			} else return self::$cms->get_message('not_allowed');
		} else return self::$cms->get_message('not_possible');
	}
		// Excuter une commande si les droits sur le module sont respects et si mle module est actif (sauf pour On)
	public static function execute_module($modulename,$module,$cmd,$opt='') {
	  $ident = $modulename.'.php';
		if (!empty(self::$cms) && !empty($modulename) && array_key_exists($ident,self::$cms->module) && ($cmd=='On' || $cmd=='Off' || (self::$cms->module[$ident][cModulOn]==1)) && (file_exists(self::$cms->zpath.'/module/'.$ident))) {
			if (empty(self::$cms->module[$ident][cModulUse])||($_SESSION['zite_admin']==2)||(array_intersect(self::$cms->module[$ident][cModulUse],$_SESSION['zite_usergroup'])!= array())) {
				if ($module===true) {
					$m = $modulename.'_do'.$cmd;
					if (function_exists($m)) {
						return $m(self::$cms);
					} else false; // pas une erreur dans ancien systme
				} else if (@is_a($module, 'T'.$modulename)) {
				    $cmd = 'do'.$cmd;
						return $module->$cmd($opt);
				} else {
					  return $module;
				}
			} else return self::$cms->get_message('not_allowed');
		} else return self::$cms->get_message('not_possible');
	}
	protected $module_ini;
	protected $module_opt;
	private $module_optb;//090a15
	protected $module_brother;//090a15
	protected $lang;
	protected $modulename;
	protected $ident;
//	public static isAuth
	function isModuleUse(){		return (empty(self::$cms->module[$this->ident][cModulUse])	||(array_intersect(self::$cms->module[$this->ident][cModulUse],$_SESSION['zite_usergroup'])!= array())	|| $this->isModuleChg() );	}
	function isModuleChg(){		return (($_SESSION['zite_admin']==2)||(isset(self::$cms->module[$this->ident]) && (array_intersect(self::$cms->module[$this->ident][cModulChg],$_SESSION['zite_usergroup'])!= array()))	);	}
/*	protected function _VerifAuth(){
			throw new Exception (self::$cms->get_message('not_allowed'));
		if (self::$cms->module[$this->ident][cModulOn]!=1) {
			throw new Exception(self::$cms->get_message('not_possible'));
	}*/
	protected function __construct($modulename) { // Pour crer un objet depuis un script php il faut utiliser la fonction create_module()
	  $this->module_opt=array();
		$this->modulename = strtolower(trim($modulename));    //		$this->modulename = basename(__FILE__);    // scurit si module appel directement
		if (empty(self::$cms)) throw new Exception('la valeur de cms n\'est pas dfini');
		if (empty($this->modulename)) throw new Exception('le module n\'est pas dfini');
		$this->ident = $this->modulename.'.php';
		if (empty($this->ident) || !array_key_exists($this->ident,self::$cms->module))     //						|| !(file_exists(self::$cms->zpath.'/module/'.$this->ident)))
			throw new Exception(self::$cms->get_message('not_possible'));
/*091		if (!empty(self::$cms->module[$this->ident][cModulUse])&&($_SESSION['zite_admin']!=2)&&(array_intersect(self::$cms->module[$this->ident][cModulUse],$_SESSION['zite_usergroup'])== array()))
			throw new Exception (self::$cms->get_message('not_allowed'));*/
// dbut code module
	if (empty($this->module_ini)) $this->Init();
	}
	function refresh() {
//		$this->docs =  (array)unserialize(@file_get_contents($this->filename));
	}
	function dojob($opt="") {
//		if (!empty(self::$cms->module[$this->ident][cModulUse])&&($_SESSION['zite_admin']!=2)&&(array_intersect(self::$cms->module[$this->ident][cModulUse],$_SESSION['zite_usergroup'])== array()))
		if (!$this->ismoduleUse())
			throw new Exception (self::$cms->get_message('not_allowed'));
		if (self::$cms->module[$this->ident][cModulOn]!=1) {
			throw new Exception(self::$cms->get_message('not_possible'));
		}
			//normaliser les paramtres d'appel du module
	  if (self::$cms->args[0]=='module') array_shift(self::$cms->args);
  }
	function On() {//Appel lorsque le module est activ
		if (($_SESSION['zite_admin']==2)&&(array_key_exists($this->ident,self::$cms->module))) {
			self::$cms->module[$this->ident][cModulOn] = 1;
			self::$cms->writedata(self::$cms->cpath.'/module.dta', self::$cms->module);
			$this->Init();
			self::$cms->messages[$this->modulename.'_admin']= $this->module_ini[$this->lang]['admin'];
			self::$cms->writeconfig(self::$cms->cpath.'/messages.ini', self::$cms->messages);
			$this->Register();
		}
	}
	function Off() {//Appel lorsque le module est dsactiv ou supprim
		if (($_SESSION['zite_admin']==2)&&(array_key_exists($this->ident,self::$cms->module))) {
			self::$cms->module[$this->ident][cModulOn] = 0;
			self::$cms->writedata(self::$cms->cpath.'/module.dta', self::$cms->module);
			$this->Init();
			unset(self::$cms->messages[$this->modulename.'_admin']);
		  self::$cms->writeconfig(self::$cms->cpath.'/messages.ini', self::$cms->messages);
		  self::$cms->unregister_event($this->modulename);
		}
	}
	function Init() {//Initialisation pour fonctionnement du module
		if (!self::$cms->messages) self::$cms->messages = @parse_ini_file(self::$cms->cpath.'/messages.ini', true);
		if (empty($this->module_ini)) $this->module_ini = @parse_ini_file(self::$cms->zpath.'/module/'.$this->modulename.'.ini', true);
		if (empty($this->lang)) $this->lang=$this->module_ini['lang'];
		if (empty($this->module_opt)) {
			if (file_exists(self::$cms->opath.'/'.$this->modulename.'.opt')) {
				$this->module_opt = @parse_ini_file(self::$cms->opath.'/'.$this->modulename.'.opt', true);
			} else $this->Config('init');
			if (isset($this->module_brother)) {
				if (file_exists(self::$cms->opath.'/'.$this->module_brother.'.opt')) {
					$this->module_optb = @parse_ini_file(self::$cms->opath.'/'.$this->module_brother.'.opt', true);
				}
			}
		}
	}
	static function isConfigAuth($modulename){return (($_SESSION['zite_admin']==2)||(isset(self::$cms->module[$modulename.'.php'][cModulCfg])&& array_intersect(self::$cms->module[$modulename.'.php'][cModulCfg],$_SESSION['zite_usergroup'])!= array()));}
	static function isConfig($modulename){return (Tmodule::isConfigAuth($modulename) && (file_exists(self::$cms->zpath.'/module/config/'.$modulename.'.config.php') || file_exists(self::$cms->zpath.'/module/config/'.$modulename.'.opt')));}
	function Config($create=null) {
		if (Tmodule::isConfig($this->modulename)) {
	  	if (file_exists(self::$cms->zpath.'/module/config/'.$this->modulename.'.opt')) {
				return  include self::$cms->zpath.'/module/config/generique.php';
			} elseif (file_exists(self::$cms->zpath.'/module/config/'.$this->modulename.'.config.php')) {
				return  include self::$cms->zpath.'/module/config/'.$this->modulename.'.config.php';
			}
		}
		return false;
	}
	function getOption($option) {return isset($this->module_opt[$option])? $this->module_opt[$option]:$this->module_optb[$option];}
	function get_message($msg, $msgall=true) {return isset($this->module_ini[$this->lang][$msg])?$this->module_ini[$this->lang][$msg]:($msgall?$msg:'');}
	function Event($event,$mode,&$out,$opt=null) {}
	protected function Register() {}
	function __get($id) {throw new Exception("Trying to access undefined property '$id'.");}
  function __set($id,$value) {throw new Exception("Trying to access undefined property '$id'.");}
}
?>
