<?php
/*
module:	Cration de coloration de code source
Copyright Jean-Paul GIAUSSERAND 2010-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
Historique:
	1.1 - 18/11/11  - Passage version 1.0 de codemirror
	1.0 - cration du module
Crdit: Ce module permet d'interfacer ZitePLUS avec le produit CodeMirror-0.67 conu par  Marijn Haverbeke
voir le site http://marijn.haverbeke.nl/codemirror/ pour plus d'informations
La version utilise est une version ne comprenant que les seuls composants utiliss
Voir le rpertoire js/codemirror pour la licence de codemirror
*/
class Tcodemirror extends Tmodule {
	function Register() {
		self::$cms->register_event(eSource,eAfter,$this->modulename);
	}
	function Event($event,$mode,&$out,$opt=null) {
		self::$cms->content['js'].='<script src="js/codemirror/codemirror.js" type="text/javascript"></script>';
		$iscss = ($opt && substr($opt, strlen($opt)-4,4)=='.css')?true:false;
		$out.='<script language="Javascript" type="text/javascript" >
				var editor = CodeMirror.fromTextArea("source", {
				parserfile: ['.($iscss?'"parsecss.js"':'"parsexml.js", "parsecss.js", "tokenizejavascript.js", "parsejavascript.js", "tokenizephp.js", "parsephp.js", "parsephphtmlmixed.js"').'],
				path: "js/codemirror/",
				stylesheet: ['.($iscss?'"js/codemirror/csscolors.css"':'"js/codemirror/xmlcolors.css", "js/codemirror/jscolors.css", "js/codemirror/csscolors.css", "js/codemirror/phpcolors.css"').'],
				continuousScanning: 500 }); </script>';
 }
}
?>
