<?php
/*
module:	Config
Copyright Jean-Paul GIAUSSERAND 2009-2010
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.2	09/12/10	Gestion options de modules
	v1.1	01/05/10	Valeur parlantes
	v1.0	26/12/09	Cration du module
*/
class Tconfig extends Tmodule {
	function dojob($opt="") {
		parent::dojob();
	  if (self::$cms->args[0]=='module') array_shift(self::$cms->args);
			$out='';
			$file = self::$cms->cpath.'/config.ini';
			if (file_exists($file)) {
				ksort(self::$cms->config); // enlever ?
				if (array_key_exists('save', $_POST)) { // Enregistrement
					foreach($_POST as $k => $v) {
						if (substr($k,0,1)=='_') {
							$k2 = substr($k, 1, strlen($k)-1);
							self::$cms->config[$k2] =  htmlentities(stripslashes($v));
						}
					}
					$out .= '<p class="zalert">'.(self::$cms->writeconfig($file, self::$cms->config) ? self::$cms->get_message('done_ok') : self::$cms->get_message('done_failed')).'</p>';
				}
				$i=0;
				$msg = self::$cms->get_message('edit_source');
				$out .= '<form action="'.self::$cms->base.'config" method="post">';
				$out .= '<table style="width:100%">';
				// Section File
				$out .= '<tr><td colspan="2" align="center"><strong>'.$this->get_message('section_file').'</strong></td></tr>';
				$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'"><td><strong>config.ini</strong></td><td><a href="'.self::$cms->base.'source_editor|config.ini">'.$msg.'</a></td></tr>';
				$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'"><td><strong>messages.ini</strong></td><td><a href="'.self::$cms->base.'source_editor|messages.ini">'.$msg.'</a></td></tr>';
				// Section Param
				$out .= '<tr><td colspan="2" align="center"><strong>'.$this->get_message('section_param').'</strong></td></tr>';
				$i=0;foreach(self::$cms->config as $k => $v) {
					$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'"><td><strong>'.$k.'</strong>'.($this->get_message($k.'_desc')!=$k.'_desc'?' : '.$this->get_message($k.'_desc'):'').'</td><td>';
					if ($opt=$this->getOption($k)) {
						$opt=explode('|',$opt);
					  switch($opt[0]) {
					    case 'bool': //$out.='<select name="_'.$k.'"><option value="0">'.$this->get_message($k.'_0').'<option value="1">'.$this->get_message($k.'_1').'</select>';
					      $opt[2]='0:1';
					    case 'list':
								$out.='<select name="_'.$k.'">';
								$list=explode(':',$opt[2]);
								foreach ($list as $k1 => $v1) {
        					$out.='<option value="'.$v1.'"'.($v1==self::$cms->config[$k]?' selected ':'').'>'.$this->get_message($k.'_'.$v1);
								}
								$out.='</select>';
					      break;
						 	default: $out .= '<input name="_'.$k.'" type="text" value="'.$v.'" style="width:80%" '.($opt[0]=='read'?' readonly ':'').'/>';
						 }
					} else $out .= '<input name="_'.$k.'" type="text" value="'.$v.'" style="width:80%" />';
					if ((substr($k, 0, 6)=='files_')&&(!empty($v))) {
					  $out.='<a href="'.self::$cms->base.'source_editor|'.$k.'"><img src=deco/edit.png title="'.self::$cms->get_message('edit_source').'"></a>';
					}
					$out .='</td></tr>';
				}
				// Section Module
				$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'"><td colspan="2" align="center"><input type="submit" name="Submit" value="'.self::$cms->get_message('submit').'" /></td></tr>';
				$out .= '<tr><td colspan="2" align="center"><strong>'.$this->get_message('section_module').'</strong></td></tr>';
				$i=0;foreach (self::$cms->module as $clef => $valeur ) {
				  if (Tmodule::isConfig($valeur[cModulIdent])) {
						$out.='<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'">'."<td><strong>{$valeur[cModulIdent]}<strong></td>".
						'<td align="center">'.('<a href="'.self::$cms->base.'selectmodule|config|'.$clef.'"><img src="deco/config.png"/></a>').'</td>';
					};
				}
				$out.='</tr><tr><td colspan="2">'.$this->get_message('section_module_comment').'</td></tr>';
				$out .= '</table>';
				$out .= '<input type="hidden" name="save" value="1" />';
				$out .= '</form>';
				return $out;
			} else {
				return self::$cms->get_message('errorNOFILE');
			}
	}
}
?>
