<?php
/*
module:	Configuration des options de modules (gnrique)
Copyright Jean-Paul GIAUSSERAND 2008-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : Creative Commons CC-NC-SA
	v2.1  02.11.2011  Ajout de nouveaux types de champs
	v2.0	01/08/2010	Cration du module gnrique de configuration
	v1.0	11/10/2008	Cration de la gestion de la configuration du module
*/
	if (!defined('cOptType')) {
		define('cOptType',0);
		define('cOptDft',1);
		define('cOptMask',2);
		define('cOptNull',3);
	}
//
	$admin = in_array('admin',$_SESSION['zite_usergroup']);
	$file = self::$cms->opath.'/'.$this->modulename.'.opt';
	$out='';
	$optconfig=@parse_ini_file(self::$cms->zpath.'/module/config/'.$this->modulename.'.opt', true);
		// prendre les valeurs par dfaut du module si besoin
	foreach($optconfig as $k => $vopt) {
  	$opt=explode(';',$vopt);
		if (!(isset($this->module_opt[$k]) && strlen($this->module_opt[$k]))) $this->module_opt[$k]= isset($opt[cOptDft])?$opt[cOptDft]:'';
		$$k=(isset($_POST[$k])&& strlen($_POST[$k]))?$_POST[$k]:$this->module_opt[$k];//Fixer valeur variable
		switch($opt[cOptType]) {
/*				case 'bool': $$k=($$k?1:0);break;	case 'list': case 'int': case 'pixel':			  break;*/
				case 'mask':
					$$k=preg_replace($opt[cOptMask],'',$$k);
					$$k=(isset($$k)&& strlen($$k))?$$k:$this->module_opt[$k];//Fixer valeur variable
					break;
				case 'page':
				  if (isset($$k)&&($$k=='*none')) $$k="";
/*				case 'string' :	case 'docimg': case 'color':		  		break;*/
			  default: ;
		}
		if (isset($_POST['userconfigsave'])) {
			$this->module_opt[$k]=$$k;
		}
	}
	if ($create=='init') {
		self::$cms->writeconfig($file, $this->module_opt);
	} else if ($admin) {
		if (isset($_POST['userconfigabort'])) {
		} else {
			if (isset($_POST['userconfigsave'])) {
				($res=self::$cms->writeconfig($file, $this->module_opt))?self::$cms->msgShow('done_ok') : self::$cms->msgShow('done_failed');
				if ($res!==false) return true;
				$this->module_opt = @parse_ini_file($file, true); // remettre les anciennes valeurs
			}
			$readonly = $admin ? '':'readonly ';
			self::$cms->content['js'].='<script type="text/javascript" src="js/jscolor/jscolor.js"></script>';
			$out = '<form method="post" action="'.self::$cms->base.implode('|',self::$cms->args).'" enctype="multipart/form-data"><table class="ztable">';
			$out .= '<tr><td colspan="2"><center><h2>'.$this->get_message('title').'</h2></center></td></tr>';
			$out .= '<tr><td colspan="2"><center><h2>'.$this->get_message('CONFIGURATION').'</h2></center></td></tr>';
			$out .= '</table><table class="ztable">';
			//
			$out.='<tr><td></td><td></td></tr>';
				// gnrer les champs de saisie
		  $i=0;foreach($optconfig as $k => $vopt) {
  		  $out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'"><td>'.$this->get_message($k).' : '.$this->get_message($k.'_desc',false).'</td><td>';
		    $v=$optconfig[$k];// ou $$k
		    $opt=explode(';',$vopt);
				if ($opt) {
					switch($opt[cOptType]) {
						case 'bool': //$out.='<select name="_'.$k.'"><option value="0">'.$this->get_message($k.'_0').'<option value="1">'.$this->get_message($k.'_1').'</select>';
					  	$opt[2]='0:1';
				  	case 'list':
							$out.='<select name="'.$k.'">';
							$list=explode(':',$opt[cOptMask]);
							foreach ($list as $k1 => $v1) {
	  	    			$out.='<option value="'.$v1.'"'.($v1==$$k?' selected ':'').'>'.$this->get_message($k.'_'.$v1).'</option>';
							}
							$out.='</select> ';
				  	  break;
				  	case 'int': 
				  		$out .= '<input name="'.$k.'" type="text" value="'.$$k.'" style="width:60px;text-align:right" /> ';
				  		  break;
						case 'string' : case 'mask':
				  		$out .= '<input name="'.$k.'" type="text" value="'.$$k.'" style="text-align:right" /> ';
				  	  break;
						case 'read':
			  			$out .= '<input name="'.$k.'" type="text" value="'.$$k.'" style="width:60px;text-align:right" readonly/> '; // voir
						  break;
						case 'docimg':
							$out.='<select name="'.$k.'" size=1>';
							foreach (self::$cms->docs as $clef => $doc)
								if ($doc[cDocType]=='img') $out .= '<option value="'.$clef.'" '.($clef==$$k?' selected':'').' >'.$clef.'</option>';
								$out.='</select>';
						  break;
						case 'page':																																																																		/** Ajouter *none*/
							$out.='<select name="'.$k.'" size=1><option value="*none"></option>';
							foreach (self::$cms->struct as $clef => $pg) {
								if ($pg[cPageOn]&&self::$cms->isPageAuth($i,cPageRead,array('all'))) $out .= '<option value="'.$pg[cPageIdent].'" '.($pg[cPageIdent]==$$k?' selected':'').' >'.str_repeat('&nbsp;',3*($pg[cPageRang]-1)).$pg[cPageTitre].'</option>';
								}
								$out.='</select>';
						  break;
						case 'color':
				  		$out .= '<input class="color {hash:true,caps:false}" name="'.$k.'" type="text" id="'.$k.'" value="'.$$k.'" style="text-align:left" size="10" '.$readonly.'/> <i>'.$this->get_message('color',false).'</i> ';
						  break;
						case 'pixel':
				  		$out .= '<input name="'.$k.'" type="text" value="'.$$k.'" style="text-align:right" size="4" '.$readonly.'/> <i>'.$this->get_message('pixel',false).'</i> ';
						  break;
						case 'none':
						 	$out .= '<input name="'.$k.'" type="text" value="inactif" readonly/>';
						  break;
					 	default: $out .= '<input name="'.$k.'" type="text" value="'.$$k.'" style="width:80%" '.($opt[cOptType]=='read'?' readonly ':'').'/>';
					}
				} else $out .= '<input name="'.$k.'" type="text" value="'.$$k.'" style="width:80%" />';//impossible depuis changement
			$out.=' <i>'.$this->get_message($k.'_desc2',false).'</i></td></tr>';
			}
			$out .= '<tr><td colspan="2"><input type="submit" name="userconfigsave" value="'.self::$cms->get_message('confirm').'" /> <input type="submit" name="userconfigabort" value="'.self::$cms->get_message('abort').'" /></td></tr></table></form>';
		}
	}
	return $out;
?>
