<?php
/*
module:	Gestion des groupes utilisateurs
Copyright Jean-Paul GIAUSSERAND 2008-2010
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.2  18/12/2010  gestion magic_quotes
	v1.1: Passage en code objet
	v1.0: cration du module
*/
require_once(Tmodule::$cms->zpath.'/outils.php');
class Tgroupes extends Tmodule {
	function dojob($opt="") {
	  parent::dojob();
//args: 0=groupes, 1=ident, 2=new|edit|delete|
		if ($_SESSION['zite_admin']) {
			$file = self::$cms->cpath.'/group.dta';
			$f = (array)unserialize(@file_get_contents($file));
			$out='';
			//
			if (isset($_POST['name'])) {//valeur renvoy par le formulaire
				$name = no_mq_gpc(strtolower(trim($_POST['name'])));
//				$name = preg_replace('/[^a-z0-9_-\' ]/','',$name);
				$desc = no_mq_gpc($_POST['desc']);
			} elseif (isset(self::$cms->args[1])) {//valeur initiale du formulaire
			  $name = no_mq_gpc(strtolower(trim(self::$cms->args[1])));
				$desc = $f[$name];
			} else {// formulaire vierge
			  $name = $desc = '';
			}
				// actions et sauvegarde
			if (isset($_POST['abort'])) {
		  	self::$cms->args[2]='';
			} elseif (isset($_POST['save'])&& $_POST['save']==1) {
				if (array_key_exists($name,$f)) {
					if ($_POST['delete']==1) {  // effacement du groupe
					  if ($name!='admin' && $name!='webmaster' && $name!='logon') {//Ne pas effacer les groupes systmes
							unset($f[$name]);
						}	else $zite->prepend('<div class="zalert">'.self::$cms->get_message('done_failed').'</div>');
					} else {
					  $f[$name] = $desc;
					}
				} else {
						$f[$name] = $desc;
				}
				self::$cms->writedata($file, $f);
			}
			// formulaire
			$out .= '<form method="post" action="'.self::$cms->base.'groupes" enctype="multipart/form-data"><table class="ztable">';
			$out .= '<tr><td colspan="2"><center><h2>'.$this->get_message('title').'</h2></center></td></tr>';
			$out .= '<tr><td align="left">'.count($f).' '.strtolower($this->get_message('admin')).'</td><td align="right"><a href="'.self::$cms->base.'groupes||new"><img src="deco/a.png" />Ajouter</a></td></tr>';
			$out .= '</table><table class="ztable">';
			if (!empty(self::$cms->args[2])) {
				$del = self::$cms->args[2]=='delete';  // Mode suppression actif
				$out .= '<tr><td colspan="2"><h3>'.$this->get_message( $del ? 'confirmdel' : (self::$cms->args[2]=='new' ? 'new' : 'edit')).' </h3></td></tr>';
				$out .= '<tr><td>'.$this->get_message('groupename').'</td><td><input name="name" type="text" id="name" value="'.$name.'" '.($del ? 'readonly' : '').' /></td></tr>';
				$out .= '<tr><td>'.$this->get_message('coldesc').'</td><td><input name="desc" type="text" id="desc" value="'.$desc.'" '.($del ? 'readonly' : '').' size=80%/></td></tr>';
				if ($del) $out .= '<tr><td></td><td><input name="delete" type="checkbox" value="1" '.($del ? 'checked' : '').' /> '.self::$cms->get_message('files_delwarning').'</td></tr>';
				$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.self::$cms->get_message($del?'confirm':'send').'" /><input name="save" type="hidden" value="1" /> <input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr></table></form>';
			}
			// liste de tous les groupes
			uksort($f, create_function('$a, $b', 'return strcmp($a[0], $b[0]);'));
			$out .= '<table class="ztable">';
			$out .= '<tr class="headcolor"><td>'.$this->get_message('colname').'</td><td>'.$this->get_message('coldesc').'</td><td></td></tr>';
			$i=0;foreach ($f as $clef => $valeur	) {
				$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'"><td><a href="'.self::$cms->base.'groupes|'.$clef.'|edit">'.strtoupper($clef).'</a></td><td>'.$valeur.'</td>';
				$out .= '<td align="center"><a href="'.self::$cms->base.'groupes|'.$clef.'|delete"><img src="deco/e1.png" /></a></td></tr>';
				}
			$out .= '</table>';
			return $out;
		} else {
			return self::$cms->get_message('not_allowed');
		}
 	}
}
?>