<?php
/*
module:	MIGRATION - Module de migration de zite/zite+/ziteplus vers ZitePLUS
Copyright Jean-Paul GIAUSSERAND 2008-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.16 migration vers la 0.9.2 + slection des migrations utiles
	v1.15 prise en compte user.css + correction print.css
	v1.14 chg dtection permission sur fichier data
	v1.13 modification de la migration du fichier messages.ini
	v1.12 migration vers 0.9.1
	v1.11 prise en compte de php 5.3
	v1.10 prise en compte serveur bridant accs script (Free)
	v1.9  prise en compte des options de modules
	v1.8  migration du template.php pour utiliser les nouveaux types de panneaux latraux
	      Intgration migration Zite0.6.7
	v1.7  Intgration migration Zite0.6.4, 0.6.5 et 0.6.6 vers zite+
	      Prise en compte nouveau modle de panneau latral, simplification processus de migration
	v1.6  Passage de la gestion des fichiers  la gestion des documents
	v1.0	Cration du module de migration de zite0.6.2beta vers zite+
*/
	function migration_dojob(zite &$zite) {
		$modulename = basename(__FILE__);    // scurit si module appel directement (ancienne forme module)
		if (empty($modulename) || !array_key_exists($modulename,$zite->module)
						|| ($zite->module[$modulename][cModulOn]!=1)
						|| !(file_exists($zite->zpath.'/module/'.$modulename)))
			return $zite->get_message('not_possible');
		if (!empty($zite->module[$modulename][cModulUse])&&($_SESSION['zite_admin']!=2)&&(array_intersect($zite->module[$modulename][cModulUse],$_SESSION['zite_usergroup'])== array()))
			return $zite->get_message('not_allowed');
		//
		function majifnodestfile($src,$dst,$file) {
		  if (!file_exists($dst.'/'.$file)) {
				rename($src.'/migration/'.$file, $dst.'/'.$file);
			} else @unlink($src.'/migration/'.$file);
		}
		function majifsrcfile($src,$dst,$file) {
		  if (file_exists($src.'/migration/'.$file)) {
				if (file_exists($dst.'/'.$file)) unlink($dst.'/'.$file);
				rename($src.'/migration/'.$file, $dst.'/'.$file);
			}
		}
		function rm($src){
      foreach (glob($src.'/*') as $file) {
				if (is_dir($file)) {
					rm($file);
				} else {
				  @unlink($file);
				}
      }
			@rmdir($src);
		}
/*juste pour la mise au point */
error_reporting(E_ALL);
/* */
    $out = '';
		if (isset($zite->args[1])&&($zite->args[1]=='ok')) {
			@set_time_limit(0);
			if (!is_dir($zite->opath)) mkdir($zite->opath);//20090927-v090a6 - Cration rpertoire des options
			if (!file_exists($zite->cpath.'/ztemp')) mkdir($zite->cpath.'/ztemp'); //20091010-v090a9
			if (!file_exists($zite->cpath.'/ztemp/files')) mkdir($zite->cpath.'/ztemp/files'); //091a13
			if (!is_dir($zite->dpath)) mkdir($zite->dpath); //26.05.2009-v0.8.3.a1 - Mise en place gestion des documents privatifs
			if (!file_exists($zite->dpath.'/thumbs')) mkdir($zite->dpath.'/thumbs'); //20091010-v090b6
			if (!file_exists($zite->ipath.'/js')) mkdir($zite->ipath.'/js');//v091a8
			if (!file_exists($zite->ipath.'/skin')) mkdir($zite->ipath.'/skin');//v091b1
				//09.08.2009-v0.8.3.a9 - simplification processus de migration: ajout des fichiers "system"
			if (file_exists($zite->zpath.'/migration')) {
				majifsrcfile($zite->zpath,$zite->ipath.'/deco','kr0.png');
				majifsrcfile($zite->zpath,$zite->ipath.'/deco','kr1.png');
				majifsrcfile($zite->zpath,$zite->ipath.'/deco','kw0.png');
				majifsrcfile($zite->zpath,$zite->ipath.'/deco','kw1.png');
				majifsrcfile($zite->zpath,$zite->ipath.'/deco','kc0.png');
				majifsrcfile($zite->zpath,$zite->ipath.'/deco','kc1.png');
				majifsrcfile($zite->zpath,$zite->ipath.'/deco','s0.png');
				majifsrcfile($zite->zpath,$zite->ipath.'/deco','s1.png');
				majifsrcfile($zite->zpath,$zite->ipath.'/deco','help.png'); //092rc1
//			majifnodestfile($zite->zpath,$zite->ipath.'/deco','dl1.png');//plus en 091a1
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','z1.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','edit.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pnl01.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl1.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl1g.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl2.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl2g.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl3.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl3g.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl4.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl4g.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl5.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl6.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl7.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','pl8.png');
//				majifnodestfile($zite->zpath,$zite->ipath.'/deco','fichier.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','docs.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','godocs.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','search.png');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','checkv.png');
				majifsrcfile($zite->zpath,$zite->ipath,'image_list.php');
				majifsrcfile($zite->zpath,$zite->ipath,'link_list.php');
				majifsrcfile($zite->zpath,$zite->ipath,'media_list.php');
				majifnodestfile($zite->zpath,$zite->ipath.'/deco','config.png');
				if (file_exists($zite->zpath.'/migration/group.dta')) unlink($zite->zpath.'/migration/group.dta');
				if (file_exists($zite->zpath.'/migration/module.dta')) unlink($zite->zpath.'/migration/module.dta');
				majifsrcfile($zite->zpath,$zite->ipath,'view.php');
				majifsrcfile($zite->zpath,$zite->ipath,'thumb.php');
				majifsrcfile($zite->zpath,$zite->opath,'config.opt');
				majifnodestfile($zite->zpath,$zite->ipath,'print.css');
				  //
/* plus en 091 => car importation nouvelle version complte de tinymce version 327 avec tous les plugins ZitePLUS
				if (file_exists($zite->zpath.'/migration/tinybrowser.zip')) {
					if (!file_exists($zite->ipath.'/tinymce/plugins/tinybrowser')) {////090b2: browser pour tinymce ! il faut paramtrer le rpertoire tinymce !!
						require_once($zite->zpath.'/pclzip.lib.php');
					  $archive = new PclZip($zite->zpath.'/migration/tinybrowser.zip');
	        	$dest = $zite->ipath.'/tinymce/plugins';
					  if ($archive->extract(PCLZIP_OPT_PATH, $dest) == 0) {
					    die("Error : ".$archive->errorInfo(true));  // un peu brutal !!!!!!!!!
						}
						unset($archive);
					}
					unlink($zite->zpath.'/migration/tinybrowser.zip');
				}
				majifsrcfile($zite->zpath,$zite->ipath.'/tinymce/plugins/tinybrowser/js','tinybrowser.js.php');
				majifsrcfile($zite->zpath,$zite->ipath.'/tinymce/plugins/tinybrowser','tb_tinymce.js.php');
				majifsrcfile($zite->zpath,$zite->ipath.'/tinymce/plugins/tinybrowser','fns_tinybrowser.php');
				majifsrcfile($zite->zpath,$zite->ipath.'/tinymce/plugins/tinybrowser','tinybrowser.php');
				majifsrcfile($zite->zpath,$zite->ipath.'/tinymce/plugins/tinybrowser','config_tinybrowser.php');
				majifsrcfile($zite->zpath,$zite->ipath.'/tinymce/plugins/tinybrowser/js','tinybrowser.js.php');*/
					//
				if (file_exists($zite->zpath.'/migration/uploadify.zip')) {
					if (!file_exists($zite->ipath.'/js/uploadify')) {
						require_once($zite->zpath.'/pclzip.lib.php');
					  $archive = new PclZip($zite->zpath.'/migration/uploadify.zip');
	        	$dest = $zite->ipath.'/js';
					  if ($archive->extract(PCLZIP_OPT_PATH, $dest, PCLZIP_OPT_REPLACE_NEWER) == 0) {       													// attention aux fichiers nouveaux: cd update_092
					    die("Error : ".$archive->errorInfo(true));  // un peu brutal !!!!!!!!!
						}
						unset($archive);
					}
					unlink($zite->zpath.'/migration/uploadify.zip');
				}
					//
/*				if (file_exists($zite->zpath.'/migration/codemirror.zip')) {
					if (!file_exists($zite->ipath.'/js/codemirror')) {
						require_once($zite->zpath.'/pclzip.lib.php');
					  $archive = new PclZip($zite->zpath.'/migration/codemirror.zip');
	        	$dest = $zite->ipath;
					  if ($archive->extract(PCLZIP_OPT_PATH, $dest) == 0) {
					    die("Error : ".$archive->errorInfo(true));  // un peu brutal !!!!!!!!!
						}
						unset($archive);
					}
					unlink($zite->zpath.'/migration/codemirror.zip');
				}*/
				//
				if (file_exists($zite->zpath.'/migration/jscolor.zip')) {
					if (!file_exists($zite->ipath.'/js/jscolor')) {
						require_once($zite->zpath.'/pclzip.lib.php');
					  $archive = new PclZip($zite->zpath.'/migration/jscolor.zip');
	        	$dest = $zite->ipath.'/js';
					  if ($archive->extract(PCLZIP_OPT_PATH, $dest, PCLZIP_OPT_REPLACE_NEWER) == 0) {
					    die("Error : ".$archive->errorInfo(true));  // un peu brutal !!!!!!!!!
						}
						unset($archive);
					}
					unlink($zite->zpath.'/migration/jscolor.zip');
				}
				if (file_exists($zite->zpath.'/migration/tigra_calendar.zip')) {
					if (!file_exists($zite->ipath.'/js/tigra_calendar')) {
						require_once($zite->zpath.'/pclzip.lib.php');
					  $archive = new PclZip($zite->zpath.'/migration/tigra_calendar.zip');
	        	$dest = $zite->ipath.'/js';
					  if ($archive->extract(PCLZIP_OPT_PATH, $dest, PCLZIP_OPT_REPLACE_NEWER) == 0) {
					    die("Error : ".$archive->errorInfo(true));  // un peu brutal !!!!!!!!!
						}
						unset($archive);
					}
					unlink($zite->zpath.'/migration/tigra_calendar.zip');
				}
				@rmdir($zite->zpath.'/migration');
			} // fin rpertoire migration
//
			if (!file_exists($zite->cpath.'/event.dta')) {
			  $zite->event=array();
		  	$zite->writedata($zite->cpath.'/event.dta',$zite->event);
			}
//
	    if (!file_exists($zite->cpath.'/group.dta')) {
				unset($zite->group);  // cration des groupes de base
				$zite->group['admin'] = 'Administrateur du site';   // passer en choix de langue
		  	$zite->group['webmaster'] = 'Webmestre du site';
		  	$zite->group['logon'] = 'Tous les utilisateurs signs';
       	$zite->writedata($zite->cpath.'/group.dta', $zite->group);
			}
			if (!isset($zite->group['logon'])) {//v090a10
        $zite->group =(array)unserialize(@file_get_contents($zite->cpath.'/group.dta'));
				$zite->group['logon'] = 'Tous les utilisateurs signs';
        $zite->writedata($zite->cpath.'/group.dta', $zite->group);
			}
//				    if (!file_exists($zite->cpath.'/user.dta')) {
//							unset($zite->user);   // Cration des utilisateurs de base
								// Reprise des utilisateurs  version 0.6.x de zite
			if (isset($zite->config['login_adminname'])) {
					  		$zite->user[$zite->config['login_adminname']] = array($zite->config['login_adminpass'],'Administrateur du site',array('admin'));
					  		$zite->user[$zite->config['login_username']] = array($zite->config['login_userpass'],'Webmestre du site',array('webmaster'));
//					  		$zite->user['webmaster'][0] = $zite->config['login_userpass'];  // prendre le mme login que user: correction 0.8.2.a13 // enlever 0.8.3
			}
      $zite->writedata($zite->cpath.'/user.dta', $zite->user);
//            	}
           // Enlever les entres du fichier de configuration qui ne servent plus dans ziteplus
			unset($zite->config['login_adminname']);
			unset($zite->config['login_adminpass']);
			unset($zite->config['login_username']);
			unset($zite->config['login_userpass']);
			unset($zite->config['argsep']);   //v090a1:pas utilis
			unset($zite->config['plugins']);  //v090a5:pas utilis (module en ziteplus)
			if (empty($zite->config['editor'])) $zite->config['editor']='tinymce';
      if (!isset($zite->config['navig_admin'])) $zite->config['navig_admin']='';
// 11.11.2009-v0.9.0.b4 - enlever rights_structure car plus utile avec ziteplus
			unset($zite->config['rights_structure']);
							// Ajouter les nouvelles entre
//pas encore						if (!isset($zite->config['statistic'])) $zite->config['statistic']='off';
			if (!isset($zite->config['url_rewriting'])) {	$zite->config['url_rewriting'] = $zite->rewrite?1:0;		} //082a7 - Mise en paramtre de l'URL rewriting et du Multiviews (Free)
			if (!isset($zite->config['page_compress'])) {	$zite->config['page_compress'] = 0;			} 	//083b7 - cration paramtre de compression du site inactif par dfaut
			if (!isset($zite->config['user_cgu'])) {	$zite->config['user_cgu']=0;			} 	//090a3
//090a8
			if (!isset($zite->config['menu_type'])) {	$zite->config['menu_type']=0;			}
			if (!isset($zite->config['page_date'])) { $zite->config['page_date']=1; 		}
//091a3
			if (!isset($zite->config['files_stylebase'])) {	$zite->config['files_stylebase']='';	}
			if (!isset($zite->config['files_stylecms']))  {	$zite->config['files_stylecms']='cms.css';	}
			if (!isset($zite->config['files_styleskin'])) {	$zite->config['files_styleskin']=''; }
			if (!isset($zite->config['files_styleprint'])) {	$zite->config['files_styleprint']='print.css';	}//091b5
//091b8
			if (!isset($zite->config['files_styleuser'])) {	$zite->config['files_styleuser']='';	}
   		if (isset($zite->config['files_style'])) {	// On vient d'une version pr skin ;-)
			 	$zite->config['files_stylebase']='base.css';//092rc1
			 	$zite->config['files_styleskin']=$zite->config['files_style'];//092rc1
					// 13.02.2009-v0.8.1.a2 - Correction erreur feuille de style de zite 0.6
				$cssfile=$zite->ipath.'/'.$zite->config['files_style'];//files_style avant
				$css = file_get_contents($cssfile);
				if (strpos($css,'madding:')!==false) $css=str_replace('madding:','padding:',$css);
        if (strpos($css,'mapping:')!==false) $css=str_replace('mapping:','padding:',$css);
				if (strpos($css,'.zerr {')===false)  $css .= "\n.zerr {\n\t\tborder: 1px solid #C00;\n\t\tbackground-color: #FEA;\n\t\tpadding: 0 1px;\n}\n"; //v090a10
				if (strpos($css,'.headcolor')===false) $css .= "\n.headcolor{background-color:#cccccc;}\n.oddcolor{background-color:#dddddd;}\n.evencolor{background-color:#eeeeee;}\n"; //v091b1
				if (file_exists($zite->zpath.'.css')) {
				  $css.="\n\t".file_get_contents($zite->zpath.'.css');
				  unlink($zite->zpath.'.css');
					}
    		file_put_contents($cssfile,$css);
        copy($cssfile, $zite->ipath.'/base.css');
				unset($zite->config['files_style']);
				unset($zite->config['files_zite']);
			}
			switch($zite->config['site_status']) {
				case 'on' : $zite->config['site_status']=1; break;
				case 0 : case 1 : break;
				default: $zite->config['site_status']=0;
			}
			if (!isset($zite->config['site_debug'])) {	$zite->config['site_debug']=0;	}	//091a20
//
			$zite->writeconfig($zite->cpath.'/config.ini', $zite->config);   // Mise  jour config.ini
//
 						  // Modifier le fichier structure.dta pour les droits en lecture et criture
    	   		foreach ($zite->struct as $idpage => &$page) {
    	   		  $page[cPageWrite] = $page[cPageWrite]==1 ? array() : ($page[cPageWrite]==0 ? array() : $page[cPageWrite]);
//    	   		  $page[cPageWrite] = $page[cPageWrite]==1 ? array() : ($page[cPageWrite]==0 ? array('webmaster') : $page[cPageWrite]);
    	   		  $page[cPageRead] = empty($page[cPageRead]) ? array() : $page[cPageRead];
							$g=strtolower(empty($page[cPageWrite])?'':implode(':',$page[cPageWrite]));
							$page[cPageWrite]=empty($g)?array():explode(':',$g);
							$g=strtolower(empty($page[cPageRead])?'':implode(':',$page[cPageRead]));
							unset($page['cPageread']);  // bug introduit par 0.8.0 beta: il manquait la masjuscule  la constante
							$page[cPageRead]=empty($g)?array():explode(':',$g);
							if (empty($page[cPageTitre])) {//v081b8: cration type de page sans titre dans le menu
							  $page[cPageTitre]='Nom de page  dfinir';//$this->get_message('page_default_title');
							  $page[cPageType] |= pgbitMenu;
							}
						}
						$zite->writeStruct(true); // Mise  jour structure des pages
							// mettre le nom des groupes en minuscule - version 0.7.x  0.8.0 beta 1
            $zite->group=array_change_key_case($zite->group,CASE_LOWER);
						$zite->writedata($zite->cpath.'/group.dta', $zite->group);
						foreach ($zite->module as $clef => &$valeur) {
							$g=strtolower(empty($valeur[2])?'':implode(':',$valeur[2]));
							$valeur[2]=empty($g)?array():explode(':',$g);
						}
						$zite->writedata($zite->cpath.'/module.dta', $zite->module);
						foreach ($zite->user as $clef => &$valeur) {
							$g=strtolower(empty($valeur[2])?'':implode(':',$valeur[2]));
							$valeur[2]=empty($g)?array():explode(':',$g);
             	if (!in_array('logon',$valeur[2])) $valeur[2][]='logon';  // Tous les utilisateurs font partis de ce groupe
						}
						$zite->writedata($zite->cpath.'/user.dta', $zite->user);
							//
							// Mettre  jour les messages
							//
						if (!$zite->messages) $zite->messages = @parse_ini_file($zite->cpath.'/messages.ini', true);
            $msg=&$zite->messages;
            if (!isset($msg['error401'])) $msg['error401']="<h1>PETIT PROBLEME</h1>	Unauthorized -	Accs  la ressource refus";
            if (!isset($msg['groupes_name'])) $msg['groupes_name']="<b>NOM</b>";
            if (!isset($msg['groupes_desc'])) $msg['groupes_desc']="<b>DESCRIPTION</b>";
            if (!isset($msg['groupes_groupname'])) $msg['groupes_groupname']="Nom du groupe :";
            if (!isset($msg['user_username'])) $msg['user_username']="Nom de l'utilisateur :";
            if (!isset($msg['user_password'])) $msg['user_password']="Mot de passe :";
            if (!isset($msg['selectgroup_read'])) $msg['selectgroup_read']="Gestion des droits en CONSULTATION de la page :";
            if (!isset($msg['selectgroup_write'])) $msg['selectgroup_write']="Gestion des droits en MODIFICATION de la page ";
            if (!isset($msg['selectgroup_commentread'])) $msg['selectgroup_commentread']="Remarque: si aucun groupe n'est slectionn, tout le monde a accs  la page";
            if (!isset($msg['selectgroup_commentwrite'])) $msg['selectgroup_commentwrite']="Remarque: si aucun groupe n'est slectionn, seul l'administrateur peut modifier la page";
            if (!isset($msg['sitemap'])) $msg['sitemap']="<b>Plan du Site</b>";
            if (!isset($msg['send'])) $msg['send']="Envoyer";
            if (!isset($msg['confirm'])) $msg['confirm']="Confirmer";
            if (!isset($msg['abort'])) $msg['abort']="ANNULER";
            if (!isset($msg['errLOGIN'])) $msg['errLOGIN']="Utilisateur inconnu ou mauvais mot de passe";
            if (!isset($msg['migration_admin'])) $msg['migration_admin']="MIGRATION";//fin-091a21
            if (!isset($msg['connect'])) $msg['connect']="Connexion";
							// Enlever les valeurs obsoltes pour diminuer le poids du fichier des messages gnraux
            unset($msg['login_form']);
						unset($msg['module_admin']);
						unset($msg['module_title']);
						unset($msg['module_colname']);
						unset($msg['module_colon']);
						unset($msg['module_colgroup']);
						unset($msg['module_confirmdel']);
						unset($msg['module_group']);
						unset($msg['selectmodule_comment']);
						unset($msg['files_open']);  	//0.8.3.a10
						unset($msg['files_delete']);
						unset($msg['files_new']);
						unset($msg['savesite_title']);		// 0.8.3.b6
						unset($msg['savesite_zdata']);
						unset($msg['savesite_zfiles']);
						unset($msg['savesite_alldata']);
						unset($msg['user_edit']);  	// 0.9.0.a2
						unset($msg['user_new']);
						unset($msg['user_delete']);
						unset($msg['user_desc']);
						unset($msg['user_colname']);
						unset($msg['user_coldesc']);
						unset($msg['user_colgroup']);
						unset($msg['user_group']);
						unset($msg['groupes_edit']);// 0.9.1.a10
						unset($msg['groupes_new']);
						unset($msg['groupes_delete']);
						unset($msg['sitemapxml_title']);//091a20
						unset($msg['edit_title']);//091a21
						unset($msg['edit_permaname']);//091a21
//						unset($msg['0']);unset($msg['1']);unset($msg['2']);unset($msg['3']);unset($msg['4']);unset($msg['5']);unset($msg['6']);unset($msg['7']);
						$_SESSION['showadminbar'] = true;
						if (!isset($msg['login_showadminbar'])) $msg['login_showadminbar']='Afficher la barre d\'administration';
						if (!isset($msg['login_returnpage'])) $msg['login_returnpage']='Rester sur la page en cours aprs la connexion';
            $zite->writeconfig($zite->cpath.'/messages.ini', $msg);
            unset($zite->messages); // force une relecture du fichier des messages
            $zite->get_message('bidon');
//
				// Prendre version des donnes de ziteplus
			$dataversion=$zite->version(false);if (empty($dataversion)) $dataversion='000';
//			print_r($dataversion);			exit;
/**
 *Gestion des modifications du template
 * */
				// Gestion des modifications du template
			$templatechanged=false;
			$template = file_get_contents($zite->ipath.'/'.$zite->config['files_template']);
			if (empty($dataversion)||($dataversion<='089')){
					// 13.02.2009-v0.8.1.a2- Correction du fichier template: erreur <!DOCT	YPE  au lieu de <!DOCTYPE
				if (strpos($template,"<!DOCT	YPE")!==false) {
     				$template=str_replace('<!DOCT	YPE',"<!DOCTYPE",$template);
						$templatechanged=true;
				}
     	  	// 13.02.2009-v0.8.1.a2 - Cosmtique: passage de Zite  ZitePlus
				if (strpos($template,'<a href="http://zite.prositif.com">ZITE')!==false) {
      		$template=str_replace('<a href="http://zite.prositif.com">ZITE CMS','<a href="http://www.giausserand.fr/index.php?perma=ziteplus">',$template);
					$templatechanged=true;
				}
					// 04.05.2009-v08a4 - Correction feuille de style dans le template prise dans fichier de configuration
				if (strpos($template,'<link href="style.css"')!==false) {
      		$template=str_replace('<link href="style.css"','<link href="<?php echo $zite->config[\'files_style\'] ?'.'>"',$template);
					$templatechanged=true;
				}
					//10.05.2009-v0.8.2.a15 - Retrait modif de la version a12 pour le multiview (free) et mise nouvelle version
				$temp = '<?php echo ($zite->rewrite===2?"<base href=\"http://{$_SERVER[\'SERVER_NAME\']}".dirname($_SERVER[\'SCRIPT_NAME\']).\'"/>\':\'\') ?'.'>';
				if (strpos($template,$temp)!==false) {
      		$template=str_replace($temp,'',$template);
					$templatechanged=true;
				}
				unset($temp);
				if (strpos($template,'($zite->rewrite===2?')===false) {
      		$template=str_replace('<head>',"<head>\n".'<?php echo ($zite->rewrite===2?\'<base href="\'.$zite->rewritebase.\'"/>\':"") ?'.'>',$template);
					$templatechanged=true;
				}
			}
			if (empty($dataversion)||($dataversion<='090')){
					//19.08.2009-v0.8.3.a20 - Ajout des metatags dans le template: description et keywords
				if (stripos($template,'echo $zite->get_data(\'site_keywords\')')!==false) {//v090a5: migration metags zite>067
      		$template=str_ireplace('echo $zite->get_data(\'site_keywords\')','echo $zite->content["page_keyword"]',$template);
					$templatechanged=true;
				}
				if (stripos($template,'echo $zite->get_data(\'site_description\')')!==false) {//v090a5: migration metatags zite>067
      		$template=str_ireplace('echo $zite->get_data(\'site_description\')','echo $zite->content["page_desc"]',$template);
					$templatechanged=true;
				}
				if (stripos($template,'<META NAME="description" CONTENT')!==false) {//v090a5: passage en minuscule
      		$template=str_ireplace('<META NAME="description" CONTENT','<meta name="description" content',$template);
					$templatechanged=true;
				}
				if (stripos($template,'<META NAME="keywords" CONTENT')!==false) {//v090a5: passage en minuscule
      		$template=str_ireplace('<META NAME="keywords" CONTENT','<meta name="keywords" content',$template);
					$templatechanged=true;
				}
				if (stripos($template,'"];?'.'>">')!==false) {//v090a10: ajout / manquant fin tag meta
      		$template=str_ireplace('"];?'.'>">','"];?'.'>" />',$template);
					$templatechanged=true;
				}
				if (stripos($template,'$zite->content["page_keyword"]')===false) {
      		$template=str_ireplace('</title>',"</title>\n".'<meta name="keywords" content="<?php echo $zite->content["page_keyword"];?'.'>" />',$template);
					$templatechanged=true;
				}
				if (stripos($template,'$zite->content["page_desc"]')===false) {
      		$template=str_ireplace('</title>',"</title>\n".'<meta name="description" content="<?php echo $zite->content["page_desc"];?'.'>" />',$template);
					$templatechanged=true;
				}
			}
      	//10.01.2010-v091a3 - Ajout gestion feuille de style
			if (stripos($template,'->head()')===false) {//correction092b1
				$template=preg_replace('@<link href=.+files_style.+/>@is', '<?php echo $this->head(); ?'.">", $template);
				$templatechanged=true;
			}
				//20110220-v091b8 - Suppression print.css dans le template:  <link href="print.css" rel="stylesheet" type="text/css" media="print" />
			if (stripos($template,'print.css')!==false) {
				$template=preg_replace('@<link href=.+print\.css.+media=[\'"]print["\'].+/>@is', '', $template);
				$templatechanged=true;
			}
				//v091a4:ajout #oppside dans le template
			if (stripos($template,'content[\'pnl4\']')===false) {
      	$template=str_ireplace('<div id="side"','<?php if (!empty($this->content[\'pnl4\'])) { echo \'<div id="oppside">\'.$this->content[\'pnl4\'].\'</div>\';} ?'.'>'."\n".'<div id="side"',$template);
				$templatechanged=true;
			}
			if (empty($dataversion)||($dataversion<='090')){
  	      //090a4/a5 - Ajout des positions de panneaux dans le template
				if (strpos($template,'$zite->content[\'pnl2\']')===false) {
      		$template=str_replace('$zite->content[\'menu\']','$zite->content[\'pnl2\'].$zite->content[\'menu\'].$zite->content[\'pnl3\']',$template);
					$templatechanged=true;
				}
				if (strpos($template,'$zite->content[\'pnl7\']')===false) {
      		$template=str_replace('$zite->content[\'main\']','$zite->content[\'pnl7\'].$zite->content[\'main\'].$zite->content[\'pnl8\']',$template);
					$templatechanged=true;
				}
				if (strpos($template,'$zite->content[\'pnl5\']')===false) {//Mettre haut de page faon Zite+
				  if (($pos1=stripos($template, '<div id="top'))!==false) {
				  			$pos2=stripos($template,'>',$pos1);
								$pos3 = $pos1;
								$pos4 = $pos2;
							  while ($pos3 && ($pos3<$pos4)) {
							    $pos3 = stripos($template,'<div',$pos3+1);
							    $pos4 = stripos($template,'</div',$pos4+1);
								}
								$pgtxt = substr($template, $pos2+1, $pos4-$pos2-1);
								$pgtxtout = str_replace('<?php echo $zite->get_content(\'_Top\', true);?'.'>','',$pgtxt);  //enlever haut de page faon Zite 0.6.7
								$pgtxtout = trim(str_replace("\t",'',$pgtxtout));
								$z = $zite->page_from_ident('_Top');
								if ($z===false) {
									$z = count($zite->struct)+1;
									$zite->struct[$z][cPageIdent] = '_Top';
									$zite->struct[$z][cPageTitre] = '_Haut';
								} else {
				    				if (file_exists($zite->cpath.'/_Top.txt')&&($pgtxtout == file_get_contents($zite->cpath.'/_Top.txt'))) $pgtxtout='';
								}
								$zite->struct[$z][cPageRang] = 1;
								$zite->struct[$z][cPageType] = 2; //PHP par dfaut
								$zite->struct[$z][cPageOn] = 1 ;
								$zite->struct[$z][cPageWrite] = array();
								$zite->struct[$z][cPageRead] = array();
							  $zite->struct[$z][cPageType] |= pgbitPosSide;
								$zite->struct[$z][cPageOpt] = 16;
								$zite->writeStruct(true); // Mise  jour structure des pages
      					$template=str_replace($pgtxt,'<?php echo $zite->content[\'pnl5\'] ?'.'>',$template);
								$templatechanged=true;
	    					file_put_contents($zite->cpath.'/_Top.txt',$pgtxtout, FILE_APPEND);
	    				}
						}
					if (strpos($template,'$zite->content[\'pnl6\']')===false) {//Mettre bas de page faon Zite+
						  if (($pos1=stripos($template, '<div id="bot'))!==false) {//vrifier si template standard
							  $pos2=stripos($template,'>',$pos1);
								$pos3 = $pos1;
								$pos4 = $pos2;
							  while ($pos3 && ($pos3<$pos4)) {
							    $pos3 = stripos($template,'<div',$pos3+1);
							    $pos4 = stripos($template,'</div',$pos4+1);
								}
								$pgtxt = substr($template, $pos2+1, $pos4-$pos2-1);
								$pgtxtout = str_replace('<?php echo $zite->get_content(\'_Bot\', true); ?'.'>','',$pgtxt);  //enlever bas de page faon Zite 0.6.7
								$pgtxtout = trim(str_replace("\t",'',$pgtxtout));
								$z = $zite->page_from_ident('_Bot');
								if ($z===false) {
									$z = count($zite->struct)+1;
									$zite->struct[$z][cPageIdent] = '_Bot';
									$zite->struct[$z][cPageTitre] = '_Bas';
								} else {
				    				if (file_exists($zite->cpath.'/_Bot.txt')&&($pgtxtout == file_get_contents($zite->cpath.'/_Bot.txt'))) $pgtxtout='';
								}
								$zite->struct[$z][cPageRang] = 1;
								$zite->struct[$z][cPageType] = 2; //PHP par dfaut
								$zite->struct[$z][cPageOn] = 1 ;
								$zite->struct[$z][cPageWrite] = array();
								$zite->struct[$z][cPageRead] = array();
							  $zite->struct[$z][cPageType] |= pgbitPosSide;
								$zite->struct[$z][cPageOpt] = 32;
								$zite->writeStruct(true); // Mise  jour structure des pages
	      				$template=str_replace($pgtxt,'<?php echo $zite->content[\'pnl6\'] ?'.'>',$template);
								$templatechanged=true;
		    				file_put_contents($zite->cpath.'/_Bot.txt',$pgtxtout, FILE_APPEND);
							}
					}
				// suppimer page _zite.txt inutile
				if (file_exists($zite->cpath.'/_Zite.txt')) {
					unlink($zite->cpath.'/_Zite.txt');
					$z = $zite->page_from_ident('_Zite');
					if ($z!==false) {
						$max = count($zite->struct);
						for($i=$z; $i<$max; $i++) $zite->struct[$i] = $zite->struct[$i+1];
						unset($zite->struct[$max]);
						$zite->writeStruct(true);
					}
				}
				// suppimer page _login.txt inutile
				if (file_exists($zite->cpath.'/_Login.txt')) {
					unlink($zite->cpath.'/_Login.txt');
					if ($z!==false) {
						$z = $zite->page_from_ident('_Login');
						$max = count($zite->struct);
						for($i=$z; $i<$max; $i++) $zite->struct[$i] = $zite->struct[$i+1];
						unset($zite->struct[$max]);
						$zite->writeStruct(true);
					}
				}
			}
			if (empty($dataversion)||($dataversion<='089')){
					// 05.04.2009-v081b9 - Correction du template pour module latral dans menu
				if (strpos($template,'<?php echo $zite->get_content(1156957918, true) ?'.'>')!==false) {
     			$template=str_replace('<?php echo $zite->get_content(1156957918, true) ?'.'>'."\r\n",'',$template);
     			$template=str_replace('<?php echo $zite->get_content(1156957918, true) ?'.'>','',$template);
					$templatechanged=true;
    			  // rechercher le module latral standard et faire les changements
					$z=-1;//au lieu de 1 !!!
					foreach ($zite->struct as $k => $v) {
						if ($v[cPageIdent]=='1156957918') $z=$k;
					}
					if ($z!=-1) { // Page latrale par dfaut trouv !!
					  $zite->struct[$z][cPageType] |= pgbitPosSide;
					  $zite->struct[$z][cPageOpt] = 4;
					  $zite->struct[$z][cPageOn] = 1 ;
						  $max = count($zite->struct);
					  $zite->swap2($z,$max);
						$zite->writeStruct(true); // Mise  jour structure des pages
					}
				}
					// 20.09.2009-v083b2 - Migration panneau latral version ziteplus antrieure
				$change = false;
				foreach ($zite->struct as $k => &$page) {
					if (($page[cPageType]&pgbitPosSide)==pgbitPosSide) {//0.8.3.a20: par dfaut, panneau latral de menu
					  if (!isset($page[cPageOpt]) || ($page[cPageOpt]==0)) {
					    $page[cPageOpt]=1;
							$change = true;
						}
					}
				}
				if ($change) $zite->writeStruct(true); // Mise  jour structure des pages
				unset($change);
			}
			  //092: Mettre  jour le fichier template.php si modifi
			if ($templatechanged===true) {
 				file_put_contents($zite->ipath.'/'.$zite->config['files_template'],$template);
			};
			unset($templatechanged);
/**
 *Fin-Gestion des modifications du template
 * */
//v091a2-dtermination si menu gauche ou droit
						if(!file_exists($zite->ipath.'/'.'cms.css')) {
							if (preg_match('/#side.+float +: +right/is', $css)) {
	              $cmscss="#oppside {float:left;}\n#side {float:right;}";
							} else { $cmscss .= "#oppside {float:left;}\n#side {float:right;}"; }
							$cmscss.='#page{overflow:auto;} #mid{clear:both;display:block;} #side{ display:block;} #main{overflow:auto;min-width:1px;display:block;} #top{clear:both;} #break{clear:both;} #bot{clear:both;}';
						  file_put_contents($zite->ipath.'/'.'cms.css',$cmscss);
						}
						if(!file_exists($zite->ipath.'/'.'base.css')) {  // Normalement, ne doit jamais arriver car copie plus haut
						  file_put_contents($zite->ipath.'/'.'base.css','');
						}
// 05.03.2009-v0.8.1.b1 - intgration nouveau module GA en mode inactif
						if (file_exists('zplus/module/ga.php')&&file_exists('zplus/module/ga.ini')) {
						  if (!isset($zite->module['ga.php'])) {
								$file = $zite->cpath.'/module.dta';
								$module = &$zite->module;
								$module['ga.php'] = array('ga', 0,array('admin'));
			 					$zite->writedata($file, $module);
							}
			 			}
// 22.03.2009-v0.8.1.b4 - intgration assistant cration de page
						if (file_exists('zplus/module/page_new.php')) {
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							if (!isset($zite->module['page_new.php'])) {//092b1
								$module['page_new.php'] = array('page_new', 1,array('logon'));
				 				$zite->writedata($file, $module);
					 			$mo = Tmodule::create_module('page_new'); $mo->On(); unset($mo);
			 				} elseif ($module['page_new.php'][cModulUse]==array()) {//091a13
								$module['page_new.php'][cModulUse] = array('logon');
				 				$zite->writedata($file, $module);
							 }
						}
//01.05.2009-v0.8.2.a3 - selectmodule est maintenant un module
						if (file_exists('zplus/module/selectmodule.php')&& !isset($zite->module['selectmodule.php'])) {
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['selectmodule.php'] = array('selectmodule', 1,array('admin'));
				 			$zite->writedata($file, $module);
				 			$mo = Tmodule::create_module('selectmodule'); $mo->On(); unset($mo);
						}
//v090a2 - intgration module de configuration
						if (file_exists('zplus/module/config.php')&& !isset($zite->module['config.php'])) {
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['config.php'] = array('config', 0,array('admin'));
				 			$zite->writedata($file, $module);
				 			$mo = Tmodule::create_module('config'); $mo->On(); unset($mo);
						}
//v090a2 - intgration module d'administration des pages
						if (file_exists('zplus/module/page_admin.php')){
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							if (!isset($zite->module['page_admin.php'])) {
								$module['page_admin.php'] = array('page_admin', 0,array('logon'));
					 			$zite->writedata($file, $module);
					 			$mo = Tmodule::create_module('page_admin'); $mo->On(); unset($mo);
							} elseif ($module['page_admin.php'][cModulUse]==array()) {//091a13
								$module['page_admin.php'][cModulUse] = array('logon');
				 				$zite->writedata($file, $module);
							 }
						}
//24.05.2009-v0.8.2.b1 - intgration module de recherche
						if (file_exists('zplus/module/search.php')&& !isset($zite->module['search.php'])) {
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['search.php'] = array('search', 0,array()); // accessible  tout le monde
				 			$zite->writedata($file, $module);
				 			$mo = Tmodule::create_module('search'); $mo->On(); unset($mo);
						}
//13.10.2009-v0.9.0.a10 - ajout user_cgu + user_auto (non activ)
						if (file_exists('zplus/module/user_cgu.php') && !isset($zite->module['user_cgu.php'])) {
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['user_cgu.php'] = array('user_cgu', 0,array()); // accessible  tout le monde
				 			$zite->writedata($file, $module);
						}
						if (file_exists('zplus/module/user_auto.php') && !isset($zite->module['user_auto.php'])) {
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['user_auto.php'] = array('user_auto', 0,array()); // accessible  tout le monde
				 			$zite->writedata($file, $module);
						}
						if (file_exists('zplus/module/rubrique.php') && !isset($zite->module['rubrique.php'])) {//v091a5
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['rubrique.php'] = array('rubrique', 0,array('admin'));//?logon plutt
				 			$zite->writedata($file, $module);
				 			$mo = Tmodule::create_module('rubrique'); $mo->On(); unset($mo);
						}
						if (file_exists('zplus/module/photoshow.php') && !isset($zite->module['photoshow.php'])) {//v091a15
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['photoshow.php'] = array('photoshow', 0,array());
				 			$zite->writedata($file, $module);
				 			$mo = Tmodule::create_module('photoshow'); $mo->On(); unset($mo);
						}
						if (file_exists('zplus/module/rss.php') && !isset($zite->module['rss.php'])) {//v091a20
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['rss.php'] = array('rss', 0,array('admin'));
				 			$zite->writedata($file, $module);
				 			$mo = Tmodule::create_module('rss'); $mo->On(); unset($mo);
						}
						if (file_exists('zplus/module/skin.php') && !isset($zite->module['skin.php'])) {//v091a5
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['skin.php'] = array('skin', 0,array('admin'));
				 			$zite->writedata($file, $module);
				 			$mo = Tmodule::create_module('skin'); $mo->On(); unset($mo);
						}
						if (file_exists('zplus/module/codemirror.php') && !isset($zite->module['codemirror.php'])) {//v091a20
							$file = $zite->cpath.'/module.dta';
							$module = &$zite->module;
							$module['codemirror.php'] = array('codemirror', 0,array('admin'));
				 			$zite->writedata($file, $module);
				 			$mo = Tmodule::create_module('codemirror'); $mo->On(); unset($mo);
						}
//091b8 Intgration libell certains modules si migration depuis zitecms
						if (isset($module['groupes.php'])&&empty($zite->messages['groupes_admin'])) {	$mo = Tmodule::create_module('groupes'); $mo->On(); unset($mo); }
						if (isset($module['user.php'])&&empty($zite->messages['user_admin'])) {	$mo = Tmodule::create_module('user'); $mo->On(); unset($mo); }
						if (isset($module['sitemapxml.php'])&&empty($zite->messages['sitemapxml_admin'])) {	$mo = Tmodule::create_module('sitemapxml'); $mo->On(); unset($mo); }
						if (isset($module['savesite.php'])&&empty($zite->messages['savesite_admin'])) {	$mo = Tmodule::create_module('savesite'); $mo->On(); unset($mo); }
//10.05.2009-v0.8.2.a10 - Modification du fichier index.php car l'url rewriting est maintenant paramtrable
						$indexphp = file($zite->ipath.'/index.php',FILE_SKIP_EMPTY_LINES);
						$newindexphp = ''; $ismodif=false;
						foreach ($indexphp as $value) {
						  if (trim($value)&&(strpos($value, '$zite->rewrite')===false)&&(strpos($value,"la rcriture d'URL")===false)) {
						    $newindexphp .= $value;
							} else $ismodif=true;
						}
						if (stripos($newindexphp,'$cms')===false) {//v091a4     <---------------------------------------  finir et supprimer $zite
						  $ismodif=true;
						  $newindexphp=str_ireplace('& new zite(__FILE__)','new zite(__FILE__)', $newindexphp);
              $newindexphp=str_ireplace('$zite', '$cms', $newindexphp);
              $newindexphp=str_ireplace('zite(__FILE__)','zite(__FILE__); $zite=&$cms',$newindexphp);
						}
						if ($ismodif) file_put_contents($zite->ipath.'/index.php',$newindexphp);
						unset($indexphp); unset($newindexphp); unset($ismodif);
//26.05.2009-v0.8.3.a1 - Mise en place gestion des documents privatifs
						if (!file_exists($zite->cpath.'/docs.dta')) {
              file_put_contents($zite->cpath.'/docs.dta', serialize(array()));
						}
						if (file_exists('zplus/module/selectdoc.php')&&file_exists('zplus/module/selectdoc.ini')) {
							if (!isset($zite->module['selectdoc.php'])) {
								$file = $zite->cpath.'/module.dta';
								$module = &$zite->module;
								$module['selectdoc.php'] = array('selectdoc', 1,array()); // accessible  tout le monde
				 				$zite->writedata($file, $module);
				 				$mo = Tmodule::create_module('selectdoc'); $mo->On(); unset($mo);
			 				}
						}
						if (file_exists('zplus/module/rubrique.php')&&file_exists('zplus/module/rubrique.ini')) {
							if (!isset($zite->module['rubrique.php'])) {
								$file = $zite->cpath.'/module.dta';
								$module = &$zite->module;
								$module['rubrique.php'] = array('rubrique', 1,array('admin'));
				 				$zite->writedata($file, $module);
				 				$mo = Tmodule::create_module('rubrique'); $mo->On(); unset($mo);
			 				}
						}
							//08.08.2009-v0.8.3.a8 - Migration FICHIERS vers DOCUMENTS
						if (empty($dataversion)||($dataversion<='089')){
							if (file_exists($zite->cpath.'/files.dta')) { // copier les fichiers
								require_once $zite->zpath.'/tdocsadmin.php';
								$zdocs = new Tdocsadmin($zite->cpath.'/docs.dta');
								$file = $zite->cpath.'/files.dta';
								$f = (array)unserialize(@file_get_contents($file));
								foreach($f as $key => $v) {
									$ident=$v[1].'.'.$v[2]; $filename=$ident; $ext=$v[2]; $desc=$v[0]; $type=''; $auth=''; $groupW=array(); $groupR=array(); $docdate='';
									$zdocs->verifdoc($filename,$ident,$ext,$rub,$desc,$auth,$groupW,$groupR,$type,$docdate);
  	             	rename($zite->ipath.'/zfiles/'.$v[1].'.'.$v[2], $zite->dpath.'/'.$filename);
//								$zdocs->updateDoc($ident,$filename,$ext,stringToArray($rub),$desc,$auth, $groupW,        $groupR,$type,$docdate);
//092							$zdocs->updateDoc($ident,$filename,$ext,array(),            $desc,'admin',array('admin'),array(),$type,date("d/m/Y",filemtime($zite->ipath.'/zfiles/'.$v[1].'.'.$v[2])));
									$zdocs->updateDoc($ident,$filename,$ext,array(),            $desc,$auth,  $groupW,       $groupR,$type,date("d/m/Y",filemtime($zite->ipath.'/zfiles/'.$v[1].'.'.$v[2])));
//								touch($zite->dpath.'/'.$filename,filemtime($this->ipath.'/zfiles/'.$v[1].'.'.$v[2]));
								}
							  	// Mettre  jour le contenu des pages
								$f = (array)unserialize(@file_get_contents($zite->cpath.'/structure.dta'));
								foreach($f as $key => $page) {
								  $filename = $zite->cpath.'/'.$page[cPageIdent].'.txt';
								  if (file_exists($filename)) {
								  	$s=file_get_contents($filename);
								  	if ($s!==FALSE) {
		      						$s=str_replace('zfiles/','view.php/',$s);//'index.php?doc=',$s);
		      						$timemaj=filemtime($filename);
	            		    file_put_contents($filename, $s,LOCK_EX);
		              	  touch($filename,$timemaj);
										}
									}
								}
									//17.08.2009-v0.8.3.a15	- Mettre  jour le template
							  $filename = $zite->ipath.'/'.$zite->config['files_template'];
								if (file_exists($filename)) {
							  	$s=file_get_contents($filename);
							  	if ($s!==FALSE) {
		    	 					$s=str_replace('zfiles/','view.php/',$s);//'index.php?doc=',$s);
		     						$timemaj=filemtime($filename);
	          	 	    file_put_contents($filename, $s,LOCK_EX);
		          	    touch($filename,$timemaj);
									}
								}
								unset($zdocs);
					  		$zite->docs = new Tdocs($zite->cpath.'/docs.dta');
							}
					  	@rmdir($zite->ipath.'/zfiles'); 			//correction v090a5: Efface le rpertoire si pas vide
						}/**Fin migration des fichiers vers les documents*/
						if (file_exists($zite->cpath.'/files.dta')) unlink($zite->cpath.'/files.dta');  //correction v090a5
							// Cosmtique: passage de Zite  ZitePlus                               <------------------------- Mettre expression rgulire !!!
						$temp = file_get_contents($zite->cpath.'/'.'_Bot.txt');
						if (strpos($temp,'Site motoris par ZiteCMS 0.6.5')!==false) {
      				$temp=str_replace('Site motoris par ZiteCMS 0.6.5','Site motoris par <a href="http://www.giausserand.fr/index.php?perma=ziteplus"> '.ZITEVER. '</a>',$temp);
	    				file_put_contents($zite->cpath.'/'.'_Bot.txt',$temp);
						}
						if (strpos($temp,'Site motoris par ZiteCMS 0.6.6')!==false) {
      				$temp=str_replace('Site motoris par ZiteCMS 0.6.6','Site motoris par <a href="http://www.giausserand.fr/index.php?perma=ziteplus"> '.ZITEVER. '</a>',$temp);
	    				file_put_contents($zite->cpath.'/'.'_Bot.txt',$temp);
						}
							  // Mettre  jour le contenu des pages pour nouveau test 090a15
						$f = (array)unserialize(@file_get_contents($zite->cpath.'/structure.dta'));
						foreach($f as $key => $page) {
						  $filename = $zite->cpath.'/'.$page[cPageIdent].'.txt';
						  if (file_exists($filename)) {
						  	$s=file_get_contents($filename);
						  	if ($s!==FALSE) {
	      					$s=str_replace('index.php?doc=','view.php/',$s);
	      					$timemaj=filemtime($filename);
            	    file_put_contents($filename, $s,LOCK_EX);
	                touch($filename,$timemaj);
								}
							}
						}
						  // Voir s'il faut renregistrer certain module
/* 15.03.2009-v0.8.2.a1 - Crer rperoire forum
						if (!is_dir($zite->cpath.'/zforum')) {
              mkdir($zite->cpath.'/zforum', 0700);
						}
						if (!file_exists($zite->cpath.'/zforum/verrou.dta')) {
              file_put_contents($zite->cpath.'/zforum/verrou.dta', '1');
						}
						if (!file_exists($zite->cpath.'/zforum/ident.dta')) {
              file_put_contents($zite->cpath.'/zforum/ident.dta', '1');
						}*/
							// Mise  jour
							// Correction droits sur documents
						require_once $zite->zpath.'/tdocsadmin.php';
						$docs=new Tdocsadmin($zite->cpath.'/docs.dta'); $changes=false;
						foreach($docs as $key => $doc) {
						  $change=false;
						  if (!is_array($doc[cDocWrite])) $doc[cDocWrite]=array('admin');
							if (in_array('admin',$doc[cDocWrite])) {
							  $doc[cDocWrite]= array_diff($doc[cDocWrite],array('admin'));
							  $change=true;
							}
						  if (!is_array($doc[cDocRead])) $doc[cDocRead]=array('admin');
							if (in_array('admin',$doc[cDocRead])) {
							  $doc[cDocRead]= array_diff($doc[cDocRead],array('admin'));
							  $change=true;
							}
						}
//						if ($changes) $docs->save();
						$docs->compact($change);
						unset($changes);unset($docs);
						$zite->docs->refresh();
						  // Migration vers nouveau zplus
						if (!file_exists('zplus')) {
//						  mkdir('zplus');
						}
							// Mise  jour vers la 092
						if (file_exists('zplus/module/update.php')&&file_exists('zplus/module/update.ini')) {
							if (!isset($zite->module['update.php'])) {
								$file = $zite->cpath.'/module.dta';
								$module = &$zite->module;
								$module['update.php'] = array('update', 1,array('admin'));
				 				$zite->writedata($file, $module);
				 			}
				 			$mo = Tmodule::create_module('update'); $mo->On(); $mo->Off(); unset($mo);
							unset($module['update.php']);
			 				$zite->writedata($file, $module);
						}
							// Mettre la nouvelle verion des donnes
						//081b7 - ajout de la version dans fichier de config pour faciliter migration
						$zite->config['version']=ZITEVER;
						$zite->writeconfig($zite->cpath.'/config.ini', $zite->config);   // Mise  jour config.ini
							//
						  // Mise  jour de tinyMCE
						if (!file_exists('tinymce/tinymce344-1.txt')) {
//						  if (file_exists('tinymce')) @rename('tinymce','tinymce.'.time());// Il faudrait effacer le rpertoire, mais trs consommateur en temps CPU ( faire de manire diffrente)
						  $zip='tinymce344.zip';
						  $lzip=$zite->cpath.'/ztemp/'.$zip;
							if (!ini_get('allow_url_fopen')) {
								function GetRemoteFileContent($url){
  								$curl = curl_init();  // Initialiser cURL.
								  curl_setopt($curl, CURLOPT_URL, $url);  // Indiquer quelle URL rcuprer
								  curl_setopt($curl, CURLOPT_HEADER, 0);  // Ne pas inclure l'header dans la rponse.
								  curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			            $txt=curl_exec($curl);  // Excuter la requte.
			  					curl_close($curl);  // Fermer cURL.
								  return $txt;
								}
								file_put_contents($lzip,GetRemoteFileContent('http://www.giausserand.fr/view.php/ziteplus.zip?path='.$zip));
							}	else copy('http://www.giausserand.fr/view.php/ziteplus.zip?path='.$zip,$lzip);
							require_once($zite->zpath.'/pclzip.lib.php');
//							$archive=new PclZip($zip);$archive->extract(PCLZIP_OPT_PATH,'.',PCLZIP_OPT_REMOVE_PATH,'tinymce',PCLZIP_OPT_SET_CHMOD, 0775);unset($archive);unlink($zip);
//							chmod('tinymce',0775);
						  $archive = new PclZip($lzip); $dest = $zite->ipath.'/';
				  		if ($archive->extract(PCLZIP_OPT_PATH, $dest, PCLZIP_OPT_REPLACE_NEWER) == 0) {
				    		die("Error : ".$archive->errorInfo(true));  // un peu brutal !!!!!!!!!
							}
							unset($archive);
							unlink($lzip);
						}
						  //
						rm('zite');
							//
						$zite->msgShow('Migration Faite/Done');
						 //header('Location: '.$zite->base.'migration|done');
						//exit ;
			} else if (isset($zite->args[1])&&($zite->args[1]=='done')) {
						$zite->prepend('<div class="zalert">'.$zite->get_message('done_ok').'</div>');
						$out .= 'done';
						}
    else {
			$out .= '<br><br>MIGRATION '.($zite->config['version']?'de la version <b>'.$zite->config['version'].'</b> vers la version <b>'.ZITEVER.'</b>' :'').' ?<p class="zalert"><a href="'.$zite->base.'migration|ok">'."MIGRATION ZITE/ZITEPLUS -> <strong>".ZITEVER."</strong></a></p>";
			$out .= '<br><center><h2>Soyez prudent !</h2><h2>Sauvegardez toujours votre site<br> avant de faire une mise  jour de version</h2></center>';
		}
		function checktoimg($b){
			return $b?(file_exists('deco/checkv.png')?'<img src="deco/checkv.png" alt="Ok">':'Ok'):'<img src="deco/e1.png">';
		}
/**/
	// Petite vrification pour l'utilisateur
		clearstatcache();
		$out.='<table class="ztable">';
		$out.='<tr class="zerr"><td width="250px">Vrification de base</td><td>Etat</td><td>Commentaire</td></tr>';
		$out.='<tr><td>Editeur TinyMCE</td><td>'.checktoimg(is_dir('tinymce')).'</td></tr>';
		$out.='<tr><td style="padding-left:20px">Version 3.4.4</td><td>'.checktoimg(file_exists($zite->ipath.'/tinymce/tinymce344-1.txt')).'</td></tr>';
		$out.='<tr><td style="padding-left:20px">TinyBrowser</td><td>'.checktoimg(is_dir($zite->ipath.'/tinymce/plugins/tinybrowser')).'</td></tr>';
		$out.='<tr><td style="padding-left:20px">PhotoShow</td><td>'.checktoimg(is_dir($zite->ipath.'/tinymce/plugins/photoshow')).'</td></tr>';
		$out.='<tr><td>Rpertoire des options</td><td>'.checktoimg(is_dir($zite->opath)).'</td></tr>';
		$out.='<tr><td>Rpertoire de travail</td><td>'.checktoimg(is_dir($zite->cpath.'/ztemp')).'</td></tr>';
		$out.='<tr><td>Rpertoire des documents</td><td>'.checktoimg(is_dir($zite->dpath)).'</td></tr>';
		$out.='<tr><td>Rpertoire des miniatures</td><td>'.checktoimg(is_dir($zite->dpath.'/thumbs')).'</td></tr>';
		$out.='<tr><td>Donnes modifiables</td><td>'.checktoimg(is_writable($zite->cpath)).'</td></tr>';
		$out.='<tr><td>Propritaire du script: </td><td>'.get_current_user().'</td></tr>';
		$test=$zite->cpath.'/ztemp/tstdr.txt';
		file_put_contents($test, 'tst');
		$prov=stat($test);
    unlink($test);
		$out.='<tr><td>Propritaire du script: UID</td><td>'.getmyuid().'</td></tr>';
		$out.='<tr><td>Propritaire fichier donnes: UID</td><td>'.$prov['uid'].'</td><td>La valeur devrait tre la mme que prcdemment</td></tr>';
		$out.='<tr><td>Propritaire du script: GID</td><td>'.getmygid().'</td></tr>';
		$out.='<tr><td>Propritaire fichier donnes: GID</td><td>'.$prov['gid'].'</td><td>La valeur devrait tre la mme que prcdemment</td></tr>';
		$out .= '</table>';
		return $out;
  }
?>