<?php
/*
module:	Assistant cration de page
Copyright Jean-Paul GIAUSSERAND 2009-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.10 Passage en module objet
	v1.9 Ajout description permalien
	v1.8 Correction bug IE lors de la cration d'une page
	v1.7 Les urls peuvent dsormais tre en majuscules
	v1.6 Correction: support des ancres dans les URL
	v1.5 Correction cration panneau latral: ajout cPageOpt=1
	v1.4 Correction du contrle de validit des URL externes
	v1.3 Possibilit d'ouvrir une URL dans une nouvelle fentre
	v1.2 Ajout du type panneau latral
	v1.1 Ajout d'un assistant de cration de page
	v1.0 Rcriture de l'ajout de page sous forme modulaire
pg_type =	1 : page HTML
					2 : page PHP
					5 : URL
*/
		/* args[1]='n' ou 'm' args[2]=n page args[3]=1 si pas premire page*/
class Tpage_new extends Tmodule {
	function dojob($opt="") {
	  parent::dojob();
		$is_pg_new = self::$cms->args[1]=='n';
		$max = count(self::$cms->struct);
		$np = $max+1; //!!!!!
		$err='';
//		$admin = $_SESSION['self::$cms_admin']==2;
		$webmaster = in_array('webmaster',$_SESSION['zite_usergroup']);
		$admin = in_array('admin',$_SESSION['zite_usergroup']);
		$tools =  $admin || ($webmaster &&(self::$cms->isPageAuth(self::$cms->args[2],cPageWrite)));
			// Oprations
		if ($tools) {   //  affiner
			if (isset(self::$cms->args[3])) {
				$ident = preg_replace('/[^A-z0-9_-]/','',$_POST['ident']);
				$pg_type=(((int)$_POST['pg_type'])&~(pgbitMenu|pgbitPosSide)) | (int)$_POST['pg_visumenu'] | (int)$_POST['pg_position'];
				$pg_titre = htmlentities(stripslashes($_POST['pg_titre']));
				$pg_url = $_POST['pg_url'];
				$pg_target = empty($_POST['pg_target'])?0:$_POST['pg_target'];
				$pg_typurl = $_POST['pg_typurl'];
				if (empty($pg_type)) $err = '<p class="zalert">'.$this->get_message('pg_errnotype').'</p>';
			} else if (!$is_pg_new) {
			  $ident = self::$cms->struct[self::$cms->args[2]][cPageIdent];
			  $pg_type = (int)self::$cms->struct[self::$cms->args[2]][cPageType];
			  $pg_titre = self::$cms->struct[self::$cms->args[2]][cPageTitre];
			  $pg_url = self::$cms->struct[self::$cms->args[2]][cPageIdent];
			  $pg_target = isset(self::$cms->struct[self::$cms->args[2]][cPageOpt]['target'])?1:0;
				$pg_typurl = (int)(self::$cms->struct[self::$cms->args[2]][cPageOpt]['typurl']);
			} else{
				$ident = time();
				$pg_titre = self::$cms->get_message('page_default_title')." [$np]";
				$pg_url = 'http://www.google.fr'; $pg_target =  0; $pg_typurl = 0;
				$pg_type= 1;
			}
			$out='';
			  // dfinir la fonction javascript qui gre la visibilit des champs de saisie en dynamique
			self::$cms->content['js'].='<script language="Javascript" type="text/javascript"> function monaction(form) { if (form.rb1.checked||form.rb2.checked){document.getElementById("identpage").style.display="";document.getElementById("visumenu").style.display="";document.getElementById("position").style.display="";} else {document.getElementById("identpage").style.display="none";document.getElementById("visumenu").style.display="none";document.getElementById("position").style.display="none";}'
				.'if (form.rb1.checked||form.rb2.checked||form.rb5.checked){document.getElementById("nompage").style.display="";} else {document.getElementById("nompage").style.display="none";} '
				.'if (form.rb5.checked){document.getElementById("urlmenu").style.display=""} else {document.getElementById("urlmenu").style.display="none"} '
				.' }</script>'
				.'<script language="Javascript" type="text/javascript"> function monactionurl(form) {'
				.' if (form.rbtypurl0.checked){document.getElementById("pg_url").value="http://www.google.fr";}'
				.' if (form.rbtypurl1.checked){document.getElementById("pg_url").value="index.php?perma=";}'
				.' if (form.rbtypurl2.checked){document.getElementById("pg_url").value="index.php?z=sitemap";}'
				.' if (form.rbtypurl3.checked){document.getElementById("pg_url").value="index.php?z=login";}'
				.' if (form.rbtypurl4.checked){document.getElementById("pg_url").value="index.php?z=search";}'
				.' }</script>';
			$qetat = isset(self::$cms->args[3])?self::$cms->args[3]:1;
			$out .= '<form name="pagenew" method="post" action="'.self::$cms->base.'page_new|'.self::$cms->args[1].'|'.self::$cms->args[2].'|'.$qetat.'" enctype="multipart/form-data"><table class="ztable">';
			$out .= '<tr><td colspan="3"><h2><center>'.$this->get_message(($is_pg_new?'pg_title':'pg_titlemodif')).'</center></h2><td></tr>';
/*			switch($qetat) {
			  case 1 :*/
					if ($is_pg_new) {
						$out .= '<tr><td colspan="2">'.$this->get_message('pg_questiontype').'</td></tr>';
					}
					$out .= '<tr><td width="5%"></td><td><input type="radio" name="pg_type" id="rb1" value="'.(1+($pg_type&~pgbitType)).'" '.(($pg_type&pgbitType)==1?'checked':'').($is_pg_new?'':' disabled ').' onclick="monaction(this.form);">'.$this->get_message('pg_HTML').'</td></tr>';
					$out .= '<tr><td width="5%"></td><td><input type="radio" name="pg_type" id="rb2" value="'.(2+($pg_type&~pgbitType)).'" '.(($pg_type&pgbitType)==2?'checked':'').($is_pg_new?'':' disabled ').' onclick="monaction(this.form);">'.$this->get_message('pg_PHP').'</td></tr>';
					$out .= '<tr><td width="5%"></td><td><input type="radio" name="pg_type" id="rb5" value="'.(5+($pg_type&~pgbitType)).'" '.(($pg_type&pgbitType)==5?'checked':'').' onclick="monaction(this.form);">'.$this->get_message('pg_Menu').'</td></tr>';
//					$out .= '<tr><td width="5%"></td><td><input type="radio" name="pg_type" id="rb7" value="'.(5+($pg_type&~pgbitType)).'" '.(($pg_type&pgbitType)==7?'checked':'').' onclick="monaction(this.form);">'.$pg_ini[$lang]['pg_Sitemap'].'</td></tr>';
					$out .= '</table>';
							// pav: Voulez-vous voir la page dans le menu
					$out .= '<table id="visumenu" class="ztable" '.(($pg_type&pgbitMenu)|($pg_type&pgbitType)==5?'style="display:none;"':'').'>';
					$out .= '<tr><td colspan="2">'.$this->get_message('pg_visumenu').'</td></tr>';
					$out .= '<tr><td width="5%"></td><td><input type="radio" name="pg_visumenu" value="0" '.($pg_type&pgbitMenu?'':'checked').' onclick="monaction(this.form);">'.$this->get_message('pg_yes').'</td></tr>';
					$out .= '<tr><td width="5%"></td><td><input type="radio" name="pg_visumenu" value="'.pgbitMenu.'" '.($pg_type&pgbitMenu?'checked':'').' onclick="monaction(this.form);">'.$this->get_message('pg_no').'</td></tr>';
					$out .= '<tr><td colspan="2">'.$this->get_message('pg_visumenudesc').'</td></tr>';
					$out .= '</table>';
							// pav: position de la page
					$out .= '<table id="position" class="ztable" '.(($pg_type&pgbitMenu)|($pg_type&pgbitType)==5?'style="display:none;"':'').'>';
					$out .= '<tr><td colspan="2">'.$this->get_message('pg_position').'</td></tr>';
					$out .= '<tr><td width="5%"></td><td><input type="radio" name="pg_position" value="0" '.($pg_type&pgbitPosSide?'':'checked').' onclick="monaction(this.form);">'.$this->get_message('pg_positionstd').'</td></tr>';
					$out .= '<tr><td width="5%"></td><td><input type="radio" name="pg_position" value="'.pgbitPosSide.'" '.($pg_type&pgbitPosSide?'checked':'').' onclick="monaction(this.form);">'.$this->get_message('pg_positionside').'</td></tr>';
					$out .= '<tr><td colspan="2">'.$this->get_message('pg_positiondesc').'</td></tr>';
					$out .= '</table>';
					  // pav: Nom de la page
					$out .= '<table class="ztable">';
					$out .= '<tr id="nompage"><td colspan="2">'.$this->get_message('pg_titre').' <input name="pg_titre" type="text" value="'.($pg_titre?$pg_titre:'').'" id="pg_titre"></td></tr><tr><td>'.$this->get_message('pg_titredesc').'</td></tr>';
					$out .= '</table>';
					  // pav: ident
					$out .= '<table class="ztable" id="identpage" '.(($pg_type&pgbitType)==1||($pg_type&pgbitType)==2?'':'style="display:none;"').'>';
					$out .= '<tr><td colspan="2">'.$this->get_message('pg_permalien').' <input name="ident" type="text" value="'.($ident?$ident:time()).'" id="ident"></td></tr><tr><td>'.$this->get_message('pg_permaliendesc').'</td></tr></table>';
					  // pav: URL
					$out .= '<table class="ztable" id="urlmenu" '.(($pg_type&pgbitType)==5?'':'style="display:none;"').'>';
					$out .= '<tr><td colspan="3">Choisissez le type d\'URL</td></tr>';
					$out .= '<tr><td width="5%"></td><td><input type="radio" name="pg_typurl" id="rbtypurl0" value="0" '.($pg_typurl==0?'checked':'').' onclick="monactionurl(this.form);">'.$this->get_message('pg_URLexterne').'</td></tr>';
					$out .= '<tr><td ></td><td><input type="radio" name="pg_typurl" id="rbtypurl1" value="1" '.($pg_typurl==1?'checked':'').' onclick="monactionurl(this.form);">'.$this->get_message('pg_URLinterne').'</td></tr>';
					$out .= '<tr><td ></td><td><input type="radio" name="pg_typurl" id="rbtypurl2" value="2" '.($pg_typurl==2?'checked':'').' onclick="monactionurl(this.form);">'.$this->get_message('pg_URLsitemap').'</td></tr>';
					$out .= '<tr><td ></td><td><input type="radio" name="pg_typurl" id="rbtypurl3" value="3" '.($pg_typurl==3?'checked':'').' onclick="monactionurl(this.form);">'.$this->get_message('pg_URLlogin').'</td></tr>';
					$out .= '<tr><td ></td><td><input type="radio" name="pg_typurl" id="rbtypurl4" value="4" '.($pg_typurl==4?'checked':'').' onclick="monactionurl(this.form);">'.$this->get_message('pg_URLsearch').'</td></tr>';
					$out .= '<tr><td colspan="3"><br /></td></tr>';
					$out .= '<tr><td colspan="2">URL de destination <input name="pg_url" id="pg_url" type="text" value="'.($pg_url?$pg_url:'').'">';//<input name="select" type="button" value="spcial"></td>';
					$out .= '<td style="align:right"> Ouvrir dans une nouvelle fentre <input name="pg_target" type="checkbox" value="1"'.($pg_target?'checked':'').'></td></tr>';
					$out .= '<tr><td colspan="3">'.$this->get_message('pg_urldesc').'</td></tr>';
//					$out .= '<tr id="sider" '.(isset($pg_type)&&($pg_type!=5)?'':'style="display:none;"').'><td colspan="2"><input name="pg_sider" type="checkbox" value="'.($pg_url?$pg_url:'').'"> cocher pour faire apparaitre le contenu de la page dans le menu (et non le titre)</td></tr>';
/*			    break;
			}*/
			if (isset($_POST['abort'])) {
				header('Location: '.self::$cms->base.'admin#'.self::$cms->args[2]);
			} elseif ($err) {
				$out .= $err;
			} elseif (isset($_POST['submit'])) {  // on va vraiment crer la page !
				$p = (int)self::$cms->args[2];
				if ($p>0 && $p<=$max) {
					$dta = & self::$cms->struct[$p];
					$ident = $ident ? $ident : time();
					$np2 = $p+1;
					switch($pg_type&pgbitType) {
						case 1 : case 2 :
						  $pg_titre = $pg_titre?$pg_titre:self::$cms->get_message('page_default_title')." [$np]";
						  break;
						case 5 :
							$pg_type=((int)$_POST['pg_type'])&~(pgbitMenu|pgbitPosSide); // enlever flags superflus
						  $pg_titre = $pg_titre?$pg_titre:self::$cms->get_message('page_default_title')." [$np]"; //"Ligne de menu [$np]";
						  $pg_url = ereg_replace('[^:/.@?_&=#[:digit:][:alpha:]-]','',$_POST['pg_url']);
						  $pg_url = $pg_url?$pg_url:'http://www.google.fr';
						  $ident = $pg_url;
					    break;
						default: $pg_titre = $pg_titre?$pg_titre:self::$cms->get_message('page_default_title')." [$np]";
					}
					if (!file_exists(self::$cms->cpath.'/'.$ident.'.txt')) {
						if ($is_pg_new) {
							self::$cms->struct[$np] = array($ident, $pg_titre, $dta[cPageRang]+1, $pg_type, 0, array(),array());
							if ($pg_type&pgbitPosSide) {
    	          self::$cms->struct[$np][cPageOpt] = 1;
							}
							for ($j=$np; $j>$np2; $j--) self::$cms->swap($j);
							$max++;
							if (($pg_type&pgbitType)!=5) {
								self::$cms->writefile(self::$cms->cpath.'/'.$ident.'.txt', self::$cms->get_message('page_default_content'));
							}
						} else {
							self::$cms->struct[self::$cms->args[2]][cPageIdent] = $ident;
							self::$cms->struct[self::$cms->args[2]][cPageTitre] = $pg_titre;
						}
						if (($pg_type&pgbitType)==5){
						  if ($pg_target) {
						    self::$cms->struct[self::$cms->args[2]][cPageOpt]['target'] = 1;
							} else unset(self::$cms->struct[self::$cms->args[2]][cPageOpt]['target']);
							if ($pg_typurl) {
						    self::$cms->struct[self::$cms->args[2]][cPageOpt]['typurl'] =  (int)$pg_typurl;
          		} else unset(self::$cms->struct[self::$cms->args[2]][cPageOpt]['typurl']);
							if (empty(self::$cms->struct[self::$cms->args[2]][cPageOpt])) {
								 unset(self::$cms->struct[self::$cms->args[2]][cPageOpt]);
							}
						}
						self::$cms->writeStruct(true);
						header('Location: '.self::$cms->base.'admin#'.self::$cms->args[2]);
						} else $out .= '<p class="zalert">'.self::$cms->get_message('permaname_duplicate').'</p>';
				}
			}
			$out .= '</table><table class="ztable"><tr><td><input type="submit" name="submit" value="'.self::$cms->get_message('submit').'" ><input name="save" type="hidden" value="1" ><input name="modulename" type="hidden" value="'.self::$cms->args[2].'" ></td><td><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" ></td></tr>';
			$out .= '</table></form>';
			return $out;
		} else return self::$cms->get_message('not_allowed');
 	}
}
?>