<?php
/*
module:	Gestion album photo
Copyright Jean-Paul GIAUSSERAND 2010-2011
Licence : Creative Commons CC-BY-NC-SA
Site: http://www.giausserand.fr/index.php?perma=ziteplus
	v1.5: Optimisation vitesse de traitement
	v1.4: Nouveaux paramtres: centrage album, taille image et couleur de voile
	v1.3: Tri des vignettes par description par dfaut
	v1.2: correction si blanc dans nom de l'image
	v1.1: ajout navigation photo suivante/prcdente
	v1.0: cration du module
*/
class Tphotoshow extends Tmodule {
	function dojob($opt="") {//Affichage de l'album photo
		parent::dojob();
		static $i=0;
		$zprubs = new Trubs(self::$cms->cpath.'/rubs.dta');
		require_once(dirname(__FILE__).'/../tdocs.php');
		parse_str($opt, $param); // Prendre valeur des paramtres
		$identps=$param['ident'];
		$docs = new Tdocs(self::$cms->cpath.'/docs.dta',cDocRub,$param['ng']);
		$out='';
		if ($i++==0) {//inclure le code une seule fois dans la page: reste  optimiser le code
		  self::$cms->content['js'].='<script language="javascript" type="text/javascript">
				var vpage = {xMin: 0, xMax: 0, yMin: 0, yMax: 0, wMax:0 , hMax:0, bMax:5, iwMax:0, ihMax:0};//Positions visible de la page
				var myphoto = null;
				var tps'.$identps.'= [];
				var idphoto = "";
				var idphotonext;
				var idphotopred;
				var iddesc="";

				function photoshow_me(obj,desc) {		//Ajuster taille photo et mettre le nom  la fin du chargement
				  var maxWidth = vpage.iwMax;
				  var maxHeight = vpage.ihMax;
					if (obj.width>maxWidth) {
					  var w = maxWidth;
						var ratio = (maxWidth)/obj.width;
						var h = obj.height*ratio;
					 	if (h>maxHeight) {
							var ratio = (maxHeight)/h;
							h = maxHeight;
							w = w*ratio;
						}
						obj.width = w;
						obj.height = h;
				 	}
					if (obj.height<maxHeight) {
			//		  obj.style.marginTop=((maxHeight-obj.height)/2)+"px";
					}

 					var mytitle=document.getElementById("photoshowonetitle");
				 	mytitle.innerHTML=desc;

          var mybody=document.getElementById("blackout");
					mybody.style.display="block";
					myphoto.style.opacity=1;//				opacity: 0.7; filter:alpha(opacity=70)
						if (myphoto.style.visibility!="visible") myphoto.style.visibility="visible";
				}


        function ps_Timer() {//Attendre la fin du chargement de la photo
					obj=document.getElementById("myimg");
					if (!obj.complete) {
//					if (!obj.width) {
			      setTimeout("ps_Timer()",100);
	  			} else {
						photoshow_me(obj,iddesc);
					}
				}
				function photoshow_open(url,desc,id){		//Afficher la photo
				 var mytitle=document.getElementById("photoshowonetitle");
				 mytitle.innerHTML="'.$this->get_message('loadprogress').'";
				 if (myphoto=document.getElementById("photoshowone"))	myphoto.style.visibility="hidden";
					//
				 var showsizex = '.$this->getOption('showsizex').';
				 var showsizey = '.$this->getOption('showsizey').';
					//
				 vpage.xMin = window.pageXOffset || document.documentElement.scrollLeft || document.body.scrollLeft;
				 vpage.xMax = vpage.xMin + (window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth);
				 vpage.yMin = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop;
				 vpage.yMax = vpage.yMin + (window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight);
				 vpage.bMax = 10;//Marge maximun:  paramtrer
				 vpage.wMax = vpage.xMax-vpage.xMin-vpage.bMax*2;
				 vpage.hMax = vpage.yMax-vpage.yMin-vpage.bMax*2;
				 vpage.iwMax = (showsizex <= vpage.bMax*2) ? vpage.wMax : Math.min((showsizex-vpage.bMax*2),vpage.wMax);
				 vpage.ihMax = (showsizey <= vpage.bMax*2) ? vpage.hMax : Math.min((showsizey-vpage.bMax*2),vpage.hMax);
					//
				 var box = document.getElementById("photoshowoneimg");
				 box.innerHTML = "<img id=\"myimg\" src=\"" + url +"\" onclick=\"photoshow_close()\" "+(showsizey? "":"height=\""+vpage.ihMax+"px\"")+"  />";
//				 box.style.width = vpage.iwMax;
//				 box.style.height = vpage.ihMax;
//				 box.innerHTML = "<img id=\"myimg\" src=\"" + url +"\" onclick=\"photoshow_close()\" />";
//				 box.innerHTML = "<img id=\"myimg\" src=\"" + url +"\" onclick=\"photoshow_close()\" '.($this->getOption('showsizey')?'':'height=\""+(vpage.yMax-vpage.yMin-40)+"px\"').'  onmouseover=\"photoshow_me(this,\'"+desc+"\')\"/>";
				  //
				 if (myphoto=document.getElementById("photoshowone")){
						myphoto.style.width = vpage.iwMax;
						myphoto.style.height = vpage.ihMax;
						myphoto.style.opacity=0.4;//				opacity: 0.7; filter:alpha(opacity=70)
						if ('.($this->getOption('imgcenter')).'){ //&&(showsizex+showsizey)) {
							myphoto.style.left = ((vpage.wMax-vpage.iwMax) / 2)+"px";
							myphoto.style.top = ((vpage.hMax-vpage.ihMax) / 2)+"px";
//							if (myphoto.style.left<10) {myphoto.style.left = (vpage.xMin+10)+"px"};
//							if (myphoto.style.top<10) {myphoto.style.top = (vpage.xMin+10)+"px";};
						} else {
							myphoto.style.left = "10px";
							myphoto.style.top = "10px";
						}
/*						myphoto.style.left = (vpage.xMin+10)+"px";						myphoto.style.top = (vpage.yMin+10)+"px";*/
////						if (myphoto.style.visibility!="visible") myphoto.style.visibility="visible";
//					myphoto.style.zIndex="99";
				 }
				 idphoto=id;
					var prm = idphoto.split("X");
					var lident = prm[0];
					idphotonext = lident+"X"+(parseInt(prm[1])+1);
					idphotopred = lident+"X"+(parseInt(prm[1])-1);
					document.getElementById("photoshownext").style.display=(document.getElementById(idphotonext)?"inline":"none");
					document.getElementById("photoshowpred").style.display=(document.getElementById(idphotopred)?"inline":"none");
					iddesc=desc;
					ps_Timer()
				}
				function photoshow_close(){//Fermer la photo
					if (myphoto) myphoto.style.visibility="hidden";
		      var mybody=document.getElementById("blackout");
		      mybody.style.display="none";
				}
				function photonext(isup){//Photo suivante
					var objphotonext=document.getElementById((isup?idphotonext:idphotopred));
					if (objphotonext) {
						var s = objphotonext.onclick;
						s=String(s).match(/photoshow_open(.*)/g);
						s=String(s).match(/[\"\'].*[\"\']/g);
						s=String(s).split(/[\"\'],/);
				    for (var i=0;i<s.length;i++){
				      s[i]=s[i].replace(/[\"\']/g,"");
				    }
					  if (s.length==3) {
							photoshow_open(s[0],s[1],isup?idphotonext:idphotopred);
						}
					}
				}
				</script>';
			$out.='<div id="blackout" style="display:none;height:100%;background-color:'.$this->getOption('opacitycolor').';top:0;left:0;width:100%;z-index:98;position:fixed;opacity: 0.7; filter:alpha(opacity=70)"></div>
			<div id="photoshowone" style="background-color:transparent;    position:fixed;overflow:hidden;visibility:hidden;z-index:99; '.($this->getOption('showsizex')?'width:'.$this->getOption('showsizex').'px; ':'').'">

				<table border="0" bgcolor="'.$this->getOption('bordercolor').'"width="100%" cellspacing="0" cellpadding="5">
				 <tr>
				  <td><div id="photoshowpred" style="cursor:pointer" onclick="photonext(false);">'.$this->get_Message('photopred').'</div></td>
				  <td width="100%" id="photoshowonetitle"></td>
				  <td><div id="photoshownext" style="cursor:pointer"onclick="photonext(true);">'.$this->get_message('photonext').'&nbsp;</div>&nbsp;&nbsp;</td>
				  <td><a href="#" onClick="photoshow_close();return false"><font style="text-decoration:none">X</font></a></td>
				 </tr>
				</table>

				<div id="photoshowoneimg" style="margin-top:5px;'.($this->getOption('showsizex')?'width:'.$this->getOption('showsizex').'px; ':'').($this->getOption('showsizey')?'height:'.$this->getOption('showsizey').'px':'').'"></div>';

			$out.='</div>';
			if ($this->getOption('usedftcss')) {
      	self::$cms->content['dftcss'].=
					"\n.photoshowtitle { border: 5px solid ".$this->getOption('bordercolor')."; text-align:center; background-color : ".$this->getOption('bordercolor')."; }".
					"\n.photoshowcell {width:".$this->getOption('cellwidth')."px;height:".$this->getOption('cellheight')."px; background-color:".$this->getOption('cellbgcolor')."; margin: ".str_repeat($this->getOption('cellmargin').'px ',4)."}".
	 				"\n.photoshowcellimg {height:".$this->getOption('cellimgheight')."px}".
	 				"\n.photoshowcelldesc {background-color:".$this->getOption('celldescbgcolor')."}".
	 				"\n#photoshownext:hover,#photoshowpred:hover {background-color:".$this->getOption('selectcolor').";}".
					"\n#photoshowonetitle {font-weight:bold; color:#000000;}"
					;
			}
		}
			// Etablir la liste des documents  afficher
		$nipl=0;
		if (empty($param['nipl']) || ($param['nipl']==false)) $param['nipl']=99999;
		$out.="<div id='photoshow$identps' >";
		$i=0;
		$docs->sort();
		foreach ($docs as $docname => $doc) {
			if ($docs->isDocAuth($docname) &&($doc[cDocType]=='img')) {
				if ($nipl==0) {
				  $out.='<div class="photoshowbody" style="clear:both">';
				};
				$id=$identps.'X'.++$i;//gnrer un numro unique par photo
				$out.='<div id="'.$id.'" class="photoshowcell" style="float:left;overflow:hidden;" title="'.$this->get_message('imglarge').'" onclick="photoshow_open(\'view.php/'.rawurlencode($docname).'\',\''.$doc[cDocDesc].'\',\''.$id.'\');">'.
							 '<div class="photoshowcellimg" style="background:url(\'thumb.php/'.rawurlencode($docname).'\') no-repeat center center;" ></div>'.
							 '<div class="photoshowcelldesc">'.$doc[cDocDesc].'</div></div>';
        if (++$nipl==$param['nipl']) {
          $out.='</div>';
          $nipl=0;$out2='';
				}
			}
		}
    if ($nipl!=0)  $out.='</div>';
		$out.='</div>';
		return $out;
	}
}
?>