<?php
/*
module:	Gestion des rubriques - V1.0
Copyright Jean-Paul GIAUSSERAND 2010-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.1: plus de rubrique sans nom + suppression warnings
	v1.0: cration du module
*/
require_once self::$cms->zpath.'/trubs.php';
class Trubsadmin extends Trubs {
	function save(){
    return ($this->rubs!==false?@file_put_contents($this->filename, serialize($this->rubs), LOCK_EX ):true);
	}
	function remove($name) {
	  $this->refresh();
		unset($this->rubs[$name]);
		$this->save();
	}
	function update($ident,$desc,$groupW,$groupR) {
	  $this->refresh();
		$this->rubs[$ident] = array($desc,$groupW,$groupR);
		$this->save();
	}
	function verif(&$ident,&$desc,&$groupW,&$groupR) {
		$ident = trim(stripslashes($ident));
		$desc = trim(stripslashes($desc));
/*		if (empty($ident)) {
		  $ident='*no';
		}*/
//		if (in_array('admin',$groupW)) {	$groupW=array_diff($groupW,array('admin'));}
	}
}
//
class Trubrique extends Tmodule {
	function dojob($opt="") {
		parent::dojob();
		// Propre  ce module: il faut un utilisateur sign
		if (empty($_SESSION['zite_user']))
			return self::$cms->get_message('not_allowed');
		require_once(self::$cms->zpath.'/outils.php');
		//
	$zprubs = new Trubsadmin(self::$cms->cpath.'/rubs.dta');

	$out = '<form method="post" action="'.self::$cms->base.'rubrique" enctype="multipart/form-data"><table class="ztable">';
	$out .= '<tr><td colspan="2"><h2><center>'.$this->get_message('title').'</center></h2><td></tr>';
	if (!empty(self::$cms->args[2])) {
		$ident = self::$cms->args[2];
	  $desc = $zprubs->getvalues($ident,cRubDesc);
		$groupW = (array)$zprubs->getvalues($ident,cRubWrite);
		$groupR = (array)$zprubs->getvalues($ident,cRubRead);
	} else {
		$ident = isset($_POST['ident'])?$_POST['ident']:'';
		$desc = isset($_POST['desc'])?$_POST['desc']:'';
		$groupW = empty($_POST['groupW'])?array():(array)$_POST['groupW'];
		$groupR = empty($_POST['groupR'])?array():(array)$_POST['groupR'];
	}
	$err ='';
	if ($err) {//pas en service pour l'instant
		$out.= $err;
		self::$cms->args[1]=substr($_POST['save'],0,strlen($_POST['save'])-1);
	} elseif (isset($_POST['docreadall'])) {
	  $groupR = array();
		self::$cms->args[1]=substr($_POST['save'],0,strlen($_POST['save'])-1);
		self::$cms->args[2]=$filename;
	} elseif (isset($_POST['docwritegroup'])) {
	  $groupW = array_diff($_SESSION['zite_usergroup'],array('logon'));
		self::$cms->args[1]=substr($_POST['save'],0,strlen($_POST['save'])-1);
		self::$cms->args[2]=$filename;
	} elseif (isset($_POST['abort'])) {
	} elseif (isset($_POST['save'])) {
		if ($_POST['save']=='del1') {
			self::$cms->args[1] = 'del';
			if ($zprubs->isRub($ident)) {
					$zprubs->remove($ident);
					self::$cms->args[1]='';
			}
		} else {
		  if (empty($ident)) {
				self::$cms->args[1] = substr($_POST['save'],0,strlen($_POST['save'])-1);
		  	self::$cms->msgShow($this->get_message('errrubnoname'),false);
			} elseif ($_POST['save']=='modif1') {
					self::$cms->args[1] = 'modif';       // en cas d'erreur
					//		if ($zdocs->isDocAuthWrite($ident)) {
					//				if (empty($_FILES['file']['name'])||loadfile('file',self::$cms->dpath.'/', $name,$filename,$ext,$zdocs->getvalues($ident,cDocFilename))) {
					$zprubs->verif($ident,$desc,$groupW,$groupR);
					$zprubs->update($ident,$desc,$groupW,$groupR);
					self::$cms->args[1]='';
					if (self::$cms->args[1]=='modif') self::$cms->msgShow('done_failed');
			} elseif ($_POST['save']=='new1') {
				self::$cms->args[1] = 'new';       // en cas d'erreur
				if (!$zprubs->isRub($ident)) { //oups: la rubrique existe dj
					$zprubs->verif($ident,$desc,$groupW,$groupR);
					$zprubs->update($ident,$desc,$groupW,$groupR);
					self::$cms->args[1]='';
				} else self::$cms->msgShow($this->get_message('errrubexist'),false);
				if (self::$cms->args[1]=='new') self::$cms->msgShow('done_failed');
			} else
				if (self::$cms->args[1]!='') self::$cms->msgShow('done_failed');
		}
	}
	$out .= '<tr><td align="left">'.$zprubs->count().' Rubrique(s)</td><td align="right"><a href="'.self::$cms->base.'rubrique|new"><img src="deco/a.png" />Ajouter</a></td></tr>';
	$out .= '</table><table class="ztable">';

	$show_listdoc = true; $del=false;
		if (isset(self::$cms->args[1])) switch (self::$cms->args[1]) {
		  case 'new' :
				$groupW = array_diff($_SESSION['zite_usergroup'],array('logon'));
				$groupR = array();
			case 'modif':
				$out .= '<tr><td>'.$this->get_message('rubident').'</td><td><input name="ident" type="text" id="ident" value="'.$ident.'" size=20 /></td></tr><tr><td/><tr><td/><td>'.$this->get_message('rubidentdesc').'</td></tr>';
				$out .= '<tr><td>'.$this->get_message('rubdesc').'</td><td><input name="desc" type="text" id="desc" value="'.$desc.'" size=65 /></td></tr><tr><td/><td>'.$this->get_message('rubdescdesc').'</td></tr>';
				//$out .= '<tr><td>'.$this->get_message('docauth').'</td><td><input name="auth" type="text" id="auth" value="'.$auth.'" size=20 readonly /> '.$this->get_message('docdate').'<input name="docdate" type="text" id="docdate" value="'.$docdate.'" size=15 readonly /></td></tr>';
				//$out .= '<tr><td>'.$this->get_message('docrub').'</td><td><input name="rub" type="text" id="rub" value="'.$rub.'" size=20 readonly /></td></tr>';
							// Afficher les groupes pouvant modifier ce fichier
				$out .= '<tr><td>'.$this->get_message('rubwrite').'</td><td><select name="groupW[]" multiple size=5 '.($del ? 'disabled' : '').' style="width:50%">';
				foreach (self::$cms->group as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$groupW)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> <input type="submit" name="docwritegroup" value="'.$this->get_message('docwritegroup').'"/></td></tr>';
							// Afficher les groupes pouvant lire ce fichier
				$out .= '<tr><td>'.$this->get_message('rubread').'</td><td><select name="groupR[]" multiple size=5 '.($del ? 'disabled' : '').' style="width:50%">';
				foreach (self::$cms->group as $clef => $valeur	)
					$out .= '<option '.(in_array($clef,$groupR)?'selected':'').' value="'.$clef.'">'.$clef.'</option>';
				$out .= '</select> <input type="submit" name="docreadall" value="'.$this->get_message('docreadall').'"/></td></tr>';
				$out .= '<input name="save" type="hidden" value="'.self::$cms->args[1].'1" /></td></tr>';
				$out .= '<tr><td><input type="submit" name="submit" value="'.self::$cms->get_message('send').'" /></td><td><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr>';
		    break;
			case 'del':
			  if ($zprubs->isRub($ident)) {
					$out .= '<tr><td>'.$this->get_message('confirmdel').'</td></tr>';
					$out .= '<tr><td><ul>'.$this->get_message('rubident').': <b>'.$ident.'<b/></ul></td></tr>';
					$out .= '<tr><td><ul>'.$this->get_message('rubdesc').': <b>'.$desc.'</b></ul></td></tr>';
					$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.self::$cms->get_message('confirm').'" /><input name="save" type="hidden" value="del1" /><input name="ident" type="hidden" value="'.$ident.'" /><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr>';
			  }
			  break;
			}
			$out.='</table>';
						// grer le formulaire de base: la liste des documents
//			if ($show_listdoc) {
			$out .= '</form>';
								// Afficher la liste de tous les documents
				$out .= '<div style="overflow:auto";><table class="ztable">';
				$out .= '<tr class="headcolor">'.
								'<td></td>'.
								'<td></td>'.
								'<td align=center><b>'.$this->get_message('rubident').'</></td>'.
								'<td align=center><b>'.$this->get_message('rubdesc').'</></td>'.
								'<td align=center><b>'.$this->get_message('rubwrite').'</></td>'.
								'<td align=center><b>'.$this->get_message('rubread').'</></td><td></td></tr>';
//				uasort($files, create_function('$a, $b', 'return strcmp($a[0], $b[0]);'));  // voir tri
				$i=0;foreach ($zprubs as $clef => $rub )
//				 if ($zprubs->isDocAuth($clef)) {//  mettre ?
					$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'">'.
									'<td align=center><a href="'.self::$cms->base.'rubrique|modif|'.rawurlencode($clef).'" title="'.$this->get_message('zoom').'"><img src=deco/z1.png></a></td>'.
									'<td align=center><a href="'.self::$cms->base.'rubrique|modif|'.rawurlencode($clef).'" title="'.$this->get_message('modif').'"><img src=deco/edit.png></a></td>'.
									'<td style="padding-left:5px"><a href="'.self::$cms->base.'rubrique|modif|'.rawurlencode($clef).'">'.$clef.'</a></td>'.
									'<td style="padding-left:5px"><a href="'.self::$cms->base.'rubrique|modif|'.rawurlencode($clef).'">'.$rub[cRubDesc].'</a></td>'.
									'<td align=center><a href="'.self::$cms->base.'rubrique|modif|'.rawurlencode($clef).'|'.(arrayToString($rub[cRubWrite])).'"><img src="deco/kw'.($rub[cRubWrite]?'1': '0').'.png" title="'.arrayToString(array_unique(array_merge($rub[cRubWrite],array('admin')))).'"/></a></td>'.
									'<td align=center><a href="'.self::$cms->base.'rubrique|modif|'.rawurlencode($clef).'|'.(arrayToString($rub[cRubRead])).'"><img src="deco/kr'.($rub[cRubRead]?'1': '0').'.png" title="'.($rub[cRubRead]?arrayToString($rub[cRubRead]):$this->get_message('grpreadall')).'"/></a></td>'.
									'<td align=center>'.'<a href="'.self::$cms->base.'rubrique|del|'.rawurlencode($clef).'" title="'.$this->get_message('del').'"><img src="deco/e1.png" /></a>'.'</td></tr>';
//				}
				$out .= '</table></div>'.$this->get_message('comment');
			//}//show_listdocs
	return $out;
}
}
?>