<?php
/*
module:	moteur de recherche - V1.4
Copyright Jean-Paul GIAUSSERAND 2009-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
v1.5	04/01/2011 Diverses corrections et amliorations
v1.4	01/12/2009 Mise en conformit W3C & XTML 1.0 Transitional
v1.3  30/10/2009 correction: les urls des pages suivent le paramtre url_rewriting
v1.2  29/10/2009 passage en code objet et interdiction d'utilisation si site horsligne
v1.1  12/10/2009 correction: les pages non publies ne sont plus prises en compte dans la recherche
v1.0  01/05/2009 cration du module

Ce module est driv d'un script de moteur de recherche cr par zulios
			A Blork Engine v0.23b
			Copyright (C) 2003 zulios
			Script du moteur
			Licence GPL
*/

class Tsearch extends Tmodule {
	function dojob($opt="") {
		parent::dojob();
		if (self::$cms->config['site_status']==false) return self::$cms->get_message('errorCLOSED');

		$out='';
		if (isset(self::$cms->args[1])&&(self::$cms->args[0]==$this->modulename)) {
			$action = self::$cms->args[1];
			$start = isset(self::$cms->args[2])?self::$cms->args[2]:'1';
			$multi = isset(self::$cms->args[3])?self::$cms->args[3]:'';
			$blork = isset(self::$cms->args[4])?self::$cms->args[4]:'';
		} else {
			$action = isset($_POST['action'])?$_POST['action']:'';
			$blork = isset($_POST['blork'])?$_POST['blork']:'';
			$multi = isset($_POST['multi'])?$_POST['multi']:'';
			$start = isset($_POST['start'])?$_POST['start']:'1';
		}
		// Liste des codes htmls spciaux
		$caractere_special=array(
			"&agrave;"=>"","&aacute;"=>"","&acirc;"=>"","&atilde;"=>"","&auml;"=>"","&aring;"=>"",
			"&aelig;"=>"",
			"&ccedil;"=>"",
			"&egrave;"=>"","&eacute;"=>"","&ecirc;"=>"","&euml;"=>"",
			"&icirc;"=>"","&iuml;"=>"",
			"&ocirc;"=>"","&ouml;"=>"",
			"&ugrave;"=>"","&uacute;"=>"","&ucirc;"=>"","&uuml;"=>"",
			"&amp;"=>"&",
		);

		/* Nombre de rsultats maximum  afficher par page */
		$maxipage="20";

/*	Configuration des fichiers/dossiers  exclure de la recherche

Pour viter qu'un fichier ou un dossier puisse tre scann et affich dans les
rsultats, vous allez devoir les indiquer dans la liste plus bas.
Par dfaut les fichiers du script sont dj exclus de la recherche, a sert  rien de rechercher dans le fichier qui est en train de faire lui-mme la recherche... Chaque lment doit tre mis entre guillemets, et suivi d'une virgule. Si vous voulez en rajouter il faut indiquer entre les guillemets :

 Pour un fichier :

Son nom avec son extension, mais surtout pas le dossier o il se trouve.
Exemple  :	index.html			FONCTIONNE
		monimage.jpg			FONCTIONNE
		monimage.gif			FONCTIONNE
		mondossier/index.html		NE FONCTIONNE PAS
		mondossier/monimage.jpg		NE FONCTIONNE PAS


 Pour un dossier :

Son chemin d'accs, c'est  dire la partie de droite que l'on remplit
lors de la personnalisation des dossiers  scanner.

Exemple : 	.		FONCTIONNE
		..		FONCTIONNE
		./mondossier	FONCTIONNE
		../mondossier	FONCTIONNE
		mondossier	NE FONCTIONNE PAS


Mettez uniquement un lment par ligne.
Les diffrents lments sont  indiquer dans la liste ci-dessous */
$exclu=array(); 
/* * * * * * * * * * * * * * * * * * * * * * */

$version="0.23b";   // la version d'origine du moteur de recherche

// Variables par dfaut

if(empty($maxmots)) $maxmots="20";
if(empty($maxipage)) $maxipage="20";
if(empty($start)) $start="1";
if(empty($choix)) $choix='';
$blork=trim($blork);
$blork=@ereg_replace(" +", " ", $blork);
$blork=strtolower($blork);  					// Passage en minuscules de la recherche
$longueur_blork=strlen($blork);   		//jpg: changement de place
$blork2=htmlspecialchars($blork);

$form_recherche='<form name="search" method="post" action="'.self::$cms->base.'search" enctype="multipart/form-data"><input type="hidden" value="go" name="action"/>
<input type="text" value="'.$blork2.'" maxlength="50"  name="blork" style="width:130px" /><button type="submit" style="background-color:transparent;border:none;vertical-align:text-bottom;cursor:pointer" ><img src="deco/search.png" alt="" style="vertical-align:bottom"/></button>
</form>';

$out .= '<table class=ztable><tr><td><h2><center>'.$this->get_message('title').'</center></h2><td></tr></table>';



// On vrifie que la recherche est correctement lance

	if ($opt=='view'){
	  $out = $form_recherche;
	} elseif($action!="go"){
	  // Nouvelle recherche
	  $out .= '<br/><p>'.$this->get_message('newsearch')." $form_recherche</p>";
	//	$out .=  $form_recherche;
	} elseif ($longueur_blork<3){ // On vrifie la longueur de la recherche
		$out .= '<p class="zalert">'.$this->get_message('mini3car').'</p>'.$form_recherche;
	} else {
    // Rsultats  0
		$compteresultats="0";
		$zetotal="0";

/* 	Dbut de recherche des sous dossier
		-- Pas sous Zite+ --
		Fin de recherche des sous dossier */

  	// Recherche sur les pages
		foreach (self::$cms->struct as $idpage=>$page) {
		  // On scanne uniquement les pages authorises
		  if ((!$page[cPageOn])||(self::$cms->isPageAuth($idpage)==false)){ continue; }
		  $file = self::$cms->cpath.'/'.$page[cPageIdent].'.txt';
			if (file_exists($file)) {
  			// On ne scanne pas les fichiers exclus
				if(in_array($file, $exclu)){ continue; }
				// On rcupre l'extension;
				$ext = 'txt';		//ereg_replace('^.*[.]([^.]*)$', '\\1', $file);
				// Dtermination du type de fichier
				// On ne vrifiera que le nom des fichiers de type "img" (image)
				// alors que les fichiers de type "normal" seront entirement retraits
				// car considrs comme contenant du texte lisible par le moteur.
				if($ext=="html" || $ext=="htm" || $ext=="php" || $ext=="php3" || $ext=="txt" || $ext=="php4"){
					$filetype="normal"; }
				else{ $filetype="img"; }
				// Maintenant qu'on a dtermin la place de notre fichier entre les deux types
				// On va appliquer des retraitements prliminaires sur les fichiers de type "normal" uniquement
				if($filetype=="normal"){
					// On ouvre le contenu du fichier
					$recupere_le_fichier=fopen("$file","r");
					$tout=fread($recupere_le_fichier,500000);
					fclose($recupere_le_fichier);
						// Passage en minuscules
					$tout=strtolower($tout);
						// On vire le html et le php
					$tout=strip_tags($tout,'<script></script><head></head><style></style>');
						// On rcupre le titre du fichier
					$titre=strtolower($page[cPageTitre]);
					$tout = preg_replace('`<title.*?/title>`', '', $tout);
					//
					// 3 tapes ici :
					//
					/* Etape 1 -
						 On effectue des remplacements pour pouvoir appliquer les regex :
						 1- On remplace le saut de ligne par un espace
						 3- Les &nbsp; (code html pour un espace) sont remplacs par des espaces
						 4- Les doubles espaces sont remplacs par un simple espace

					 	Etape 2-
						On lance les regex
						1- On vire le code entre <head> et </head> qui contient en gnral tout les trucs qui ne nous intressent pas ici (feuille de style, javascript...)
						2- On vire le javascript pour viter les bugs au cas ou une partie nous aurait chappe
						3- On vire les attributs de style pour les mmes raisons
						Merci encore une fois  Frdric Bouchery pour le regex

						Etape 3-
						On remplace le code html des accents et autres caractres spciaux par le terme correspondant
						pour le titre ET le contenu
					*/
					$tout = str_replace("\n"," ",$tout);
					$tout = str_replace("&nbsp;"," ",$tout);
					$tout = str_replace("  "," ",$tout);
						//
//					$tout = preg_replace('`<head.*?/head>`', '', $tout);  //090 Inutile en ziteplus
					$tout = preg_replace('`<script.*?/script>`', '', $tout);
					$tout = preg_replace('`<style.*?/style>`', '', $tout);
						//
					foreach($caractere_special as $caractere_code=>$caractere_traduction){
						$tout = str_replace("$caractere_code","$caractere_traduction",$tout);
						$titre = str_replace("$caractere_code","$caractere_traduction",$titre);
					}
				} // Fin du retraitement
				// Maintenant le fichier a t retrait (si ncessaire),
				// on peut voir s'il contient ce qu'on cherche.
				//
				// On incrmente le nb de fichiers scanns
				$zetotal++;
				if($zetotal>9999){ continue 2; }
				// Si on trouve la recherche
//				if(strpos("$tout","$blork") || strpos("$file","$blork") || strpos("$titre","$blork")){
				// correction car pb en PHP5
				if(strpos("$tout","$blork")!==false || strpos("$file","$blork")!==false || strpos("$titre","$blork")!==false){
						// On remet a zro histoire d'viter des doublons
					/*	$tout,$filetype,$ext,$file, 				);*/
					$total_mots=0;
					$resume='';
					// Rsultats +1
					$compteresultats++;
					// S'il s'agit d'un fichier de type "normal"
					if($filetype=="normal"){
						// On compte les occurences du terme
						// Les occurences trouves dans le titre comptent pour 10 (pire qu'au scrabble) car ils sont souvent explicites sur le contenu de la page
						$total_mots=intval(substr_count($titre,$blork)*10+$total_mots);
						$total_mots=intval(substr_count($tout,$blork)+$total_mots);
						// On cre la description
						$position=strpos($tout, $blork);
						$start_position=intval($position-50);
						if($start_position<0){ $start_position="0"; }
						$fin_position=intval($longueur_blork+100);
						if($position === FALSE ){
							$resume.= $this->get_message('filenomatch');
						}else{
							$resume="... ";
							$resume.=substr($tout, $start_position, $fin_position);
							$resume.=" ... ";
							// On met en gras le terme recherch dans la description
							$resume=str_replace($blork,"<b>$blork2</b>",$resume);
						}
					}
          // Si c'est une image ou un autre type de fichier
					// On adapte la description
					else{ $resume="Fichier $ext";
					}
						// Puis dans le titre
					$titre=str_replace($blork,"<b>$blork2</b>",$titre);
						// Calcul du pourcentage de pertinence
					similar_text($blork, $tout, $p1);
					similar_text($blork, $titre, $p2);
					$p=intval($p1+$p2);
						// Si le pourcentage est suprieur ou gal  100 on le ramne  99
						// Et s'il est gal  0 on le ramne  1 pour qu'il puisse tre rindex (voir suite)
					if($p>=100){ $p="99"; }
					if($p=="0"){ $p="1"; }
						// On va crer une cl identique pour chaque rsultat.
						// Le premier sera un "1", pour que la cl soit rindexe
						// Le suivant sera le nombre d'occurences total de mots trouvs (en dizaines)
						// Ensuite le pourcentage de similarit du texte + celui du titre (deux chiffres)
						// Enfin le numro du rsultat (4 chiffres)
						// Avec cette cl on pourra classer les rsultats par ordre dcroissant selon le chiffre obtenu, donc par pertinence.
						//
						// Notes :
						// La cl ne doit pas commencer par 0 donc il tait important de mettre en premier
						// un "1", ou un chiffre suprieur  0 en tout cas.
						// La cl ne doit pas tre suprieure  8 chiffres, sinon elle ne sera pas rindexe.
						//
						// Cette bidouille me permettra par la suite avec array_unshift() de rindexer le tableau avec
						// des cls numriques pour pouvoir afficher uniquement les rsultats souhaits, donc j'conomise
						// du temps d'xcution et des ressources par rapport  l'ancienne mthode qui consistait  crer
						// un nouveau tableau. L'array_unshift() me rajoutera une valeur de cl 0 que je ne supprime pas
						// parce que je pourrai ainsi grer mes rsultats  partir de 1, ce qui est plus logique.
						//
						// On ramne les occurences au maxi  99
						// Puis on rajoute un 0 devant le chiffre s'il est infrieur  10
						// Enfin on ne garde que le chiffre des dizaines
						//
					if($total_mots>=100){ $total_mots="99"; }
					if (strlen($total_mots)==1){
						$total_mots=str_repeat("0",2-strlen($total_mots)).$total_mots;
					}
					$total_mots=substr($total_mots, 0, 1);
						// Idem pour les pourcentages
					if (strlen($p)==1){
						$p=str_repeat("0",2-strlen($p)).$p;
					}
						// Et enfin le numro du rsultat
					$compteresultats2=$compteresultats;
					if (strlen($compteresultats2)<4){
						$compteresultats2=str_repeat("0",4-strlen($compteresultats2)).$compteresultats2;
					}
						// On met la premire lettre du titre en majuscules
					$titre=ucfirst($titre);
						//
						// URL par dfaut pour les fichiers
						//
					$go_2_url='index.php?perma='.$page[cPageIdent];
						// Source du rsultat
					$src=" <a href=\"$go_2_url\">$titre</a> <br/>$resume";
						// On enregistre
					$zeresults["1".$total_mots."".$p."".$compteresultats2]="$src";
						// On remet a zro histoire d'viter des doublons
					unset(	$compteresultats2,
										$tout,
										$resume,
										$src,
										$titre,
										$filetype,         /* erreur: voir plus bas: aussi $ext  ?*/
										$p, $p1, $p2,
										$file, $ext,
										$total_mots,
										$register
									);
				}
			}
			// On referme
			// Ssame ferme toi
			unset($tout,$filetype,$fp,$ext);
		}
				// Si on a des rsultats
				// On les classe par ordre dcroissant de pertinence
				// Ensuite on lance un array_unshift() qui rindexe le tableau
				// ce qui nous permet d'avoir des cls numriques et de grer les rsultats  partir de 1
				// Pour de plus amples explications vous pouvez voir un peu plus haut
				// ou me contacter, j'essaierai de vous expliquer a en dtail.
		if($compteresultats>0){
			krsort($zeresults);
			array_unshift($zeresults,"rien");
		}
			// On dfinit les diffrentes variables qui serviront pour la barre de navigation
		if($start=="1" && $compteresultats=="0" ){ $start="0"; }
		$pourvoir=intval($start+$maxipage-1);
		if($pourvoir>$compteresultats){ $pourvoir=$compteresultats; }
		$finstart=intval($compteresultats-$maxipage+1);
		$prevbarre=intval($start-$maxipage);
		$nextbarre=intval($start+$maxipage);
		$nb_barre="1";
		$compte_affichage=$start;
			// Changement du texte selon les rsultats
			// Entre singulier et pluriel
		$rs=" rsultat trouv ";
		$fich=" page";
		if($compteresultats>1){ $rs=" rsultats trouvs "; }
		if($zetotal>1){ $fich=" pages"; }
			// Maintenant on commence l'affichage
		$out.="$form_recherche"	;
		$out .= "<br />{$this->get_message('resultsearch')} <b>$blork2</b><br/> $compteresultats $rs sur $zetotal $fich";
		if($compteresultats>$maxipage) $out.="<br/>{$this->get_message('showresult')} $start  $pourvoir";
			// On slectionne les lments du tableau de rsultat  afficher et on les lance
		if($compteresultats>0){
			foreach($zeresults as $key=>$value){
				if($key>=$start && $key<$nextbarre){
					$out .= "<br/><br/>$value";
					$compte_affichage++;
				}
			}
		}
			// Et si on a trop de rsultats par rapport au nombre  afficher dans la page on met la barre de navigation
		if($compteresultats>$maxipage){
			$out .= "<p align=center><br/>";
			if($start!="1"){
				$out.='<a href="'.self::$cms->base."search|go||$choix|$blork\"><< Dbut</a> <a href=\"".self::$cms->base."search|go|$prevbarre|$choix|$blork\">< Page prcdente</a> (";
			} else{ $out.="<< Dbut < Page prcdente (";
			}
			for($barre=1;$barre<$compteresultats;){
				$finbarre=intval($compteresultats-$barre);
				$out .= ' <a href="'.self::$cms->base."search|go|$barre|$choix|$blork\">$nb_barre</a> ";
				$nb_barre++;
				$barre=intval($barre+$maxipage);
			}
			if($start<$finstart){
				$out .= ') <a href="'.self::$cms->base."search|go|$nextbarre|$choix|$blork\">Page suivante ></A> <A href=\"".self::$cms->base."search|go|$finstart|$choix|$blork\">Fin >></a>";
			} else{
				$out.=") Page suivante >  Fin >>";
			}
			$out.="</p>";
		}
		if($compteresultats=="0"){
			$out .= "<br/>Votre recherche sur le terme <b>$blork2</b> n'a donn aucun rsultat. Essayez d'largir votre recherche en y mettant moins de mots ou vrifiez son orthographe.";
		} else{
			$out .= "<p align='center'>$compteresultats $rs sur $zetotal $fich.</p>";
		if($compteresultats>$maxipage) $out.="<p align='center'>{$this->get_message('showresult')} $start  $pourvoir</p>";
		}
		if($compteresultats>0){ $out.="$form_recherche"	; }
	}
	return $out;
	}
}
?>