<?php
/*
module:	Gestion des modules
Copyright Jean-Paul GIAUSSERAND 2009-2011
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.11 07/12/11  Nouvelle structure pour base centrale des modules
	v1.10 07/09/11  Passage 092, module-092.txt gnrique
	v1.9  11/10/10  Corrections mineures
	v1.8  23/09/10  Mise  jour depuis site officiel
	v1.7  08/06/10  Possibilit d'ajouter des modules sous forme de fichier zip
	v1.6	12/10/09  Passage en classe Tselectmodule
	v1.5  27/09/09  Gestion des options de configuration
	v1.4  23/08/09  Gestion des modules objets
	v1.3: Gestion des fichiers ini associs aux modules
	v1.2: Gestion des fichiers de messages de modules et nouveau codage des modules
	v1.1: Transformation en module de la gestion des modules
	v1.0: Gestion des modules
*/

class Tselectmodule extends Tmodule {
	function dojob($opt="") {
	  parent::dojob();

	function loadfile($src, $path, &$name, &$filename) {
  	$handle = $_FILES[$src];
		if (!empty($handle) && ($handle['error']==0)) {
		  $filename = strtolower(stripslashes($handle['name']));
			$prov01 = pathinfo($filename);
			$ext = $prov01['extension'];
			$name = basename($filename,'.'.$ext); // enlever l'extension
			$temp_file = $handle['tmp_name'];
			return @move_uploaded_file($temp_file, $path.$filename);
     } else return false;
	}
	$isconfig=Tmodule::isConfigAuth($this->modulename);//Droit de grer selectmodule
	if (!isset(self::$cms->args[1])&&isset($_SESSION['url_return'])) unset($_SESSION['url_return']);
	$file = self::$cms->cpath.'/module.dta';
	self::$cms->module = (array)unserialize(@file_get_contents($file));
	$module = &self::$cms->module;

	$out = '<form method="post" action="'.self::$cms->base.'selectmodule" enctype="multipart/form-data"><table class="ztable">';
	$out .= '<tr><td colspan="2"><h2><center>'.$this->get_message('title').'</center></h2><td></tr>';
	if ($isconfig&&(empty(self::$cms->args[1])||(self::$cms->args[1]!='installzip')&&(self::$cms->args[1]!='installsite'))){
		$out .= '<tr><td colspan="2" align="right"><a href="'.self::$cms->base.'selectmodule|installzip"><img src="deco/a.png" />'.$this->get_Message('btnadd').'</a></td></tr>';
		$out .= '<tr><td colspan="2" align="right"><a href="'.self::$cms->base.'selectmodule|installsite"><img src="deco/a.png" />'.$this->get_Message('btnaddjpg').'</a></td></tr>';
	}
	if (isset($_POST['abort'])) {
	} elseif (isset($_POST['m_save'])) {
		self::$cms->args[1] = $_POST['m_save'];       // en cas d'erreur
		if ($isconfig) {
		 	switch($_POST['m_save']){
			 case 'installsite':
					if (empty($_POST['filezip'])) {
					  // aucun fichier de choisi
					} else {
					  $filezip=$_POST['filezip'];
					  $pos=strpos($filezip,'-');
    		    $name=substr($filezip,0,$pos);
				  	$zip="module-$filezip.zip";//			  $zip='module-'.self::$cms->version().'-'.$_POST['filezip'].'.zip';
						if (!ini_get('allow_url_fopen')) {
							function GetRemoteFileContent($url){
  							$curl = curl_init();  // Initialiser cURL.
							  curl_setopt($curl, CURLOPT_URL, $url);  // Indiquer quelle URL rcuprer
							  curl_setopt($curl, CURLOPT_HEADER, 0);  // Ne pas inclure l'header dans la rponse.
							  curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		            $txt=curl_exec($curl);  // Excuter la requte.
  							curl_close($curl);  // Fermer cURL.
							  return $txt;
							}
							file_put_contents(self::$cms->zpath.'/module/'.$zip,GetRemoteFileContent('http://www.giausserand.fr/view.php/ziteplus.zip?path='.$zip));
						}	else copy('http://www.giausserand.fr/view.php/ziteplus.zip?path='.$zip,self::$cms->zpath.'/module/'.$zip);
			  		$ok=false;
						require_once(self::$cms->zpath.'/pclzip.lib.php');
					  $archive = new PclZip(self::$cms->zpath.'/module/'.$zip); $dest = self::$cms->ipath.'/';
				  	if ($archive->extract(PCLZIP_OPT_PATH, $dest, PCLZIP_OPT_REPLACE_NEWER) != 0) $ok=true;      																							// <--------- newer !!!
						unset($archive);
						unlink(self::$cms->zpath.'/module/'.$zip);
						if ($ok) {
							$filename=$name.'.php';
							if (isset($module[$filename])) {  // mise  jour si le fichier existe
							} else $module[$filename] = array($name, 0,array('admin'));
				 			self::$cms->writedata($file, $module);
							self::$cms->args[1]='';
							unset($name); unset($filename); unset($bid1); unset($bid2);
						}
					}
				break;
			 case 'installzip':
				if (loadfile('filezip',self::$cms->zpath.'/module/', $name,$filename)) {
				  $ok=false;
					require_once(self::$cms->zpath.'/pclzip.lib.php');
				  $archive = new PclZip(self::$cms->zpath.'/module/'.$filename); $dest = self::$cms->ipath.'/';
		  		if ($archive->extract(PCLZIP_OPT_PATH, $dest, PCLZIP_OPT_REPLACE_NEWER) != 0) $ok=true;
					unset($archive);
					unlink(self::$cms->zpath.'/module/'.$filename);
					if ($ok) {
//						$name = str_ireplace('.zip','', preg_replace('@module-[0-9][0-9][0-9]-@is', '', $name));
						$name = preg_replace('@module-@i', '', $name);
						$name = preg_replace('@-[0-9]*$@', '', $name);
						$filename=$name.'.php';
					}
				}/* else {
					  $ok = loadfile('filephp',self::$cms->zpath.'/module/', $name,$filename) && loadfile('fileini',self::$cms->zpath.'/module/', $bid1, $bid2);
				}*/
				if ($ok) {
					if (isset($module[$filename])) {  // mise  jour si le fichier existe
					} else $module[$filename] = array($name, 0,array('admin'));
		 			self::$cms->writedata($file, $module);
					self::$cms->args[1]='';
					unset($name); unset($filename); unset($bid1); unset($bid2);
				}
				break;
			case 'del':
			 if (array_key_exists($_POST['modulename'],$module)) {
				$mo = Tmodule::create_module($module[$_POST['modulename']][cModulIdent]);
				if ($mo===true) {Tmodule::execute_module($module[$_POST['modulename']][cModulIdent],$mo,'Off');} elseif (is_object($mo)) {$mo->Off();}
				@unlink(self::$cms->zpath.'/module/'.$module[$_POST['modulename']][cModulIdent].'.php');
				@unlink(self::$cms->zpath.'/module/'.$module[$_POST['modulename']][cModulIdent].'.ini');
				unset($module[$_POST['modulename']]);
			 	self::$cms->writedata($file, $module);
				self::$cms->args[1]='';
			}
		}
		}
		if (self::$cms->args[1]!='') self::$cms->msgShow('done_failed');
	} elseif (isset($_POST['submit'])&&$isconfig) {  // on veut enregistrer les droits sur les modules
		  if (array_key_exists($_POST['modulename'],$module)) {
					if ($_POST['save']=='group'){
          	$module[$_POST['modulename']][cModulUse]=empty($_POST['group'])?array():explode(':',$_POST['group']);
					} elseif ($_POST['save']=='groupchg'){
						$module[$_POST['modulename']][cModulChg]=empty($_POST['group'])?array():explode(':',$_POST['group']);
						if (empty($module[$_POST['modulename']][cModulChg])) unset($module[$_POST['modulename']][cModulChg]);
					} else {
						$module[$_POST['modulename']][cModulCfg]=empty($_POST['group'])?array():explode(':',$_POST['group']);
						if (empty($module[$_POST['modulename']][cModulCfg])) unset($module[$_POST['modulename']][cModulCfg]);
					}
					self::$cms->writedata($file, $module);
			}
	}
	$show_listmodule = true;
							//
		if (isset(self::$cms->args[1])) switch (self::$cms->args[1]) {
			case 'config':
			  if (array_key_exists(self::$cms->args[2],$module)) {
					if (isset($_SERVER['HTTP_REFERER'])&&!stripos($_SERVER['HTTP_REFERER'],'selectmodule')) $_SESSION['url_return']=$_SERVER['HTTP_REFERER'];
					$mo = Tmodule::create_module($module[self::$cms->args[2]][cModulIdent]);
					$out2=$mo->Config();//v091
					if ($out2===true || empty($out2)) {
					  if (isset($_SESSION['url_return'])){
					    header('Location: '.$_SESSION['url_return']);
					    unset($_SESSION['url_return']);
					    exit;
						}
					} else if ($out2) return $out2;//.'</table></form>';
				}
				break;
		  case 'installzip' :  // Ajout module: depuis un fichier local
/*				$out .= '<tr><td>'.$this->get_message('filephp').'</td><td><input type="file" name="filephp" /></td></tr>';				$out .= '<tr><td>'.$this->get_message('fileini').'</td><td><input type="file" name="fileini" /></td></tr>';*/
				$out .= '<tr><td>'.$this->get_message('filezip').'</td><td><input type="file" name="filezip" /></td></tr>';
				$out .= '<tr><td colspan="2"><input type="submit" name="submit" value="'.$this->get_message('install').'" /> <input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr><tr><td colspan="2">'.$this->get_message('comment_new').'</td></tr></table><input name="m_save" type="hidden" value="installzip" /></form>';
		    break;
		  case 'installsite' :  // Ajout module: depuis le site officiel
				$zip='module-ctrl.txt';	//'module-092.txt';
				if (!ini_get('allow_url_fopen')) {
					function GetRemoteFileContent($url){
  					$curl = curl_init();  // Initialiser cURL.
					  curl_setopt($curl, CURLOPT_URL, $url);  // Indiquer quelle URL rcuprer
					  curl_setopt($curl, CURLOPT_HEADER, 0);  // Ne pas inclure l'header dans la rponse.
					  curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            $txt=curl_exec($curl);  // Excuter la requte.
  					curl_close($curl);  // Fermer cURL.
					  return $txt;
					}
					file_put_contents(self::$cms->cpath.'/ztemp/'.$zip,GetRemoteFileContent('http://www.giausserand.fr/view.php/ziteplus.zip?path='.$zip));
				} else copy('http://www.giausserand.fr/view.php/ziteplus.zip?path='.$zip,self::$cms->cpath.'/ztemp/'.$zip);
				// !!! ne pas tlcharger si fichier rcent: modif  faire
				$txt=file(self::$cms->cpath.'/ztemp/'.$zip);
				require_once(self::$cms->zpath.'/outils.php');
					// Dfinition constante module de controle
				define('cMctrlName',0);	define('cMctrlDesc',1); define('cMctrlHelp',2);	define('cMctrlVer',3); define('cMctrlVerMin',4); define('cMctrlVerMax',5); define('cMctrlType',6);
				$out2='';
				foreach($txt as $k => $desc) {
				  $prm=stringToArray($desc,';');
				  $prm[cMctrlDesc]=trim($prm[cMctrlDesc],'" ');
					if (empty($prm[cMctrlVerMin])) $prm[cMctrlVerMin]='092';
					if (empty($prm[cMctrlVerMax])) $prm[cMctrlVerMax]='999';
          if (($prm[cMctrlVerMin]<=self::$cms->version())and(self::$cms->version()<=$prm[cMctrlVerMax])) {
						$out2.="<div><input name='filezip' type='radio'  value=\"${prm[cMctrlName]}-".str_ireplace('.','',$prm[cMctrlVer])."\"/>${prm[cMctrlName]} - ${prm[cMctrlDesc]} - V${prm[cMctrlVer]} ".(empty($prm[cMctrlHelp])?'':"<a href=\"${prm[cMctrlHelp]}\"><img src='deco/help.png' alt='' style='vertical-align:bottom'/></a>")."</div>";  // Montrer les modules compatibles avec cette version
					}
				}
				$out .= '<tr><td colspan="2">'.$this->get_message('filefromsite').'</td><td>';
				$out .= '<tr><td  width="30px"></td><td>'.$out2.'</td></tr>';
				$out .= '<tr><td colspan="2">'.$this->get_message('filefromsitedesc').'</td></tr>';
				$out .= '<tr><td colspan="2"><input type="submit" name="submit" value="'.$this->get_message('install').'" /> <input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr><tr><td colspan="2">'.$this->get_message('comment_new').'</td></tr></table><input name="m_save" type="hidden" value="installsite" /></form>';
		    break;
			case 'actif':
			  if (array_key_exists(self::$cms->args[2],$module)) {
					$mo = Tmodule::create_module($module[self::$cms->args[2]][cModulIdent]);
					if ($mo===true) {
				    $module[self::$cms->args[2]][cModulOn] = ($module[self::$cms->args[2]][cModulOn]==0) ? 1 : 0;
						self::$cms->writedata($file, $module);
						Tmodule::execute_module($module[self::$cms->args[2]][cModulIdent],$mo,($module[self::$cms->args[2]][cModulOn] ? 'On' : 'Off'));
					}	else {
						($module[self::$cms->args[2]][cModulOn]==0) ? $mo->On(): $mo->Off();
						unset($mo);
					}
				}
				break;
			case 'del':
			  if (array_key_exists(self::$cms->args[2],$module)) {
					$out .= '<tr><td>'.$this->get_message('confirmdel').'<b>'.self::$cms->args[2].'</b> ?</td></tr>';
					$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.self::$cms->get_message('confirm').'" /><input name="m_save" type="hidden" value="del" /><input name="modulename" type="hidden" value="'.self::$cms->args[2].'" /></td></tr></table></form>';
			  }
			  break;
			case 'group':	case 'groupcfg': case 'groupchg':
			  if (array_key_exists(self::$cms->args[2],$module)) {
			  	$show_listmodule = false;
					$g = (empty(self::$cms->args[3])?array():explode(':', self::$cms->args[3]));
					if (in_array(self::$cms->args[4],$g)) {
					 	$g2[] = self::$cms->args[4];
           	$g = array_diff($g, $g2);
					}	else $g[]=self::$cms->args[4];
					$g1 = empty($g)?'':implode(':',$g);

					$out .= '<tr><td>'.$this->get_message(self::$cms->args[1]).'<b>'.self::$cms->args[2].'</b></td></tr>';
								// Afficher la liste de tous les groupes
					$f = self::$cms->group;  // copie du tableau des groupes
					uksort($f, create_function('$a, $b', 'return strcmp($a[0], $b[0]);'));
					$out .= '<tr><td><input type="submit" name="submit" value="'.self::$cms->get_message('submit').'" />
					<input name="save" type="hidden" value="'.self::$cms->args[1].'" />
					<input name="modulename" type="hidden" value="'.self::$cms->args[2].'" />
					<input name="group" type="hidden" value="'.$g1.'" /></td>
					<td><input type="submit" name="abort" value="'.self::$cms->get_message('abort').'" /></td></tr>';
					$out .= '<tr class="headcolor"><td>'.self::$cms->get_message('groupes_name').'</td><td>'.self::$cms->get_message('groupes_desc').'</td><td></td></tr>';
					$i=0;foreach ($f as $clef => $valeur	) {
						$out .= '<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'"><td>'.$clef.'</a></td><td>'.$valeur.'</td>';
						$out .= '<td><a href="'.self::$cms->base.'selectmodule|'.self::$cms->args[1].'|'.self::$cms->args[2].'|'.$g1.'|'.$clef.'"><img src="deco/k'.(self::$cms->args[1]=='group'?'r':(self::$cms->args[1]=='groupchg'?'w':'c')).(in_array($clef,$g)?'1': '0').'.png"/></a></td></tr>';
					}
				}
				break;
			}
			$out.='</table>';
			$out .= '</form>';
						// grer le formulaire de base: la liste des modules
			if ($show_listmodule) {
			  // ! si on trie $module, cela modifie aussi l'affichage cran du menu admin
//				uksort($module, create_function('$a, $b', 'return strcmp($a[0], $b[0]);'));//uasort
								// Afficher la liste de tous les modules
				$out .= '<table class="ztable">';
				$out .= '<tr class="headcolor"><td></td><td><b>'.$this->get_message('colname').'</td><td align=center><b>'.$this->get_message('colon').'</td><td align=center><b>'.$this->get_message('colgroupcfg').'</td><td align=center><b>'.$this->get_message('colgroupchg').'</td><td align=center><b>'.$this->get_message('colgroup').'</td><td></td></tr>';
				$i=0;foreach ($module as $clef => $valeur ) {
				  if (!isset($valeur[cModulCfg])) $valeur[cModulCfg]=array();
					$out.='<tr class="'.(++$i%2 ? 'oddcolor' : 'evencolor').'"><td align="center">'.(Tmodule::isConfig($valeur[cModulIdent])?'<a href="'.self::$cms->base.'selectmodule|config|'.$clef.'"><img src="deco/config.png"/></a>':'').'</td>';
					$out.='<td>'.$clef.'</td><td align=center>'.($isconfig?'<a href="'.self::$cms->base.'selectmodule|actif|'.$clef.'">':'').($valeur[cModulOn]?'<img src="deco/s1.png" />':'<img src="deco/s0.png" />').($isconfig?'</a>':'').'</td>';
					$out.='<td align=center>'.($isconfig?'<a href="'.self::$cms->base.'selectmodule|groupcfg|'.$clef.'|'.(empty($valeur[cModulCfg])?'':implode(':',$valeur[cModulCfg])).'">':'').'<img src="deco/kc'.(empty($valeur[cModulCfg])?'0': '1').'.png" title="'.(empty($valeur[cModulCfg])?'admin':implode(' ',array_unique(array_merge($valeur[cModulCfg],array('admin'))))).'"/>'.($isconfig?'</a>':'').'</td>';
					$out.='<td align=center>'.($isconfig?'<a href="'.self::$cms->base.'selectmodule|groupchg|'.$clef.'|'.(empty($valeur[cModulChg])?'':implode(':',$valeur[cModulChg])).'">':'').'<img src="deco/kw'.(empty($valeur[cModulChg])?'0': '1').'.png" title="'.(empty($valeur[cModulChg])?'admin':implode(' ',array_unique(array_merge($valeur[cModulChg],array('admin'))))).'"/>'.($isconfig?'</a>':'').'</td>';
					$out.='<td align=center>'.($isconfig?'<a href="'.self::$cms->base.'selectmodule|group|'.$clef.'|'.(empty($valeur[cModulUse])?'':implode(':',$valeur[cModulUse])).'">':'').'<img src="deco/kr'.($valeur[cModulUse]?'1': '0').'.png" title="'.($valeur[cModulUse]?implode(' ',$valeur[cModulUse]):$this->get_message('grpreadall')).'"/>'.($isconfig?'</a>':'').'</td>';
					$out.='<td align=center>'.($isconfig?'<a href="'.self::$cms->base.'selectmodule|del|'.$clef.'">':'').'<img src="deco/e1.png" /></a></td></tr>';
				}
				$out .= '</table>'.$this->get_message('comment');
			}
			return $out;
	}
}
?>