<?php
/*
module:	Cration du fichier sitemap.xml pour Google
Copyright Jean-Paul GIAUSSERAND 2008-2010
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
Historique:
	1.8 - enlever les pages commenant par _
	1.7 - Passage des messages dans le fichier ini
	1.6 - Passage partiel en code objet
	1.5 - Affichage du contenu du sitemap s'il existe
	      Les entrs de menu de type URL (redirection) ne sont plus gnres
	1.4 - Aprs gnration, affichage du sitemap avec sa date/heure
	1.3 - Modification pour grer le multiview
	1.2 - Ajout de la date de dernire modification de la page dans le sitemap.xml
	1.1 - Transformation en module
	1.0 - Intgration de la gestion des sitemap.xml dans zite+
*/
class Tsitemapxml extends Tmodule {
	function dojob($opt="") {
	  parent::dojob();
	if ($_POST['save']=='googlesitemap') { // gnration sitemapXML
		$out = '<?xml version="1.0" encoding="UTF-8"?'.'> ';
	  $out .= '<urlset xmlns="http://www.google.com/schemas/sitemap/0.84"> ';
		$base = self::$cms->rewrite ? '' : self::$cms->base;
		$max = count(self::$cms->struct);
		for ($i=1; $i<=$max; $i++) {
			if (1==1) { //($zite->isPageAuth($i,cPageWrite)) { // il faut tenir compte des droit de l'utilisateur de base
				$s = self::$cms->struct[$i];
				if ($s[cPageOn] && (($s[cPageType]&pgbitType)!=5)&&($s[cPageIdent][0]!='_')) {
			 		$out .= '<url> ';
		  		$out .= '<loc>'.str_replace($_SERVER["REQUEST_URI"],'/',$_SERVER["HTTP_REFERER"]).(self::$cms->rewrite ? (self::$cms->rewrite===2?self::$cms->config['files_index']:'').$s[0].'.html' : 'index.php?perma='.$s[0]).'</loc>';
//		  		$out .= '<loc>'.str_replace($_SERVER["REQUEST_URI"],'/',$_SERVER["HTTP_REFERER"]).($zite->rewrite ? $s[0].'.html' : 'index.php?perma='.$s[0]).'</loc>';
		  		$out .= '<lastmod>'.date("Y-m-d", filemtime(self::$cms->cpath.'/'.self::$cms->struct[$i][cPageIdent].'.txt')).'</lastmod>';
	//  		$out .= '<changefreq>weekly</changefreq>';
	//  		$out .= '<priority>0.8</priority>';
					$out .= '</url>';
  	    }
			}
		}
  	$out .= '</urlset>';
  	self::$cms->writefile(self::$cms->ipath.'/sitemap.xml',$out)?self::$cms->msgShow('done_ok'):self::$cms->msgShow('done_failed');
		$out = '';
	}
	$out .= '<form method="post" action="'.self::$cms->base.'module|sitemapxml" enctype="multipart/form-data"><table class="ztable">';
	$out .= '<tr><td colspan="2"><center><strong>'.$this->get_message('title').'</strong></center></td></tr>';
	$out .= '<tr><td>'.$this->get_message('desc').'</td></tr>';
	$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.self::$cms->get_message('submit').'" /><input name="save" type="hidden" value="googlesitemap" /></td></tr></table></form>';
	if (file_exists(self::$cms->ipath.'/sitemap.xml')) {
	  $out .= '<table class="ztable">';
	  $out .= '<tr><td>'.$this->get_message('filedate').date("d/m/Y  H:m:s", filemtime(self::$cms->ipath.'/sitemap.xml')).'</td></tr>';
		$out .= '<tr><td><textarea rows=30 cols=70 wrap=off readonly>'.str_replace('<url',"\n<url",file_get_contents(self::$cms->ipath.'/sitemap.xml')).' </textarea></td></tr>';
	  $out .= '</table>';
	}
	return $out;
}
}
?>
