<?php
	/* V1.0 - 26/10/2009 - Visualisation d'images ou de document */
	if (session_id()=='') session_start();
	$ipath = dirname($_SERVER['SCRIPT_FILENAME']);
	$cpath = $ipath.'/zdata';
	$dpath = $cpath.'/zdocs';
	$zpath = $ipath.'/zplus';
	$docname=str_replace('/','',(empty($_SERVER['PATH_INFO'])?$_SERVER['ORIG_PATH_INFO']:$_SERVER['PATH_INFO']));
	if (isset($docname)) {
		require_once($zpath.'/tdocs.php');
		$docs = new Tdocs($cpath.'/docs.dta');
		$docname=rawurldecode($docname);
		if ($docs->isDocAuth($docname)) { // Vrification des droits (et aussi existence)
			$doc = $docs[$docname];
      @ob_end_clean();
			if (isset($_SERVER['HTTP_IF_NONE_MATCH']) && ($_SERVER['HTTP_IF_NONE_MATCH']==filemtime($dpath.'/thumbs/'.$doc[cDocFilename])) ) {
				header("HTTP/1.0 304 Not Modified");
			} else {
				$contenttype= isset($mimetype[$doc[cDocExt]])?$mimetype[$doc[cDocExt]]:'text/plain';
				header('Content-Type: '.$contenttype);
 	    	header('Content-Disposition: inline; filename="'.$doc[cDocFilename].'"');
				header('Content-Length: '.filesize($dpath.'/thumbs/'.$doc[cDocFilename]));
				header('Cache-Control: ');//max-age=30000');
				header('ETag: '.filemtime($dpath.'/thumbs/'.$doc[cDocFilename]));
				header('Pragma: ');
				header('Date: '.date("r",filemtime($dpath.'/thumbs/'.$doc[cDocFilename])));
 	    	header('Expires: ');//.date("r",time()+3000000));
				header('Last-modified: '.date("r",filemtime($dpath.'/thumbs/'.$doc[cDocFilename])));
      	@ob_flush();
				readfile($dpath.'/thumbs/'.$doc[cDocFilename]);
			}
		}
	}
?>