<?php
/*
Classe: Gestion des rubriques
Copyright Jean-Paul GIAUSSERAND 2010
Site: http://www.giausserand.fr/index.php?perma=ziteplus
Licence : CeCILL-B, http://www.cecill.info
	v1.0: Cration de la classe
*/
// index du tableau = nom unique de la rubrique
define('cRubDesc',0);     // Description de la rubrique
define('cRubWrite',1);		// Droits de remplacer/supprimer attachs  la rubrique
define('cRubRead',2);			// Droits de lecture attachs  la rubrique
//
class Trubs implements Countable,Iterator {
 	protected $filename;
	protected $rubs;
		//
	protected $krub=false;  // lments en cours
//
	function __construct($file) {
		$this->filename = $file;
		$this->rubs=false;
	}
	protected function init() {
	  if ($this->rubs===false) $this->refresh();
	}
	protected function _init(){
		$this->krub=false;
		$this->rewind();
	}
	function refresh() {
	  if (file_exists($this->filename)) {
    	$this->rubs=unserialize(@file_get_contents($this->filename));
		} else $this->rubs=array();
	  $this->_init();
	}
	function isRub($ident) {
		$this->init();
		if (empty($ident) || !array_key_exists($ident,$this->rubs)) {
		  return false;
		} else return true;
	}
	function getValues($index, $val) {
	  $this->init();
		return $this->rubs[$index][$val];
	}
	/*Interface Coutable*/
	public function count() {
	  $this->init();
	  return count($this->rubs);
	}
	/*Interface Iterator*/
	public function rewind(){	$this->init(); $this->krub=reset($this->rubs);	}
	public function current(){ $this->init(); return $this->krub;	}
	public function key(){ $this->init();	  return key($this->rubs);	}
	public function next(){	$this->init();  $this->krub=next($this->rubs);	}
	public function valid() { $this->init();  return ($this->krub!==false);	}
}
?>
